# SparseConnectivityTracer.jl
|               |                                                                     | 
|:--------------|:--------------------------------------------------------------------|
| Documentation | [![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://adrhill.github.io/SparseConnectivityTracer.jl/stable/) [![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://adrhill.github.io/SparseConnectivityTracer.jl/dev/) [![Changelog](https://img.shields.io/badge/news-changelog-yellow.svg)](https://github.com/adrhill/SparseConnectivityTracer.jl/blob/main/CHANGELOG.md) |
| Build Status  | [![Build Status](https://github.com/adrhill/SparseConnectivityTracer.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/adrhill/SparseConnectivityTracer.jl/actions/workflows/CI.yml?query=branch%3Amain) [![Coverage](https://codecov.io/gh/adrhill/SparseConnectivityTracer.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/adrhill/SparseConnectivityTracer.jl) [![Aqua](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl) [![JET](https://img.shields.io/badge/%F0%9F%9B%A9%EF%B8%8F_tested_with-JET.jl-233f9a.svg)](https://github.com/aviatesk/JET.jl) |
| Code Style    | [![Code Style: Runic](https://img.shields.io/badge/code_style-%E1%9A%B1%E1%9A%A2%E1%9A%BE%E1%9B%81%E1%9A%B2-black)](https://github.com/fredrikekre/Runic.jl) [![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac) | 
| Downloads     | [![Downloads](https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FSparseConnectivityTracer&query=total_requests&suffix=%2Fmonth&label=Downloads)](http://juliapkgstats.com/pkg/SparseConnectivityTracer) [![Dependents](https://juliahub.com/docs/General/SparseConnectivityTracer/stable/deps.svg)](https://juliahub.com/ui/Packages/General/SparseConnectivityTracer?t=2) |
| Citation      | [![arXiv DOI](https://img.shields.io/badge/DOI-10.48550/arXiv.2501.17737-red)](https://arxiv.org/abs/2501.17737) [![Zenodo DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.13138554.svg)](https://zenodo.org/doi/10.5281/zenodo.13138554) |

Fast Jacobian and Hessian sparsity pattern detection via operator-overloading.

> [!TIP]
> If you want to use [automatic sparse differentiation](https://iclr-blogposts.github.io/2025/blog/sparse-autodiff/) to compute sparse Jacobians or Hessians with SparseConnectivityTracer (instead of just sparsity patterns), 
> refer to the [DifferentiationInterface.jl documentation](https://juliadiff.org/DifferentiationInterface.jl/DifferentiationInterface/stable/tutorials/advanced/#Sparsity).

## Installation 
To install this package, open the Julia REPL and run 

```julia-repl
julia> ]add SparseConnectivityTracer
```

## Examples
### Jacobian

For functions `y = f(x)` and `f!(y, x)`, the sparsity pattern of the Jacobian can be obtained
by computing a single forward-pass through the function:

```julia-repl
julia> using SparseConnectivityTracer

julia> detector = TracerSparsityDetector();

julia> x = rand(3);

julia> f(x) = [x[1]^2, 2 * x[1] * x[2]^2, sin(x[3])];

julia> jacobian_sparsity(f, x, detector)
3×3 SparseArrays.SparseMatrixCSC{Bool, Int64} with 4 stored entries:
 1  ⋅  ⋅
 1  1  ⋅
 ⋅  ⋅  1
```

By default, `BitSet` is used for internal sparsity pattern representations.
For very large inputs, it might be more efficient to set the type to `Set{UInt}`:

```julia-repl
julia> detector = TracerSparsityDetector(; gradient_pattern_type=Set{UInt})
```

### Hessian

For scalar functions `y = f(x)`, the sparsity pattern of the Hessian can be obtained
by computing a single forward-pass through the function:

```julia-repl
julia> x = rand(4);

julia> f(x) = x[1] + x[2]*x[3] + 1/x[4];

julia> hessian_sparsity(f, x, detector)
4×4 SparseArrays.SparseMatrixCSC{Bool, Int64} with 3 stored entries:
 ⋅  ⋅  ⋅  ⋅
 ⋅  ⋅  1  ⋅
 ⋅  1  ⋅  ⋅
 ⋅  ⋅  ⋅  1
```

By default, dictionaries of `BitSet`s are used for internal sparsity pattern representations.
For very large inputs, it might be more efficient to set the type to `Dict{UInt, Set{UInt}}`:

```julia-repl
julia> detector = TracerSparsityDetector(; hessian_pattern_type=Dict{UInt, Set{UInt}})
```

For more detailed examples, take a look at the [documentation](https://adrianhill.de/SparseConnectivityTracer.jl/stable).

### Local tracing

`TracerSparsityDetector` returns conservative "global" sparsity patterns over the entire input domain of `x`. 
It is not compatible with functions that require information about the primal values of a computation (e.g. `iszero`, `>`, `==`).
To compute a less conservative Jacobian or Hessian sparsity pattern at an input point `x`, use `TracerLocalSparsityDetector` instead.
Note that patterns computed with `TracerLocalSparsityDetector` depend on the input `x` and have to be recomputed when `x` changes:

```julia-repl
julia> using SparseConnectivityTracer

julia> detector = TracerLocalSparsityDetector();

julia> f(x) = x[1] > x[2] ? x[1] : x[2];

julia> jacobian_sparsity(f, [1 2], detector)
1×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 1 stored entry:
 ⋅  1

julia> jacobian_sparsity(f, [2 1], detector)
1×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 1 stored entry:
 1  ⋅
```

Take a look at the documentation for [more information on global and local patterns](https://adrianhill.de/SparseConnectivityTracer.jl/stable/user/global_vs_local/).

## ADTypes.jl compatibility
SparseConnectivityTracer uses [ADTypes.jl](https://github.com/SciML/ADTypes.jl)'s interface for [sparsity detection](https://sciml.github.io/ADTypes.jl/stable/#Sparsity-detector),
making it compatible with [DifferentiationInterface.jl](https://github.com/gdalle/DifferentiationInterface.jl)'s [sparse automatic differentiation](https://juliadiff.org/DifferentiationInterface.jl/DifferentiationInterface/stable/tutorials/advanced/#Sparsity) functionality.
In fact, the functions `jacobian_sparsity` and `hessian_sparsity` are re-exported from ADTypes.

## Related packages
* [SparseDiffTools.jl](https://github.com/JuliaDiff/SparseDiffTools.jl): automatic sparsity detection via Symbolics.jl and Cassette.jl
* [SparsityTracing.jl](https://github.com/PALEOtoolkit/SparsityTracing.jl): automatic Jacobian sparsity detection using an algorithm based on SparsLinC by Bischof et al. (1996)

## Citation

If you use SparseConnectivityTracer in your research, please cite our TMLR paper [*Sparser, Better, Faster, Stronger: Efficient Automatic Differentiation for Sparse Jacobians and Hessians*](https://openreview.net/forum?id=GtXSN52nIW):

```bibtex
@article{hill2025sparser,
  title={Sparser, Better, Faster, Stronger: Sparsity Detection for Efficient Automatic Differentiation},
  author={Adrian Hill and Guillaume Dalle},
  journal={Transactions on Machine Learning Research},
  issn={2835-8856},
  year={2025},
  url={https://openreview.net/forum?id=GtXSN52nIW},
  note={}
}
```

## Acknowledgements

Adrian Hill gratefully acknowledges funding from the German Federal Ministry of Education and Research under the grant BIFOLD25B.

# Test construction and conversions of internal tracer types
using SparseConnectivityTracer: AbstractTracer, GradientTracer, HessianTracer, Dual
using SparseConnectivityTracer: primal, tracer, isemptytracer, myempty
using Test

# Load definitions of GRADIENT_TRACERS and HESSIAN_TRACERS
include("tracers_definitions.jl")

# Pretty-printing of Dual tracers
tracer_name(::Type{T}) where {T <: GradientTracer} = "GradientTracer"
tracer_name(::Type{T}) where {T <: HessianTracer} = "HessianTracer"
tracer_name(::Type{D}) where {P, T, D <: Dual{P, T}} = "Dual-$(tracer_name(T))"

function test_nested_duals(::Type{T}) where {T <: AbstractTracer}
    # Putting Duals into Duals is prohibited
    t = myempty(T)
    D1 = Dual(1.0, t)
    return @test_throws ErrorException D2 = Dual(D1, t)
end

function test_constant_functions(::Type{T}) where {T <: AbstractTracer}
    return @testset "$f" for f in (
            zero, one, oneunit, typemin, typemax, eps, floatmin, floatmax, maxintfloat,
        )
        t = f(T)
        @test isa(t, T)
        @test isemptytracer(t)
    end
end

function test_constant_functions(::Type{D}) where {P, T, D <: Dual{P, T}}
    return @testset "$f" for f in (
            zero, one, oneunit, typemin, typemax, eps, floatmin, floatmax, maxintfloat,
        )
        out = f(D)
        @test out isa D
    end
end

function test_type_conversion_functions(::Type{T}) where {T}
    return @testset "$f" for f in (big, widen, float)
        test_type_conversion_functions(T, f)
    end
end
function test_type_conversion_functions(::Type{T}, f::Function) where {T <: AbstractTracer}
    return @test f(T) == T
end
function test_type_conversion_functions(::Type{D}, f::Function) where {P, T, D <: Dual{P, T}}
    return @testset "Primal type $P_IN" for P_IN in (Int, Float32, Irrational)
        P_OUT = f(P_IN)
        @test f(Dual{P_IN, T}) == Dual{P_OUT, T}
    end
end

function test_type_casting(::Type{T}) where {T <: AbstractTracer}
    t_in = myempty(T)
    @testset "$T to $T" begin
        t_out = T(t_in)
        @test t_out isa T
        @test isemptytracer(t_out)
    end
    return @testset "$N to $T" for N in (Int, Float32, Irrational)
        t_out = T(one(N))
        @test t_out isa T
        @test isemptytracer(t_out)
    end
end

function test_type_casting(::Type{D}) where {P, T, D <: Dual{P, T}}
    d_in = Dual(one(P), myempty(T))
    @testset "$(tracer_name(D)) to $(tracer_name(D))" begin
        d_out = D(d_in)
        @test primal(d_out) == primal(d_in)
        @test tracer(d_out) isa T
        @test isemptytracer(d_out)
    end
    return @testset "$P2 to $(tracer_name(D))" for P2 in (Int, Float32, Irrational)
        p_in = one(P2)
        d_out = D(p_in)
        @test primal(d_out) == P(p_in)
        @test tracer(d_out) isa T
        @test isemptytracer(d_out)
    end
end

function test_similar(::Type{T}) where {T <: AbstractTracer}
    A = rand(Int, 2, 3)

    # 2-arg from matrix of Reals
    B = similar(A, T)
    @test eltype(B) == T
    @test size(B) == (2, 3)

    # 1-arg from matrix of tracers
    B1 = similar(B)
    @test eltype(B1) == T
    @test size(B1) == (2, 3)

    # 2-arg from matrix of tracers
    B2 = similar(B, T)
    @test eltype(B2) == T
    @test size(B2) == (2, 3)

    # 2-arg from matrix of tracers, custom size
    B3 = similar(B, 4, 5)
    @test eltype(B3) == T
    @test size(B3) == (4, 5)

    # 3-arg from matrix of Reals
    B4 = similar(A, T, 4, 5)
    @test eltype(B4) == T
    @test size(B4) == (4, 5)

    # 3-arg from matrix of tracers
    B5 = similar(B, T, 5, 6)
    @test eltype(B5) == T
    return @test size(B5) == (5, 6)
end

function test_similar(::Type{D}) where {P, T, D <: Dual{P, T}}
    # Test `similar`
    P2 = Float16   # using something different than P
    @test P2 != P # this is important for following tests

    A = rand(P2, 2, 3)

    # 2-arg from matrix of Reals P2
    B = similar(A, D)
    @test eltype(B) == D
    @test size(B) == (2, 3)

    # 1-arg from matrix of tracers
    B1 = similar(B)
    @test eltype(B1) == D
    @test size(B1) == (2, 3)

    # 2-arg from matrix of tracers
    B2 = similar(B, D)
    @test eltype(B2) == D
    @test size(B2) == (2, 3)

    # 2-arg from matrix of tracers, custom size
    B3 = similar(B, 4, 5)
    @test eltype(B3) == D
    @test size(B3) == (4, 5)

    # 3-arg from matrix of Reals
    B4 = similar(A, D, 4, 5)
    @test eltype(B4) == D
    @test size(B4) == (4, 5)

    # 3-arg from matrix of tracers
    B5 = similar(B, D, 5, 6)
    @test eltype(B5) == D
    return @test size(B5) == (5, 6)
end

@testset "GradientTracer" begin
    P = Float32
    DUAL_GRADIENT_TRACERS = [Dual{P, T} for T in GRADIENT_TRACERS]
    ALL_GRADIENT_TRACERS = (GRADIENT_TRACERS..., DUAL_GRADIENT_TRACERS...)

    @testset "Nested Duals on HessianTracer" for T in GRADIENT_TRACERS
        test_nested_duals(T)
    end
    @testset "Constant functions on $T" for T in ALL_GRADIENT_TRACERS
        test_constant_functions(T)
    end
    @testset "Type conversions on $T" for T in ALL_GRADIENT_TRACERS
        test_type_conversion_functions(T)
    end
    @testset "Type casting on $T" for T in ALL_GRADIENT_TRACERS
        test_type_casting(T)
    end
    @testset "similar on $T" for T in ALL_GRADIENT_TRACERS
        test_similar(T)
    end
end

@testset "HessianTracer" begin
    P = Float32
    DUAL_HESSIAN_TRACERS = [Dual{P, T} for T in HESSIAN_TRACERS]
    ALL_HESSIAN_TRACERS = (HESSIAN_TRACERS..., DUAL_HESSIAN_TRACERS...)

    @testset "Nested Duals on HessianTracer" for T in HESSIAN_TRACERS
        test_nested_duals(T)
    end
    @testset "Constant functions on $T" for T in ALL_HESSIAN_TRACERS
        test_constant_functions(T)
    end
    @testset "Type conversions on $T" for T in ALL_HESSIAN_TRACERS
        test_type_conversion_functions(T)
    end
    @testset "Type casting on $T" for T in ALL_HESSIAN_TRACERS
        test_type_casting(T)
    end
    @testset "similar on $T" for T in ALL_HESSIAN_TRACERS
        test_similar(T)
    end
end

@testset "Explicit type conversions on Dual" begin
    T = DEFAULT_GRADIENT_TRACER
    t_full = T(BitSet(2))
    t_empty = myempty(T)
    d_full = Dual(1.0, t_full)
    d_empty = Dual(1.0, t_empty)

    @testset "Non-empty tracer" begin
        @testset "$TOUT" for TOUT in (Int, Integer, Float64, Float32)
            @test_throws InexactError TOUT(d_full)
        end
    end
    @testset "Empty tracer" begin
        @testset "$TOUT" for TOUT in (Int, Integer, Float64, Float32)
            out = TOUT(d_empty)
            @test out isa TOUT # not a Dual!
            @test isone(out)
        end
    end
    @testset "Conversions of Reals to Dual" begin
        @testset "$P_out" for P_out in (Float16, Float64, Float32)
            @testset "$P_in" for P_in in (Int, Float64, Float32)
                x = oneunit(P_in)
                D = Dual{P_out, T}
                d = convert(D, x)
                @test primal(d) isa P_out
            end
        end
    end
end

using SparseConnectivityTracer
using ChainRulesCore: ignore_derivatives
using LinearAlgebra
using Test

@testset "$detector" for detector in (TracerSparsityDetector(), TracerLocalSparsityDetector())
    @testset "Jacobian Scalar" begin
        J = jacobian_sparsity(ignore_derivatives, 1, detector)
        @test J == [0;;]
    end
    @testset "Jacobian Array" begin
        J = jacobian_sparsity(ignore_derivatives, [1, 2], detector)
        @test J == [0 0; 0 0]
    end
    @testset "Hessian Scalar" begin
        H = hessian_sparsity(x -> ignore_derivatives(x^2), 1, detector)
        @test H == [0;;]
        H = hessian_sparsity(x -> ignore_derivatives(x)^2, 1, detector)
        @test H == [0;;]
    end
    @testset "Hessian Array" begin
        H = hessian_sparsity(x -> logdet(ignore_derivatives(x)), [1.0 0.0; 0.0 1.0], detector)
        @test H == zeros(Bool, 4, 4)
    end

end

using BenchmarkTools
using SparseConnectivityTracer
using SparseConnectivityTracerBenchmarks.ODE: Brusselator!, brusselator_2d_loop!

using Random: MersenneTwister
using SparseArrays: sprand
using SimpleDiffEq: ODEProblem, solve, SimpleEuler
using Flux: Conv

function jacbench(detector)
    suite = BenchmarkGroup()
    suite["SparseMul"] = jacbench_sparsemul(detector)
    suite["Brusselator"] = jacbench_brusselator(detector)
    suite["Conv"] = jacbench_conv(detector)
    return suite
end

## Iterated sparse mul

struct IteratedSparseMul{M <: AbstractMatrix}
    As::Vector{M}
end

function IteratedSparseMul(; n::Integer, p::Real = 0.1, depth::Integer = 5)
    As = [sprand(MersenneTwister(123 + i), n, n, p) for i in 1:depth]
    return IteratedSparseMul(As)
end

function (ism::IteratedSparseMul)(x::AbstractVector)
    @assert length(x) == size(ism.As[1], 1)
    y = copy(x)
    for l in eachindex(ism.As)
        y = ism.As[l] * y
    end
    return y
end

function jacbench_sparsemul(detector)
    suite = BenchmarkGroup()
    for n in [50], p in [0.01, 0.25], depth in [5]
        x = rand(n)
        f = IteratedSparseMul(; n, p, depth)
        suite["n=$n, p=$p, depth=$depth"] = @benchmarkable jacobian_sparsity(
            $f, $x, $detector
        )
    end
    return suite
end

## Brusselator

function jacbench_brusselator(detector)
    suite = BenchmarkGroup()
    for N in (6, 24)
        f! = Brusselator!(N)
        x = rand(N, N, 2)
        y = similar(x)
        suite["operator"]["N=$N"] = @benchmarkable jacobian_sparsity($f!, $y, $x, $detector)
        solver = SimpleEuler()
        prob = ODEProblem(brusselator_2d_loop!, x, (0.0, 1.0), f!.params)
        function brusselator_ode_solve(x)
            return solve(ODEProblem(brusselator_2d_loop!, x, (0.0, 1.0), f!.params), solver; dt = 0.5).u[end]
        end
        suite["ODE"]["N=$N"] = @benchmarkable jacobian_sparsity(
            $brusselator_ode_solve, $x, $detector
        )
    end
    return suite
end

## Convolution

function jacbench_conv(detector)
    # TODO: benchmark local sparsity tracers on LeNet-5 CNN
    layer = Conv((5, 5), 3 => 2)
    suite = BenchmarkGroup()
    for N in (28, 128)
        suite["N=$N"] = @benchmarkable jacobian_sparsity(
            $layer, $(rand(N, N, 3, 1)), $detector
        )
    end
    return suite
end

import SparseConnectivityTracer as SCT
using SparseConnectivityTracer
using SparseConnectivityTracer:
    GradientTracer,
    Dual,
    isemptytracer,
    MissingPrimalError,
    split_dual_array,
    tracer
using Test

using LinearAlgebra: Symmetric, Diagonal, diagind
using LinearAlgebra: det, logdet, logabsdet, norm, opnorm
using LinearAlgebra: eigen, eigmax, eigmin
using LinearAlgebra: cholesky, NoPivot, RowMaximum
using LinearAlgebra: inv, pinv, dot
using SparseArrays: sparse, spdiagm

S = BitSet
TG = GradientTracer{eltype(S), S}

# Utilities for quick testing
idx2set(is) = S(is)
idx2set(r::AbstractRange) = idx2set(collect(r))
idx2tracer(is) = TG(idx2set(is))

function sameidx(s1::AbstractSet, s2::AbstractSet)
    same = s1 == s2
    if same
        return true
    else
        println("Index sets don't match:")
        println("Detected:  ", s1)
        println("Reference: ", s2)
        return false
    end
end

function sameidx(t1::T, t2::T) where {T <: GradientTracer}
    return sameidx(SCT.gradient(t1), SCT.gradient(t2))
end
sameidx(t::GradientTracer, s::AbstractSet) = sameidx(SCT.gradient(t), s)
sameidx(t::GradientTracer, i) = sameidx(t, idx2set(i))

#=========================#
# Weird function wrappers #
#=========================#

# These print better stack traces than lambda functions.

struct SparsifyInput{F}
    f::F
end
(s::SparsifyInput)(x) = s.f(sparse(x))

struct SpdiagmifyInput{F}
    f::F
end
(s::SpdiagmifyInput)(x) = s.f(spdiagm(x))

struct SumOutputs{F}
    f::F
end
(s::SumOutputs)(x) = sum(s.f(x))

norm1(A) = norm(A, 1)
norm2(A) = norm(A, 2)
norminf(A) = norm(A, Inf)
opnorm1(A) = opnorm(A, 1)
opnorm2(A) = opnorm(A, 2)
opnorminf(A) = opnorm(A, Inf)
logabsdet_first(A) = first(logabsdet(A))
logabsdet_last(A) = last(logabsdet(A))
pow0(A) = A^0
pow3(A) = A^3

#===================#
# Testing utilities #
#===================#

detector = TracerSparsityDetector()

allone(A) = all(isone, A)
allzero(A) = all(iszero, A)

# Short-hand for Jacobian pattern of `x -> sum(f(A))`
Jsum(f, A) = jacobian_sparsity(SumOutputs(f), A, detector)
# Test whether all entries in Jacobian are zero
testJ0(f, A) = @testset "Jacobian" begin
    @test allzero(Jsum(f, A))
end
# Test whether all entries in Jacobian are one where inputs were non-zero.
testJ1(f, A) = @testset "Jacobian" begin
    @test allone(Jsum(f, A))
end
function testJ1(f, A::Diagonal)
    return @testset "Jacobian" begin
        jac = Jsum(f, A)
        di = diagind(A)
        for (i, x) in enumerate(jac)
            if i in di
                @test isone(x)
            else
                @test iszero(x)
            end
        end
    end
end

# Short-hand for Hessian pattern of `x -> sum(f(A))`
Hsum(f, A) = hessian_sparsity(SumOutputs(f), A, detector)
# Test whether all entries in Hessian are zero
testH0(f, A) = @testset "Hessian" begin
    @test allzero(Hsum(f, A))
end
# Test whether all entries in Hessian are one where inputs were non-zero.
testH1(f, A) = @testset "Hessian" begin
    @test allone(Hsum(f, A))
end
function testH1(f, A::Diagonal)
    return @testset "Hessian" begin
        hess = Hsum(f, A)
        di = diagind(A)

        for I in CartesianIndices(A)
            i, j = Tuple(I)
            x = hess[I]

            if i in di && j in di
                @test isone(x)
            else
                @test iszero(x)
            end
        end
    end
end

#===================#
# Arrays to test on #
#===================#

mat33 = rand(3, 3)
mat34 = rand(3, 4)
sym33 = Symmetric(rand(3, 3))
dia33 = Diagonal(rand(3))

ALL_MATRICES = (mat33, mat34, sym33, dia33)
SQUARE_MATRICES = (mat33, sym33, dia33)
NONDIAG_MATRICES = (mat33, mat34, sym33)
NONDIAG_SQUARE_MATRICES = (mat33, sym33)
DIAG_MATRICES = (dia33,)
DIAG_SQUARE_MATRICES = (dia33,)

arrayname(A) = "$(typeof(A)) $(size(A))"

#=================#
# TEST START HERE #
#=================#

@testset "Scalar functions" begin
    @testset "det $(arrayname(A))" for A in NONDIAG_MATRICES
        testJ1(det, A)
        testH1(det, A)
    end
    @testset "det $(arrayname(A))" for A in DIAG_MATRICES
        @test Jsum(det, A) == [1 0 0 0 1 0 0 0 1;]
        @test Hsum(det, A) == [
            0  0  0  0  1  0  0  0  1
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            1  0  0  0  0  0  0  0  1
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            1  0  0  0  1  0  0  0  0
        ]
    end
    @testset "logdet $(arrayname(A))" for A in ALL_MATRICES
        testJ1(logdet, A)
        testH1(logdet, A)
    end
    @testset "norm(A, 1) $(arrayname(A))" for A in ALL_MATRICES
        testJ1(norm1, A)
        testH0(norm1, A)
    end
    @testset "norm(A, 2) $(arrayname(A))" for A in ALL_MATRICES
        testJ1(norm2, A)
        testH1(norm2, A)
    end
    @testset "norm(A, Inf) $(arrayname(A))" for A in ALL_MATRICES
        testJ1(norminf, A)
        testH0(norminf, A)
    end
    @testset "eigmax $(arrayname(A))" for A in ALL_MATRICES
        testJ1(eigmax, A)
        testH1(eigmax, A)
    end
    @testset "eigmin $(arrayname(A))" for A in ALL_MATRICES
        testJ1(eigmin, A)
        testH1(eigmin, A)
    end
    @testset "opnorm(A, 1) $(arrayname(A))" for A in ALL_MATRICES
        testJ1(opnorm1, A)
        testH0(opnorm1, A)
    end
    @testset "opnorm(A, 2) $(arrayname(A))" for A in NONDIAG_MATRICES
        # On diagonal matrices, opnorm(A, 2) returns the highest diagonal entry
        # since the spectral norm is equal to the largest singular value of A.
        # For diagonal matrices, the Hessian pattern is therefore "empty".
        testJ1(opnorm2, A)
        testH1(opnorm2, A)
    end
    @testset "opnorm(A, Inf) $(arrayname(A))" for A in ALL_MATRICES
        testJ1(opnorminf, A)
        testH0(opnorminf, A)
    end
    @testset "first(logabsdet(A)) $(arrayname(A))" for A in ALL_MATRICES
        testJ1(logabsdet_first, A)
        testH1(logabsdet_first, A)
    end
    @testset "last(logabsdet(A)) $(arrayname(A))" for A in ALL_MATRICES
        testJ0(logabsdet_last, A)
        testH0(logabsdet_last, A)
    end

    @testset "`SparseMatrixCSC` (3×3)" begin
        A = rand(3, 3)
        v = rand(3)

        # TODO: this is a temporary solution until sparse matrix inputs are supported (#28)
        @testset "det" begin
            testJ1(SparsifyInput(det), A)
            testH1(SparsifyInput(det), A)
            testJ1(SpdiagmifyInput(det), v)
            testH1(SpdiagmifyInput(det), v)
        end
        @testset "logdet" begin
            testJ1(SparsifyInput(logdet), A)
            testH1(SparsifyInput(logdet), A)
            testJ1(SpdiagmifyInput(logdet), v)
            testH1(SpdiagmifyInput(logdet), v)
        end
        @testset "norm" begin
            testJ1(SparsifyInput(norm), A)
            testH1(SparsifyInput(norm), A)
            testJ1(SpdiagmifyInput(norm), v)
            testH1(SpdiagmifyInput(norm), v)
        end
        @testset "eigmax" begin
            testJ1(SparsifyInput(eigmax), A)
            testH1(SparsifyInput(eigmax), A)
            testJ1(SpdiagmifyInput(eigmax), v)
            testH1(SpdiagmifyInput(eigmax), v)
        end
        @testset "eigmin" begin
            testJ1(SparsifyInput(eigmin), A)
            testH1(SparsifyInput(eigmin), A)
            testJ1(SpdiagmifyInput(eigmin), v)
            testH1(SpdiagmifyInput(eigmin), v)
        end
        @testset "opnorm(x, 1)" begin
            testJ1(SparsifyInput(opnorm1), A)
            testH0(SparsifyInput(opnorm1), A)
            testJ1(SpdiagmifyInput(opnorm1), v)
            testH0(SpdiagmifyInput(opnorm1), v)
        end
        @testset "first(logabsdet(x))" begin
            testJ1(SparsifyInput(logabsdet_first), A)
            testH1(SparsifyInput(logabsdet_first), A)
            testJ1(SpdiagmifyInput(logabsdet_first), v)
            testH1(SpdiagmifyInput(logabsdet_first), v)
        end
        @testset "last(logabsdet(x))" begin
            testJ0(SparsifyInput(logabsdet_last), A)
            testH0(SparsifyInput(logabsdet_last), A)
            testJ0(SpdiagmifyInput(logabsdet_last), v)
            testH0(SpdiagmifyInput(logabsdet_last), v)
        end
    end
end

@testset "Matrix-valued functions" begin
    # Functions that only work on square matrices
    @testset "inv $(arrayname(A))" for A in NONDIAG_SQUARE_MATRICES
        testJ1(inv, A)
        testH1(inv, A)
    end
    @testset "inv $(arrayname(A))" for A in DIAG_SQUARE_MATRICES
        @test Hsum(inv, A) == [
            1  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  1  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  1
        ]
    end
    @testset "exp $(arrayname(A))" for A in NONDIAG_SQUARE_MATRICES
        testJ1(exp, A)
        testH1(exp, A)
    end
    @testset "exp $(arrayname(A))" for A in DIAG_SQUARE_MATRICES
        testJ1(exp, A)
        @test Hsum(exp, A) == [
            1  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  1  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  0
            0  0  0  0  0  0  0  0  1
        ]
    end
    @testset "pow0 $(arrayname(A))" for A in SQUARE_MATRICES
        testJ0(pow0, A)
        testH0(pow0, A)
    end
    @testset "pow3 $(arrayname(A))" for A in SQUARE_MATRICES
        testJ1(pow3, A)
        testH1(pow3, A)
    end

    A = rand(3, 3)
    v = rand(3)

    @testset "`SparseMatrixCSC` (3×3)" begin
        # TODO: this is a temporary solution until sparse matrix inputs are supported (#28)

        testJ1(SparsifyInput(exp), A)
        testH1(SparsifyInput(exp), A)

        testJ0(SparsifyInput(pow0), A)
        testH0(SparsifyInput(pow0), A)

        testJ1(SparsifyInput(pow3), A)
        testH1(SparsifyInput(pow3), A)

        testJ1(SpdiagmifyInput(exp), v)
        testH1(SpdiagmifyInput(exp), v)

        testJ0(SpdiagmifyInput(pow0), v)
        testH0(SpdiagmifyInput(pow0), v)

        testJ1(SpdiagmifyInput(pow3), v)
        testH1(SpdiagmifyInput(pow3), v)
    end

    # Functions that work on all matrices
    @testset "pinv $(arrayname(A))" for A in ALL_MATRICES
        testJ1(pinv, A)
        testH1(pinv, A)
    end
    @testset "`SparseMatrixCSC` (3×4)" begin
        testJ1(SparsifyInput(pinv), rand(3, 4))
        testH1(SparsifyInput(pinv), rand(3, 4))
    end
end

@testset "clamp!" begin
    t1 = idx2tracer(1)
    t2 = idx2tracer(2)
    t3 = idx2tracer(3)
    t4 = idx2tracer(4)
    A = [t1 t2; t3 t4]

    t_lo = idx2tracer(5)
    t_hi = idx2tracer(6)

    out = clamp!(A, 0.0, 1.0)
    @test sameidx(out[1, 1], 1)
    @test sameidx(out[1, 2], 2)
    @test sameidx(out[2, 1], 3)
    @test sameidx(out[2, 2], 4)

    out = clamp!(A, t_lo, 1.0)
    @test sameidx(out[1, 1], [1, 5])
    @test sameidx(out[1, 2], [2, 5])
    @test sameidx(out[2, 1], [3, 5])
    @test sameidx(out[2, 2], [4, 5])

    out = clamp!(A, 0.0, t_hi)
    @test sameidx(out[1, 1], [1, 6])
    @test sameidx(out[1, 2], [2, 6])
    @test sameidx(out[2, 1], [3, 6])
    @test sameidx(out[2, 2], [4, 6])

    out = clamp!(A, t_lo, t_hi)
    @test sameidx(out[1, 1], [1, 5, 6])
    @test sameidx(out[1, 2], [2, 5, 6])
    @test sameidx(out[2, 1], [3, 5, 6])
    @test sameidx(out[2, 2], [4, 5, 6])
end

@testset "Matrix multiplication" begin
    t1 = idx2tracer([1])
    t2 = idx2tracer([2])
    t3 = idx2tracer([3])
    t4 = idx2tracer([4])
    t5 = idx2tracer([5])
    t6 = idx2tracer([6])
    t7 = idx2tracer([7])
    t8 = idx2tracer([8])
    t9 = idx2tracer([9])

    A_t = [
        t1 t2
        t3 t4
        t5 t6
    ]
    A_p = rand(3, 2)

    x_t = [t7, t8]
    y_t = [t7, t9]

    x_p = rand(2)
    y_p = rand(2)

    @testset "Global" begin
        b_pp = A_p * x_p
        @testset "Tracer-Primal" begin
            b_tp = A_t * x_p
            @test size(b_tp) == size(b_pp)
            @test all(
                map(
                    sameidx,
                    b_tp,
                    [
                        t1 + t2
                        t3 + t4
                        t5 + t6
                    ],
                )
            )
            B_tp = A_t * hcat(x_p, y_p)
            @test size(B_tp) == (3, 2)
            @test all(
                map(
                    sameidx,
                    B_tp,
                    [
                        (t1 + t2)       (t1 + t2)
                        (t3 + t4)       (t3 + t4)
                        (t5 + t6)       (t5 + t6)
                    ],
                )
            )
            @test_throws DimensionMismatch A_t * vcat(x_p, x_p)
            @test_throws DimensionMismatch A_t * hcat(x_p[1:1], x_p[1:1])
        end
        @testset "Primal-Tracer" begin
            b_pt = A_p * x_t
            @test size(b_pt) == size(b_pp)
            @test all(
                map(
                    sameidx,
                    b_pt,
                    [
                        t7 + t8
                        t7 + t8
                        t7 + t8
                    ],
                )
            )
            B_pt = A_p * hcat(x_t, y_t)
            @test size(B_pt) == (3, 2)
            @test all(
                map(
                    sameidx,
                    B_pt,
                    [
                        (t7 + t8)         (t7 + t9)
                        (t7 + t8)         (t7 + t9)
                        (t7 + t8)         (t7 + t9)
                    ],
                )
            )
            @test_throws DimensionMismatch A_p * vcat(x_t, x_t)
            @test_throws DimensionMismatch A_p * hcat(x_t[1:1], x_t[1:1])
        end
        @testset "Tracer-Tracer" begin
            b_tt = A_t * x_t
            @test size(b_tt) == size(b_pp)
            @test all(
                map(
                    sameidx,
                    b_tt,
                    [
                        t1 + t2 + t7 + t8
                        t3 + t4 + t7 + t8
                        t5 + t6 + t7 + t8
                    ],
                )
            )
            B_tt = A_t * hcat(x_t, y_t)
            @test size(B_tt) == (3, 2)
            @test all(
                map(
                    sameidx,
                    B_tt,
                    [
                        (t1 + t2 + t7 + t8)           (t1 + t2 + t7 + t9)
                        (t3 + t4 + t7 + t8)           (t3 + t4 + t7 + t9)
                        (t5 + t6 + t7 + t8)           (t5 + t6 + t7 + t9)
                    ],
                ),
            )
            @test_throws DimensionMismatch A_t * vcat(x_t, x_t)
            @test_throws DimensionMismatch A_t * hcat(x_t[1:1], x_t[1:1])
        end
    end
end

@testset "Matrix division" begin
    t1 = idx2tracer([1, 3, 4])
    t2 = idx2tracer([2, 4])
    t3 = idx2tracer([8, 9])
    t4 = idx2tracer([8, 9])
    A_t = [t1 t2; t3 t4]
    A_p = rand(2, 2)

    t5 = idx2tracer([6])
    t6 = idx2tracer([5, 7])
    x_t = [t5; t6]
    x_p = rand(2)

    set_tp = set_A = idx2set([1, 2, 3, 4, 8, 9])
    set_pt = set_x = idx2set([5, 6, 7])
    set_tt = union(set_tp, set_pt)

    @testset "Global" begin
        b_pp = A_p \ x_p
        @testset "Tracer-Primal" begin
            b_tp = A_t \ x_p
            @test size(b_tp) == size(b_pp)
            @test all(t -> sameidx(t, set_tp), b_tp)
        end
        @testset "Primal-Tracer" begin
            b_pt = A_p \ x_t
            @test size(b_pt) == size(b_pp)
            @test all(t -> sameidx(t, set_pt), b_pt)
        end
        @testset "Tracer-Tracer" begin
            b_tt = A_t \ x_t
            @test size(b_tt) == size(b_pp)
            @test all(t -> sameidx(t, set_tt), b_tt)
        end
    end
    @testset "Local" begin
        @testset "$P" for P in (Float32, BigFloat)
            # https://github.com/adrhill/SparseConnectivityTracer.jl/issues/235

            A_p = rand(P, 2, 2)
            A_d = Dual.(A_p, A_t)
            @test size(A_d) == size(A_p)

            x_p = rand(P, 2)
            x_d = Dual.(x_p, x_t)
            @test size(x_d) == size(x_p)

            b_pp = A_p \ x_p

            @testset "Dual-Primal" begin
                b_dp = A_d \ x_p
                primals_dp, _ = split_dual_array(b_dp)
                @test size(b_dp) == size(b_pp)
                @test primals_dp == b_pp
                @test all(d -> sameidx(tracer(d), set_tp), b_dp)
            end
            @testset "Primal-Dual" begin
                b_pd = A_p \ x_d
                primals_pd, _ = split_dual_array(b_pd)
                @test size(b_pd) == size(b_pp)
                @test primals_pd == b_pp
                @test all(d -> sameidx(tracer(d), set_pt), b_pd)
            end
            @testset "Dual-Dual" begin
                b_dd = A_d \ x_d
                primals_dd, _ = split_dual_array(b_dd)
                @test size(b_dd) == size(b_pp)
                @test primals_dd == b_pp
                @test all(d -> sameidx(tracer(d), set_tt), b_dd)
            end
        end
    end
end

@testset "Dot" begin
    t1 = idx2tracer([1, 3, 4])
    t2 = idx2tracer([2, 4])
    t3 = idx2tracer([5, 6])
    t4 = idx2tracer([7, 8])

    tx = [t1, t2]
    ty = [t3, t4]
    tA = [idx2tracer(9) idx2tracer(10); idx2tracer(11) idx2tracer(12)]

    # SubArray variants of tx and ty
    B = [t1 t2; t3 t4]
    subx = view(B, 1, :)
    suby = view(B, 2, :)

    rx = rand(2)
    ry = rand(2)
    rA = rand(2, 2)
    sx = sparse([1; 0])
    sy = sparse([0; 1])
    sA = sparse([1 0; 0 2])

    @testset "scalar-scalar" begin
        @test sameidx(dot(t1, t2), 1:4)
        @test sameidx(dot(t1, t3), [1, 3, 4, 5, 6])
        @test sameidx(dot(t1, 1.0), [1, 3, 4])
        @test sameidx(dot(1.0, t2), [2, 4])
    end
    @testset "vector-vector" begin
        @test sameidx(dot(tx, ty), 1:8)
        @test sameidx(dot(tx, ry), 1:4)
        @test sameidx(dot(rx, ty), 5:8)

        @testset "SubArrays" begin
            @test subx isa SubArray
            @test suby isa SubArray
            @test sameidx(dot(subx, suby), 1:8)
            @test sameidx(dot(subx, ry), 1:4)
            @test sameidx(dot(rx, suby), 5:8)
        end

        @testset "SparseArrays" begin
            @test sameidx(dot(tx, sy), [2, 4])
            @test sameidx(dot(sx, ty), 5:6)
        end
        @test_throws DimensionMismatch dot(tx, rand(3))
        @test_throws DimensionMismatch dot(rand(3), ty)

        txe = TG[]
        tye = TG[]
        out = dot(txe, tye)
        @test isemptytracer(out)
    end
    @testset "vector-Matrix-vector" begin
        @test sameidx(dot(tx, rA, ry), 1:4)
        @test sameidx(dot(tx, tA, ry), vcat(1:4, 9:12))
        @test sameidx(dot(tx, rA, ty), 1:8)
        @test sameidx(dot(tx, tA, ty), 1:12)
        @test sameidx(dot(rx, tA, ty), 5:12)
        @test sameidx(dot(rx, rA, ty), 5:8)
        @test sameidx(dot(rx, tA, ry), 9:12)

        @testset "SubArrays" begin
            @test subx isa SubArray
            @test suby isa SubArray
            @test sameidx(dot(subx, rA, ry), 1:4)
            @test sameidx(dot(subx, tA, ry), vcat(1:4, 9:12))
            @test sameidx(dot(subx, rA, suby), 1:8)
            @test sameidx(dot(subx, tA, suby), 1:12)
            @test sameidx(dot(rx, tA, suby), 5:12)
            @test sameidx(dot(rx, rA, suby), 5:8)
            @test sameidx(dot(rx, tA, ry), 9:12)
        end

        @testset "SparseArrays" begin
            # Some tests are broken since there is no specialized support for SparseArrays.
            # The purpose of these tests is to catch ambiguity errors.
            @test_nowarn dot(tx, sA, ry)
            @test_nowarn dot(tx, rA, sy)
            @test_nowarn dot(tx, sA, sy)
            @test_nowarn dot(tx, tA, sy)
            @test_nowarn dot(tx, sA, ty)
            @test_nowarn dot(tx, tA, ty)
            @test_nowarn dot(sx, tA, ry)
            @test_nowarn dot(rx, tA, sy)
            @test_nowarn dot(sx, tA, sy)
            @test_throws MissingPrimalError dot(sx, tA, ty)
            @test_throws MissingPrimalError dot(sx, rA, ty)
            @test_nowarn dot(rx, sA, ty)
            @test_nowarn dot(sx, sA, ty)
        end
    end
end

@testset "Eigenvalues" begin
    t1 = idx2tracer([1, 3, 4])
    t2 = idx2tracer([2, 4])
    t3 = idx2tracer([8, 9])
    t4 = idx2tracer([8, 9])
    A = [t1 t2; t3 t4]
    s_out = idx2set([1, 2, 3, 4, 8, 9])
    values, vectors = eigen(A)
    @test size(values) == (2,)
    @test size(vectors) == (2, 2)
    @test all(t -> sameidx(t, s_out), values)
    @test all(t -> sameidx(t, s_out), vectors)
end

@testset "Cholesky" begin
    t1 = idx2tracer([1, 3, 4])
    t2 = idx2tracer([2, 4])
    t3 = idx2tracer([8, 9])
    t4 = idx2tracer([8, 9])
    A = [t1 t2; t3 t4]
    s_out = idx2set([1, 2, 3, 4, 8, 9])
    @testset "$pivot" for pivot in (NoPivot(), RowMaximum())
        factors = cholesky(A, pivot).factors
        @test size(factors) == (2, 2)
        @test all(t -> sameidx(t, s_out), factors)
    end
    @test all(t -> sameidx(t, s_out), cholesky(A).factors)
end

@testset "SparseMatrixCSC construction" begin
    t1 = idx2tracer(1)
    t2 = idx2tracer(2)
    t3 = idx2tracer(3)
    SA = sparse([t1 t2; t3 0])
    @test length(SA.nzval) == 3

    res = opnorm(SA, 1)
    @test sameidx(res, [1, 2, 3])
end

using Dates: now
using LinearAlgebra
using OptimizationProblems
using SparseArrays
using Test
using SparseConnectivityTracerBenchmarks.Optimization:
    compute_jac_and_hess_sparsity_sct,
    compute_jac_and_hess_sparsity_and_value_jump,
    OPTIMIZATION_PROBLEM_NAMES

function compare_patterns(
        truth::AbstractMatrix{<:Real}; sct::AbstractMatrix{Bool}, jump::AbstractMatrix{Bool}
    )
    difference = jump - sct
    if nnz(difference) > 0
        # test that all pattern differences are local zeros in the ground truth
        I, J, _ = findnz(difference)
        coeffs = [truth[i, j] for (i, j) in zip(I, J)]
        @test maximum(abs, coeffs) < 1.0e-7
    end

    nnz_sct, nnz_jump = nnz(sct), nnz(jump)
    diagonal = (difference == Diagonal(difference)) ? "[diagonal difference only]" : ""
    message = if all(>(0), nonzeros(difference))
        "SCT ($nnz_sct nz) ⊂ JuMP ($nnz_jump nz) $diagonal"
    elseif all(<(0), nonzeros(difference))
        "SCT ($nnz_sct nz) ⊃ JuMP ($nnz_jump nz) $diagonal"
    else
        "SCT ($nnz_sct nz) ≠ JuMP ($nnz_jump nz) $diagonal"
    end
    return message
end

#=
Please look at the warnings displayed at the end.
=#

jac_inconsistencies = []
hess_inconsistencies = []

@testset "$name" for name in OPTIMIZATION_PROBLEM_NAMES
    @info "$(now()) - $name"

    (jac_sparsity_sct, hess_sparsity_sct) = compute_jac_and_hess_sparsity_sct(name)
    ((jac_sparsity_jump, jac), (hess_sparsity_jump, hess)) = compute_jac_and_hess_sparsity_and_value_jump(
        name
    )

    @testset verbose = true "Jacobian comparison" begin
        if jac_sparsity_sct == jac_sparsity_jump
            @test jac_sparsity_sct == jac_sparsity_jump
        else
            @test_broken jac_sparsity_sct == jac_sparsity_jump
            message = compare_patterns(jac; sct = jac_sparsity_sct, jump = jac_sparsity_jump)
            @warn "Inconsistency for Jacobian of $name: $message"
            push!(jac_inconsistencies, (name, message))
        end
    end

    @testset verbose = true "Hessian comparison" begin
        if hess_sparsity_sct == hess_sparsity_jump
            @test hess_sparsity_sct == hess_sparsity_jump
        else
            @test_broken hess_sparsity_sct == hess_sparsity_jump
            message = compare_patterns(hess; sct = hess_sparsity_sct, jump = hess_sparsity_jump)
            @warn "Inconsistency for Hessian of $name: $message"
            push!(hess_inconsistencies, (name, message))
        end
    end
    yield()
end;

if !isempty(jac_inconsistencies) || !isempty(hess_inconsistencies)
    @warn "Inconsistencies were detected"
    for (name, message) in jac_inconsistencies
        @warn "Inconsistency for Jacobian of $name: $message"
    end
    for (name, message) in hess_inconsistencies
        @warn "Inconsistency for Hessian of $name: $message"
    end
end

using SparseConnectivityTracer
using ADTypes
using Documenter
using DocumenterMermaid

# Create index.md from README
cp(joinpath(@__DIR__, "..", "README.md"), joinpath(@__DIR__, "src", "index.md"); force = true)

DocMeta.setdocmeta!(
    SparseConnectivityTracer,
    :DocTestSetup,
    :(using SparseConnectivityTracer);
    recursive = true,
)

makedocs(;
    modules = [SparseConnectivityTracer, ADTypes],
    authors = "Adrian Hill <gh@adrianhill.de>",
    sitename = "SparseConnectivityTracer.jl",
    format = Documenter.HTML(;
        canonical = "https://adrhill.github.io/SparseConnectivityTracer.jl",
        edit_link = "main",
        assets = ["assets/favicon.ico"],
    ),
    pages = [
        "Getting Started" => "index.md",
        "User Documentation" =>
            ["user/global_vs_local.md", "user/performance.md", "user/limitations.md", "user/api.md"],
        "Developer Documentation" => [
            "internals/how_it_works.md",
            "internals/adding_overloads.md",
            "internals/api.md",
        ],
    ],
    warnonly = [:missing_docs],
)

deploydocs(; repo = "github.com/adrhill/SparseConnectivityTracer.jl", devbranch = "main")

#= For now, three-argument functions are overloaded individually.
If this file grows too large:
    1. 3-arg operators should be classified in src/operators.jl
    2. the classification should be tested in test/classification.jl
    3. code generation utilities should be added to the src/overloads/*_tracer.jl files
=#
Base.clamp(t::T, lo, hi) where {T <: AbstractTracer} = t
Base.clamp(t::T, lo::T, hi) where {T <: AbstractTracer} = first_order_or(t, lo)
Base.clamp(t::T, lo, hi::T) where {T <: AbstractTracer} = first_order_or(t, hi)
function Base.clamp(t::T, lo::T, hi::T) where {T <: AbstractTracer}
    return first_order_or(t, first_order_or(lo, hi))
end

# For `fma(x, y, z)`, just fall back on `x * y + z`.
Base.fma(x::T, y::T, z::T) where {T <: Union{AbstractTracer, Dual}} = x * y + z

using SparseConnectivityTracer
using LogExpFunctions
using Test

# Load definitions of GRADIENT_TRACERS and HESSIAN_TRACERS
include("../tracers_definitions.jl")

lef_1_to_1_pos_input = (
    xlogx,
    logistic,
    logit,
    log1psq,
    log1pexp,
    logexpm1,
    softplus,
    invsoftplus,
    log1pmx,
    logmxp1,
    logcosh,
    logabssinh,
    cloglog,
    cexpexp,
    loglogistic,
    log1mlogistic,
)
lef_1_to_1_neg_input = (log1mexp, log2mexp, logitexp, logit1mexp)
lef_1_to_1 = union(lef_1_to_1_pos_input, lef_1_to_1_neg_input)
lef_2_to_1 = (xlogy, xlog1py, xexpy, logaddexp, logsubexp)

@testset "Jacobian Global" begin
    detector = TracerSparsityDetector()
    J(f, x) = jacobian_sparsity(f, x, detector)

    @testset "1-to-1 functions" begin
        @testset "$f" for f in lef_1_to_1
            @test J(x -> f(x[1]), rand(2)) == [1 0]
        end
    end
    @testset "2-to-1 functions" begin
        @testset "$f" for f in lef_2_to_1
            @test J(x -> f(x[1], x[2]), rand(3)) == [1 1 0]
        end
    end
end

@testset "Jacobian Local" begin
    detector = TracerLocalSparsityDetector()
    J(f, x) = jacobian_sparsity(f, x, detector)

    @testset "1-to-1 functions" begin
        @testset "$f" for f in lef_1_to_1_pos_input
            @test J(x -> f(x[1]), [0.5, 1.0]) == [1 0]
        end
        @testset "$f" for f in lef_1_to_1_neg_input
            @test J(x -> f(x[1]), [-0.5, 1.0]) == [1 0]
        end
    end
    @testset "2-to-1 functions" begin
        @testset "$f" for f in lef_2_to_1
            @test J(x -> f(x[1], x[2]), [0.5, 1.0, 2.0]) == [1 1 0]
        end
    end
end

@testset "Hessian Global" begin
    detector = TracerSparsityDetector()
    H(f, x) = hessian_sparsity(f, x, detector)

    @testset "1-to-1 functions" begin
        @testset "$f" for f in lef_1_to_1
            @test H(x -> f(x[1]), rand(2)) == [1 0; 0 0]
        end
    end
    @testset "2-to-1 functions" begin
        @testset "$f" for f in lef_2_to_1
            @test H(x -> f(x[1], x[2]), rand(3)) == [1 1 0; 1 1 0; 0 0 0]
        end
    end
end

@testset "Hessian Local" begin
    detector = TracerLocalSparsityDetector()
    H(f, x) = hessian_sparsity(f, x, detector)

    @testset "1-to-1 functions" begin
        @testset "$f" for f in lef_1_to_1_pos_input
            @test H(x -> f(x[1]), [0.5, 1.0]) == [1 0; 0 0]
        end
        @testset "$f" for f in lef_1_to_1_neg_input
            @test H(x -> f(x[1]), [-0.5, 1.0]) == [1 0; 0 0]
        end
    end
    @testset "2-to-1 functions" begin
        @testset "$f" for f in lef_2_to_1
            @test H(x -> f(x[1], x[2]), [0.5, 1.0, 2.0]) == [1 1 0; 1 1 0; 0 0 0]
        end
    end
end

using ADTypes
using ADTypes: AbstractSparsityDetector
using Flux: Conv, relu
using ReferenceTests
using SparseConnectivityTracer
using Test

# Load definitions of GRADIENT_TRACERS and HESSIAN_TRACERS
include("tracers_definitions.jl")

const INPUT_FLUX = reshape(
    [
        0.2677768300138966
        1.1934917429169245
        -1.0496617141319355
        0.456668782925957
        0.09678342859916624
        -0.7962039825333248
        -0.6138709208787495
        -0.6809396498148278
        0.4938230574627916
        0.7847107012511034
        0.7423059724033608
        -0.6914378396432983
        1.2062310319178624
        -0.19647670394840708
        0.10708057449244994
        -0.4787927739226245
        0.045072020113458774
        -1.219617669693635
    ],
    3,
    3,
    2,
    1,
) # WHCN
const WEIGHTS_FLUX = reshape(
    [
        0.311843398150865
        0.488663701947109
        0.648497438559604
        -0.41742794246238
        0.174865988551499
        1.061745573803265
        -0.72434245370475
        -0.05213963181095
    ],
    2,
    2,
    2,
    1,
)
const BIAS_FLUX = [0.1]

const LAYER = Conv(WEIGHTS_FLUX, BIAS_FLUX) # Conv((2, 2), 2 => 1)
const LAYER_RELU = Conv(WEIGHTS_FLUX, BIAS_FLUX, relu) # Conv((2, 2), 2 => 1, relu)

function test_flux_conv(detector::AbstractSparsityDetector)
    J = jacobian_sparsity(LAYER, INPUT_FLUX, detector)
    return @test_reference "references/pattern/jacobian/NNlib/conv.txt" BitMatrix(J)
end
function test_flux_conv_local(detector::AbstractSparsityDetector)
    J = jacobian_sparsity(LAYER_RELU, INPUT_FLUX, detector)
    return @test_reference "references/pattern/jacobian/NNlib/conv_relu.txt" BitMatrix(J)
end

@testset "Global" begin
    @testset "$T" for T in GRADIENT_TRACERS
        detector = TracerSparsityDetector(T)
        test_flux_conv(detector)
    end
end
@testset "Local" begin
    @testset "$T" for T in GRADIENT_TRACERS
        detector = TracerLocalSparsityDetector(T)
        test_flux_conv(detector)
        test_flux_conv_local(detector)
    end
end

##===============#
# AbstractTracer #
#================#

Base.promote_rule(::Type{T}, ::Type{N}) where {T <: AbstractTracer, N <: Real} = T
Base.promote_rule(::Type{N}, ::Type{T}) where {T <: AbstractTracer, N <: Real} = T

Base.convert(::Type{T}, x::Real) where {T <: AbstractTracer} = myempty(T)
Base.convert(::Type{T}, t::T) where {T <: AbstractTracer} = t
Base.convert(::Type{<:Real}, t::T) where {T <: AbstractTracer} = t

##======#
# Duals #
#=======#

function Base.promote_rule(::Type{Dual{P1, T}}, ::Type{Dual{P2, T}}) where {P1, P2, T}
    PP = Base.promote_type(P1, P2) # TODO: possible method call error?
    return Dual{PP, T}
end
function Base.promote_rule(::Type{Dual{P, T}}, ::Type{N}) where {P, T, N <: Real}
    PP = Base.promote_type(P, N) # TODO: possible method call error?
    return Dual{PP, T}
end
function Base.promote_rule(::Type{N}, ::Type{Dual{P, T}}) where {P, T, N <: Real}
    PP = Base.promote_type(P, N) # TODO: possible method call error?
    return Dual{PP, T}
end

Base.convert(::Type{D}, x::Real) where {P, T, D <: Dual{P, T}} = D(convert(P, x), myempty(T))
Base.convert(::Type{D}, d::D) where {D <: Dual} = d
Base.convert(::Type{N}, d::D) where {N <: Real, P, T, D <: Dual{P, T}} = Dual{N, T}(convert(N, primal(d)), tracer(d))

function Base.convert(::Type{Dual{P1, T}}, d::Dual{P2, T}) where {P1, P2, T}
    return Dual{P1, T}(convert(P1, primal(d)), tracer(d))
end

##==========================#
# Explicit type conversions #
#===========================#

for T in (:Int, :Integer, :Float64, :Float32)
    # Currently only defined on Dual to avoid invalidations.
    @eval function Base.$T(d::Dual)
        isemptytracer(d) || throw(InexactError(Symbol($T), $T, d))
        return $T(primal(d))
    end
end

##======================#
# Named type promotions #
#=======================#

for f in (:big, :widen, :float)
    @eval Base.$f(::Type{T}) where {T <: AbstractTracer} = T
    @eval Base.$f(::Type{D}) where {P, T, D <: Dual{P, T}} = Dual{$f(P), T}
end

##============================#
# Constant functions on types #
#=============================#

for f in
    (:zero, :one, :oneunit, :typemin, :typemax, :eps, :floatmin, :floatmax, :maxintfloat)
    @eval Base.$f(::Type{T}) where {T <: AbstractTracer} = myempty(T)
    @eval Base.$f(::Type{D}) where {P, T, D <: Dual{P, T}} = Dual($f(P), myempty(T))
    @eval Base.$f(::T) where {T <: AbstractTracer} = myempty(T)
    @eval Base.$f(d::D) where {P, T, D <: Dual{P, T}} = Dual($f(d.primal), myempty(T))
end

module SparseConnectivityTracer

using ADTypes: ADTypes, jacobian_sparsity, hessian_sparsity
using SparseArrays: SparseArrays
using SparseArrays: sparse
using Random: AbstractRNG, SamplerType

using LinearAlgebra: LinearAlgebra, Symmetric
using LinearAlgebra: Diagonal, diag, diagind
using FillArrays: Fill

using DocStringExtensions: DocStringExtensions, TYPEDEF, TYPEDFIELDS

include("set_operations.jl")
include("tracers.jl")
include("exceptions.jl")
include("operators.jl")

include("overloads/conversion.jl")
include("overloads/gradient_tracer.jl")
include("overloads/hessian_tracer.jl")
include("overloads/utils.jl")
include("overloads/special_cases.jl")
include("overloads/three_arg.jl")
include("overloads/ifelse_global.jl")
include("overloads/is_functions.jl")
include("overloads/arrays.jl")
include("overloads/ambiguities.jl")

include("trace_functions.jl")
include("parse_outputs_to_matrix.jl")
include("adtypes_interface.jl")

export TracerSparsityDetector
export TracerLocalSparsityDetector

# Reexport ADTypes interface
export jacobian_sparsity, hessian_sparsity

export jacobian_eltype, hessian_eltype
export jacobian_buffer, hessian_buffer

end # module

#===============#
# Tracer unions #
#===============#

"""
    first_order_or(tracers)

Compute the most conservative elementwise OR of tracer sparsity patterns,
excluding second-order interactions of `HessianTracer`.

This is functionally equivalent to:
```julia
reduce(+, tracers)
```
"""
function first_order_or(ts::AbstractArray{T}) where {T <: AbstractTracer}
    # TODO: improve performance
    return reduce(first_order_or, ts; init = myempty(T))
end
function first_order_or(a::T, b::T) where {T <: GradientTracer}
    return gradient_tracer_2_to_1(a, b, false, false)
end
function first_order_or(a::T, b::T) where {T <: HessianTracer}
    return hessian_tracer_2_to_1(a, b, false, true, false, true, true)
end

"""
    second_order_or(tracers)

Compute the most conservative elementwise OR of tracer sparsity patterns,
including second-order interactions to update the `hessian` field of `HessianTracer`.

This is functionally equivalent to:
```julia
reduce(^, tracers)
```
"""
function second_order_or(ts::AbstractArray{T}) where {T <: AbstractTracer}
    # TODO: improve performance
    return reduce(second_order_or, ts; init = myempty(T))
end

function second_order_or(a::T, b::T) where {T <: GradientTracer}
    return gradient_tracer_2_to_1(a, b, false, false)
end
function second_order_or(a::T, b::T) where {T <: HessianTracer}
    return hessian_tracer_2_to_1(a, b, false, false, false, false, false)
end

#=================#
# Code generation #
#=================#

dims = (Symbol("1_to_1"), Symbol("2_to_1"), Symbol("1_to_2"))

# Generate both Gradient and Hessian code with one call to `generate_code_X_to_Y`
for d in dims
    f = Symbol("generate_code_", d)
    g = Symbol("generate_code_gradient_", d)
    h = Symbol("generate_code_hessian_", d)

    @eval function $f(M::Symbol, f::Function)
        expr_g = $g(M, f)
        expr_h = $h(M, f)
        return Expr(:block, expr_g, expr_h)
    end
end

# Allow all `generate_code_*` functions to be called on several operators at once
for d in dims
    for f in (
            Symbol("generate_code_", d),
            Symbol("generate_code_gradient_", d),
            Symbol("generate_code_hessian_", d),
        )
        @eval function $f(M::Symbol, ops::Union{AbstractVector, Tuple})
            exprs = [$f(M, op) for op in ops]
            return Expr(:block, exprs...)
        end
    end
end

# Overloads of 2-argument functions on arbitrary types
function generate_code_2_to_1_typed(M::Symbol, f::Function, Z::Type)
    expr_g = generate_code_gradient_2_to_1_typed(M, f, Z)
    expr_h = generate_code_hessian_2_to_1_typed(M, f, Z)
    return Expr(:block, expr_g, expr_h)
end
function generate_code_2_to_1_typed(M::Symbol, ops::Union{AbstractVector, Tuple}, Z::Type)
    exprs = [generate_code_2_to_1_typed(M, op, Z) for op in ops]
    return Expr(:block, exprs...)
end

## Overload operators
eval(generate_code_1_to_1(:Base, ops_1_to_1))
eval(generate_code_2_to_1(:Base, ops_2_to_1))
eval(generate_code_1_to_2(:Base, ops_1_to_2))

## List operators for later testing
test_operators_1_to_1(::Val{:Base}) = ops_1_to_1
test_operators_2_to_1(::Val{:Base}) = ops_2_to_1
test_operators_1_to_2(::Val{:Base}) = ops_1_to_2

using BenchmarkTools
using OptimizationProblems: ADNLPProblems
using SparseConnectivityTracerBenchmarks.Optimization:
    compute_jac_sparsity_sct, compute_hess_sparsity_sct

function optbench(names::Vector{Symbol})
    suite = BenchmarkGroup()
    for name in names
        nlp = ADNLPProblems.eval(name)()
        suite[name]["Jacobian"] = @benchmarkable compute_jac_sparsity_sct($nlp)
        suite[name]["Hessian"] = @benchmarkable compute_hess_sparsity_sct($nlp)
    end
    return suite
end

using SparseConnectivityTracer
using SparseConnectivityTracer: Dual, HessianTracer, MissingPrimalError
using SparseConnectivityTracer: create_tracers, hessian, isshared, primal, tracer
using LinearAlgebra: I, dot
using Test
using Random: rand, GLOBAL_RNG

# Load definitions of GRADIENT_TRACERS and HESSIAN_TRACERS
include("tracers_definitions.jl")
REAL_TYPES = (Float64, Int, Bool, UInt8, Float16, Rational{Int})

# These exists to be able to quickly run tests in the REPL.
# NOTE: H gets overwritten inside the testsets.
detector = TracerSparsityDetector()
H(f, x) = hessian_sparsity(f, x, detector)

T = DEFAULT_HESSIAN_TRACER
D = Dual{Int, T}

@testset "Global Hessian" begin
    @testset "$T" for T in HESSIAN_TRACERS
        detector = TracerSparsityDetector(T)
        H(f, x) = hessian_sparsity(f, x, detector)

        @testset "Trivial examples" begin
            @test H(identity, rand()) ≈ [0;;]
            @test H(sqrt, rand()) ≈ [1;;]

            @test H(x -> 1 * x, rand()) ≈ [0;;]
            @test H(x -> x * 1, rand()) ≈ [0;;]
        end

        # Code coverage
        @testset "Miscellaneous" begin
            @test H(sign, 1) ≈ [0;;]
            @test H(typemax, 1) ≈ [0;;]
            @test H(x -> x^(2 // 3), 1) ≈ [1;;]
            @test H(x -> (2 // 3)^x, 1) ≈ [1;;]
            @test H(x -> x^ℯ, 1) ≈ [1;;]
            @test H(x -> ℯ^x, 1) ≈ [1;;]
            @test H(x -> 0, 1) ≈ [0;;]

            @test H(x -> sum(sincosd(x)), 1.0) ≈ [1;;]

            @test H(x -> sum(diff(x) .^ 3), rand(4)) == [
                1 1 0 0
                1 1 1 0
                0 1 1 1
                0 0 1 1
            ]
        end

        # Conversions
        @testset "Conversion" begin
            @testset "to $T" for T in REAL_TYPES
                @test H(x -> convert(T, x), 1.0) ≈ [0;;]
                @test H(x -> convert(T, x^2), 1.0) ≈ [1;;]
                @test H(x -> convert(T, x)^2, 1.0) ≈ [1;;]
            end
        end

        @testset "Round" begin
            @test H(round, 1.1) ≈ [0;;]
            @test H(x -> round(Int, x), 1.1) ≈ [0;;]
            @test H(x -> round(Bool, x), 1.1) ≈ [0;;]
            @test H(x -> round(Float16, x), 1.1) ≈ [0;;]
            @test H(x -> round(x, RoundNearestTiesAway), 1.1) ≈ [0;;]
            @test H(x -> round(x; digits = 3, base = 2), 1.1) ≈ [0;;]
        end

        @testset "Three-argument operators" begin
            @test H(x -> clamp(x, 0.1, 0.9), rand()) == [0;;]
            @test H(x -> clamp(x[1], x[2], 0.9), rand(2)) == [0 0; 0 0]
            @test H(x -> clamp(x[1], 0.1, x[2]), rand(2)) == [0 0; 0 0]
            @test H(x -> clamp(x[1], x[2], x[3]), rand(3)) == [0 0 0; 0 0 0; 0 0 0]
            @test H(x -> x[1] * clamp(x[1], x[2], x[3]), rand(3)) == [1 1 1; 1 0 0; 1 0 0]
            @test H(x -> x[2] * clamp(x[1], x[2], x[3]), rand(3)) == [0 1 0; 1 1 1; 0 1 0]
            @test H(x -> x[3] * clamp(x[1], x[2], x[3]), rand(3)) == [0 0 1; 0 0 1; 1 1 1]

            @test H(x -> fma(x, 1.0, 1.0), rand()) == [0;;]
            @test H(x -> fma(1.0, x, 1.0), rand()) == [0;;]
            @test H(x -> fma(1.0, 1.0, x), rand()) == [0;;]
            @test H(x -> fma(x[1], x[2], 1.0), rand(2)) == [0 1; 1 0]
            @test H(x -> fma(x[1], 1.0, x[2]), rand(2)) == [0 0; 0 0]
            @test H(x -> fma(x[1], x[2], x[3]), rand(3)) == [0 1 0; 1 0 0; 0 0 0]
        end

        @testset "Random" begin
            @test H(x -> rand(typeof(x)), 1) ≈ [0;;]
            @test H(x -> rand(GLOBAL_RNG, typeof(x)), 1) ≈ [0;;]
        end

        @testset "Basic operators" begin
            @test H(x -> x[1] / x[2] + x[3] / 1 + 1 / x[4], rand(4)) == [
                0 1 0 0
                1 1 0 0
                0 0 0 0
                0 0 0 1
            ]

            @test H(x -> x[1] * x[2] + x[3] * 1 + 1 * x[4], rand(4)) == [
                0 1 0 0
                1 0 0 0
                0 0 0 0
                0 0 0 0
            ]

            @test H(x -> (x[1] * x[2]) * (x[3] * x[4]), rand(4)) == [
                0 1 1 1
                1 0 1 1
                1 1 0 1
                1 1 1 0
            ]

            @test H(x -> (x[1] + x[2]) * (x[3] + x[4]), rand(4)) == [
                0 0 1 1
                0 0 1 1
                1 1 0 0
                1 1 0 0
            ]

            @test H(x -> (x[1] + x[2] + x[3] + x[4])^2, rand(4)) == [
                1 1 1 1
                1 1 1 1
                1 1 1 1
                1 1 1 1
            ]

            @test H(x -> 1 / (x[1] + x[2] + x[3] + x[4]), rand(4)) == [
                1 1 1 1
                1 1 1 1
                1 1 1 1
                1 1 1 1
            ]

            @test H(x -> (x[1] - x[2]) + (x[3] - 1) + (1 - x[4]), rand(4)) == [
                0 0 0 0
                0 0 0 0
                0 0 0 0
                0 0 0 0
            ]

            x = rand(5)
            foo(x) = x[1] + x[2] * x[3] + 1 / x[4] + 1 * x[5]
            @test H(foo, x) == [
                0 0 0 0 0
                0 0 1 0 0
                0 1 0 0 0
                0 0 0 1 0
                0 0 0 0 0
            ]

            bar(x) = foo(x) + x[2]^x[5]
            @test H(bar, x) == [
                0 0 0 0 0
                0 1 1 0 1
                0 1 0 0 0
                0 0 0 1 0
                0 1 0 0 1
            ]
        end

        @testset "Zero derivatives" begin
            h = H(x -> copysign(x[1] * x[2], x[3] * x[4]), rand(4))
            if isshared(T)
                @test h == [
                    0 1 0 0
                    1 0 0 0
                    0 0 0 1
                    0 0 1 0
                ]
            else
                @test h == [
                    0 1 0 0
                    1 0 0 0
                    0 0 0 0
                    0 0 0 0
                ]
            end

            h = H(x -> div(x[1] * x[2], x[3] * x[4]), rand(4))
            if isshared(T)
                @test Matrix(h) == [
                    0 1 0 0
                    1 0 0 0
                    0 0 0 1
                    0 0 1 0
                ]
            else
                @test h == [
                    0 0 0 0
                    0 0 0 0
                    0 0 0 0
                    0 0 0 0
                ]
            end
        end

        @testset "shared Hessian" begin
            function dead_end(x)
                z = x[1] * x[2]
                return x[3] * x[4]
            end
            h = H(dead_end, rand(4))

            if isshared(T)
                @test h == [
                    0  1  0  0
                    1  0  0  0
                    0  0  0  1
                    0  0  1  0
                ]
            else
                @test h == [
                    0  0  0  0
                    0  0  0  0
                    0  0  0  1
                    0  0  1  0
                ]
            end
        end

        # Missing primal errors
        @testset "MissingPrimalError" begin
            @testset "$f" for f in (
                    iseven,
                    isfinite,
                    isinf,
                    isinteger,
                    isnan,
                    isodd,
                    isone,
                    isreal,
                    iszero,
                )
                @test_throws MissingPrimalError H(f, rand())
            end
        end

        @testset "ifelse and comparisons" begin
            @test H(x -> ifelse(x[1], x[1]^x[2], x[3] * x[4]), rand(4)) == [
                1  1  0  0
                1  1  0  0
                0  0  0  1
                0  0  1  0
            ]

            @test H(x -> ifelse(x[1], x[1]^x[2], 1.0), rand(4)) == [
                1  1  0  0
                1  1  0  0
                0  0  0  0
                0  0  0  0
            ]

            @test H(x -> ifelse(x[1], 1.0, x[3] * x[4]), rand(4)) == [
                0  0  0  0
                0  0  0  0
                0  0  0  1
                0  0  1  0
            ]

            function f_ampgo07(x)
                return (x[1] <= 0) * convert(eltype(x), Inf) +
                    sin(x[1]) +
                    sin(10 // 3 * x[1]) +
                    log(abs(x[1])) - 84 // 100 * x[1] + 3
            end
            @test H(f_ampgo07, [1.0]) ≈ [1;;]

            # Error handling when applying non-dual tracers to "local" functions with control flow
            # TypeError: non-boolean (SparseConnectivityTracer.GradientTracer{BitSet}) used in boolean context
            @test_throws TypeError H(x -> x[1] > x[2] ? x[1]^x[2] : x[3] * x[4], rand(4))
        end

        # NOTE: If these tests fail, changes might be breaking on stateful code (see PR #248).
        @testset "Ignore multiplication by zero" begin
            f1(x) = 0 * x[1]^2
            @test H(f1, [1.0]) == [1;;]
            f2(x) = x[1]^2 * 0
            @test H(f2, [1.0]) == [1;;]
        end

        yield()
    end
end

@testset "Local Hessian" begin
    @testset "$T" for T in HESSIAN_TRACERS
        detector = TracerLocalSparsityDetector(T)
        H(f, x) = hessian_sparsity(f, x, detector)

        @testset "Trivial examples" begin
            f1(x) = x[1] + x[2] * x[3] + 1 / x[4] + x[2] * max(x[1], x[5])
            @test H(f1, [1.0 3.0 5.0 1.0 2.0]) == [
                0  0  0  0  0
                0  0  1  0  1
                0  1  0  0  0
                0  0  0  1  0
                0  1  0  0  0
            ]

            @test H(f1, [4.0 3.0 5.0 1.0 2.0]) == [
                0  1  0  0  0
                1  0  1  0  0
                0  1  0  0  0
                0  0  0  1  0
                0  0  0  0  0
            ]

            f2(x) = ifelse(x[2] < x[3], x[1] * x[2], x[3] * x[4])
            h = H(f2, [1 2 3 4])
            if isshared(T)
                @test h == [
                    0  1  0  0
                    1  0  0  0
                    0  0  0  1
                    0  0  1  0
                ]
            else
                @test h == [
                    0  1  0  0
                    1  0  0  0
                    0  0  0  0
                    0  0  0  0
                ]
            end

            h = H(f2, [1 3 2 4])
            if isshared(T)
                @test h == [
                    0  1  0  0
                    1  0  0  0
                    0  0  0  1
                    0  0  1  0
                ]
            else
                @test h == [
                    0  0  0  0
                    0  0  0  0
                    0  0  0  1
                    0  0  1  0
                ]
            end
        end

        @testset "Shared Hessian" begin
            function dead_end(x)
                z = x[1] * x[2]
                return x[3] * x[4]
            end
            h = H(dead_end, rand(4))
            if isshared(T)
                @test h == [
                    0  1  0  0
                    1  0  0  0
                    0  0  0  1
                    0  0  1  0
                ]
            else
                @test h == [
                    0  0  0  0
                    0  0  0  0
                    0  0  0  1
                    0  0  1  0
                ]
            end
        end

        @testset "Miscellaneous" begin
            @test H(sign, 1) ≈ [0;;]
            @test H(typemax, 1) ≈ [0;;]
            @test H(x -> x^(2 // 3), 1) ≈ [1;;]
            @test H(x -> (2 // 3)^x, 1) ≈ [1;;]
            @test H(x -> x^ℯ, 1) ≈ [1;;]
            @test H(x -> ℯ^x, 1) ≈ [1;;]
            @test H(x -> 0, 1) ≈ [0;;]

            # Test special cases on empty tracer

            @test H(x -> zero(x)^(2 // 3), 1) ≈ [0;;]
            @test H(x -> (2 // 3)^zero(x), 1) ≈ [0;;]
            @test H(x -> zero(x)^ℯ, 1) ≈ [0;;]
            @test H(x -> ℯ^zero(x), 1) ≈ [0;;]
        end

        @testset "Conversion" begin
            @testset "to $T" for T in REAL_TYPES
                @test H(x -> convert(T, x), 1.0) ≈ [0;;]
                @test H(x -> convert(T, x^2), 1.0) ≈ [1;;]
                @test H(x -> convert(T, x)^2, 1.0) ≈ [1;;]
            end
        end

        @testset "Round" begin
            @test H(round, 1.1) ≈ [0;;]
            @test H(x -> round(Int, x), 1.1) ≈ [0;;]
            @test H(x -> round(Bool, x), 1.1) ≈ [0;;]
            @test H(x -> round(x, RoundNearestTiesAway), 1.1) ≈ [0;;]
            @test H(x -> round(x; digits = 3, base = 2), 1.1) ≈ [0;;]
        end

        @testset "Three-argument operators" begin
            @test H(x -> x * clamp(x, 0.0, 1.0), 0.5) == [1;;]
            @test H(x -> x * clamp(x, 0.0, 1.0), -0.5) == [0;;]
            @test H(x -> sum(x) * clamp(x[1], x[2], 1.0), [0.5, 0.0]) == [1 1; 1 0]
            @test H(x -> sum(x) * clamp(x[1], x[2], 1.0), [0.5, 0.6]) == [0 1; 1 1]
            @test H(x -> sum(x) * clamp(x[1], 0.0, x[2]), [0.5, 1.0]) == [1 1; 1 0]
            @test H(x -> sum(x) * clamp(x[1], 0.0, x[2]), [0.5, 0.4]) == [0 1; 1 1]
            @test H(x -> sum(x) * clamp(x[1], x[2], x[3]), [0.5, 0.0, 1.0]) ==
                [1 1 1; 1 0 0; 1 0 0]
            @test H(x -> sum(x) * clamp(x[1], x[2], x[3]), [0.5, 0.6, 1.0]) ==
                [0 1 0; 1 1 1; 0 1 0]
            @test H(x -> sum(x) * clamp(x[1], x[2], x[3]), [0.5, 0.0, 0.4]) ==
                [0 0 1; 0 0 1; 1 1 1]
        end

        @testset "Random" begin
            @test H(x -> rand(typeof(x)), 1) ≈ [0;;]
            @test H(x -> rand(GLOBAL_RNG, typeof(x)), 1) ≈ [0;;]
        end

        @testset "Zero-derivative functions" begin
            x = [1.5]
            ts = create_tracers(T, x, eachindex(x))
            d = Dual(x[1], ts[1])

            @testset "$f" for f in (round, floor, ceil, trunc, sign)
                result = f(d)
                # Z-type functions should return plain primal (fast path)
                @test !(result isa Dual)
                @test result == f(primal(d))
            end
        end

        @testset "1-to-2 functions" begin
            x = [0.5]
            ts = create_tracers(T, x, eachindex(x))
            d = Dual(x[1], ts[1])

            @testset "$f" for f in (sincos, sincosd, sincospi)
                result = f(d)
                @test result isa Tuple{<:Dual, <:Dual}

                # Check primal values are correct
                expected_primals = f(primal(d))
                @test primal(result[1]) == expected_primals[1]
                @test primal(result[2]) == expected_primals[2]

                # Check tracers are HessianTracers (not Duals - Bug 2 caused this)
                @test tracer(result[1]) isa T
                @test tracer(result[2]) isa T

                # Check sparsity patterns for each output
                @test H(x -> f(x)[1], 0.5) == [1;;]
                @test H(x -> f(x)[2], 0.5) == [1;;]
            end
        end

        yield()
    end
end

@testset "Shared HessianTracer - shared `hessian` fields" begin
    @testset "$T" for T in HESSIAN_TRACERS_SHARED

        function multi_output_for_shared_test(x::AbstractArray)
            z = ones(eltype(x), size(x))
            y1 = x[1]^2 * z[1]
            y2 = z[2] * x[2]^2
            y3 = x[1] * x[2]
            y4 = z[1] * z[2]  # entirely new tracer
            y = [y1, y2, y3, y4]
            return y
        end

        x = rand(2)
        xt = create_tracers(T, x, eachindex(x))
        yt = multi_output_for_shared_test(xt)

        @test hessian(yt[1]) === hessian(yt[2])
        @test hessian(yt[1]) === hessian(yt[3])
        @test_broken hessian(yt[1]) === hessian(yt[4])
    end
end

using ADTypes
using ADTypes: AbstractSparsityDetector
using ReferenceTests
using SparseConnectivityTracer
using SparseConnectivityTracerBenchmarks.ODE: Brusselator!
using Test

# Load definitions of GRADIENT_TRACERS and HESSIAN_TRACERS
include("tracers_definitions.jl")

function test_brusselator(detector::AbstractSparsityDetector)
    N = 6
    f! = Brusselator!(N)
    x = rand(N, N, 2)
    y = similar(x)

    J = ADTypes.jacobian_sparsity(f!, y, x, detector)
    return @test_reference "references/pattern/jacobian/Brusselator.txt" BitMatrix(J)
end

@testset "$T" for T in GRADIENT_TRACERS
    detector = TracerSparsityDetector(T)
    test_brusselator(detector)
    yield()
end

#=
Given an optimization problem `min f(x) s.t. c(x) <= 0`, we study

- the Jacobian of the constraints `c(x)`
- the Hessian of the Lagrangian `L(x,y) = f(x) + yᵀc(x)`

Package ecosystem overview: https://jso.dev/ecosystems/models/

- NLPModels.jl: abstract interface `AbstractNLPModel` for nonlinear optimization problems (with utilities to query objective, constraints, and their derivatives). See API at https://jso.dev/NLPModels.jl/stable/api/

- ADNLPModels.jl: concrete `ADNLPModel <: AbstractNLPModel` created from pure Julia code with autodiff
- NLPModelsJuMP.jl: concrete `MathOptNLPModel <: AbstractNLPModel` converted from a `JuMP.Model`

- OptimizationProblems.jl: suite of benchmark problems available in two formulations:
  - OptimizationProblems.ADNLPProblems: spits out `ADNLPModel`
  - OptimizationProblems.PureJuMP: spits out `JuMP.Model`
=#

# Obtained from `Symbol.(OptimizationProblems.meta[!, :name])`
const OPTIMIZATION_PROBLEM_NAMES = [
    :AMPGO02,
    :AMPGO03,
    :AMPGO04,
    :AMPGO05,
    :AMPGO06,
    :AMPGO07,
    :AMPGO08,
    :AMPGO09,
    :AMPGO10,
    :AMPGO11,
    :AMPGO12,
    :AMPGO13,
    :AMPGO14,
    :AMPGO15,
    :AMPGO18,
    :AMPGO20,
    :AMPGO21,
    :AMPGO22,
    :BOX2,
    :BOX3,
    :Dus2_1,
    :Dus2_3,
    :Dus2_9,
    :Duscube,
    :NZF1,
    :Shpak1,
    :Shpak2,
    :Shpak3,
    :Shpak4,
    :Shpak5,
    :Shpak6,
    :aircrfta,
    :allinit,
    :allinitc,
    :allinitu,
    :alsotame,
    :argauss,
    :arglina,
    :arglinb,
    :arglinc,
    :argtrig,
    :arwhead,
    :auglag,
    :avion2,
    :bard,
    :bdqrtic,
    :beale,
    :bearing,
    :bennett5,
    :biggs5,
    :biggs6,
    :booth,
    :boundary,
    :boxbod,
    :bqp1var,
    :britgas,
    :brownal,
    :brownbs,
    :brownden,
    :browngen1,
    :browngen2,
    :broyden3d,
    :broyden7d,
    :broydn7d,
    :brybnd,
    :bt1,
    :camshape,
    :catenary,
    # :catmix,
    :chain,
    :chainwoo,
    :channel,
    :chnrosnb_mod,
    :chwirut1,
    :chwirut2,
    :cliff,
    :clnlbeam,
    :clplatea,
    :clplateb,
    :clplatec,
    :controlinvestment,
    :cosine,
    :cragglvy,
    :cragglvy2,
    :curly,
    :curly10,
    :curly20,
    :curly30,
    :danwood,
    :dixmaane,
    :dixmaanf,
    :dixmaang,
    :dixmaanh,
    :dixmaani,
    :dixmaanj,
    :dixmaank,
    :dixmaanl,
    :dixmaanm,
    :dixmaann,
    :dixmaano,
    :dixmaanp,
    :dixon3dq,
    :dqdrtic,
    :dqrtic,
    :eckerle4,
    :edensch,
    :eg2,
    :elec,
    :engval1,
    :enso,
    :errinros_mod,
    :extrosnb,
    :fletcbv2,
    :fletcbv3_mod,
    :fletchcr,
    :fminsrf2,
    :freuroth,
    # :gasoil,
    :gauss1,
    :gauss2,
    :gauss3,
    :gaussian,
    :genbroydenb,
    :genbroydentri,
    :genhumps,
    :genrose,
    :genrose_nash,
    # :glider,
    :gulf,
    :hahn1,
    :helical,
    :hovercraft1d,
    :hs1,
    :hs10,
    :hs100,
    :hs101,
    :hs102,
    :hs103,
    :hs104,
    :hs105,
    :hs106,
    :hs107,
    :hs108,
    :hs109,
    :hs11,
    :hs110,
    :hs111,
    :hs112,
    :hs113,
    :hs114,
    :hs116,
    :hs117,
    :hs118,
    :hs119,
    :hs12,
    :hs13,
    :hs14,
    :hs15,
    :hs16,
    :hs17,
    :hs18,
    :hs19,
    :hs2,
    :hs20,
    :hs201,
    :hs21,
    :hs211,
    :hs219,
    :hs22,
    :hs220,
    :hs221,
    :hs222,
    :hs223,
    :hs224,
    :hs225,
    :hs226,
    :hs227,
    :hs228,
    :hs229,
    :hs23,
    :hs230,
    :hs231,
    :hs232,
    :hs233,
    :hs234,
    :hs235,
    :hs236,
    :hs237,
    :hs238,
    :hs239,
    :hs24,
    :hs240,
    :hs241,
    :hs242,
    :hs243,
    :hs244,
    :hs245,
    :hs246,
    :hs248,
    :hs249,
    :hs25,
    :hs250,
    :hs251,
    :hs252,
    :hs253,
    :hs254,
    :hs255,
    :hs256,
    :hs257,
    :hs258,
    :hs259,
    :hs26,
    :hs260,
    :hs261,
    :hs262,
    :hs263,
    :hs264,
    :hs265,
    :hs27,
    :hs28,
    :hs29,
    :hs3,
    :hs30,
    :hs31,
    :hs316,
    :hs317,
    :hs318,
    :hs319,
    :hs32,
    :hs320,
    :hs321,
    :hs322,
    :hs33,
    :hs34,
    :hs35,
    :hs36,
    :hs37,
    :hs378,
    :hs38,
    :hs39,
    :hs4,
    :hs40,
    :hs41,
    :hs42,
    :hs43,
    :hs44,
    :hs45,
    :hs46,
    :hs47,
    :hs48,
    :hs49,
    :hs5,
    :hs50,
    :hs51,
    :hs52,
    :hs53,
    :hs54,
    :hs55,
    :hs56,
    :hs57,
    :hs59,
    :hs6,
    :hs60,
    :hs61,
    :hs62,
    :hs63,
    :hs64,
    :hs65,
    :hs66,
    :hs68,
    :hs69,
    :hs7,
    :hs70,
    :hs71,
    :hs72,
    :hs73,
    :hs74,
    :hs75,
    :hs76,
    :hs77,
    :hs78,
    :hs79,
    :hs8,
    :hs80,
    :hs81,
    :hs83,
    :hs84,
    :hs86,
    :hs87,
    :hs9,
    :hs93,
    :hs95,
    :hs96,
    :hs97,
    :hs98,
    :hs99,
    :indef_mod,
    :integreq,
    :jennrichsampson,
    :kirby2,
    :kowosb,
    :lanczos1,
    :lanczos2,
    :lanczos3,
    :liarwhd,
    :lincon,
    :linsv,
    :marine,
    # :methanol,
    :meyer3,
    :mgh01feas,
    :mgh09,
    :mgh10,
    :mgh17,
    # :minsurf,
    :misra1a,
    :misra1b,
    :misra1c,
    :misra1d,
    :morebv,
    :nasty,
    :nazareth,
    :ncb20,
    :ncb20b,
    :nelson,
    :noncvxu2,
    :noncvxun,
    :nondia,
    :nondquar,
    :osborne1,
    :osborne2,
    :palmer1c,
    :palmer1d,
    :palmer2c,
    :palmer3c,
    :palmer4c,
    :palmer5c,
    :palmer5d,
    :palmer6c,
    :palmer7c,
    :palmer8c,
    :penalty1,
    :penalty2,
    :penalty3,
    # :pinene,
    :polygon,
    :polygon1,
    :polygon2,
    :polygon3,
    :powellbs,
    :powellsg,
    :power,
    :quartc,
    :rat42,
    :rat43,
    :robotarm,
    # :rocket,
    :rosenbrock,
    :rozman1,
    :sbrybnd,
    :schmvett,
    :scosine,
    :sinquad,
    :sparsine,
    :sparsqur,
    :spmsrtls,
    :srosenbr,
    # :steering,
    :structural,
    :tetra,
    :tetra_duct12,
    :tetra_duct15,
    :tetra_duct20,
    :tetra_foam5,
    :tetra_gear,
    :tetra_hook,
    :threepk,
    :thurber,
    :tointgss,
    # :torsion,
    :tquartic,
    :triangle,
    :triangle_deer,
    :triangle_pacman,
    :triangle_turtle,
    :tridia,
    :vardim,
    :variational,
    :vibrbeam,
    :watson,
    :woods,
    :zangwil3,
]

## SCT

#=
Here we use OptimizationProblems.ADNLPProblems because we need the problems in pure Julia.

https://jso.dev/OptimizationProblems.jl/stable/tutorial/#Problems-in-ADNLPModel-syntax:-ADNLPProblems
=#

function myconstraints(nlp::AbstractNLPModel, x::AbstractVector)
    c = similar(x, nlp.meta.ncon)
    NLPModels.cons!(nlp, x, c)
    return c
end

function mylagrangian(nlp::AbstractNLPModel, x::AbstractVector)
    f = NLPModels.obj(nlp, x)
    c = myconstraints(nlp, x)
    y = randn(length(c))
    L = f + dot(y, c)
    return L
end

function compute_jac_sparsity_sct(nlp::AbstractNLPModel)
    c = Base.Fix1(myconstraints, nlp)
    x0 = nlp.meta.x0
    jac_sparsity = ADTypes.jacobian_sparsity(c, x0, TracerSparsityDetector())
    return jac_sparsity
end

function compute_hess_sparsity_sct(nlp::AbstractNLPModel)
    L = Base.Fix1(mylagrangian, nlp)
    x0 = nlp.meta.x0
    hess_sparsity = ADTypes.hessian_sparsity(L, x0, TracerSparsityDetector())
    return hess_sparsity
end

function compute_jac_and_hess_sparsity_sct(name::Symbol)
    nlp = OptimizationProblems.ADNLPProblems.eval(name)()
    return compute_jac_sparsity_sct(nlp), compute_hess_sparsity_sct(nlp)
end

## Generic

function compute_jac_sparsity_and_value(nlp::AbstractNLPModel)
    n, m = nlp.meta.nvar, nlp.meta.ncon
    x0 = nlp.meta.x0
    I, J = NLPModels.jac_structure(nlp)
    V = NLPModels.jac_coord(nlp, x0)
    jac_sparsity = sparse(I, J, ones(Bool, length(I)), m, n)
    jac = sparse(I, J, V, m, n)
    return jac_sparsity, jac
end

function compute_hess_sparsity_and_value(nlp::AbstractNLPModel)
    n, m = nlp.meta.nvar, nlp.meta.ncon
    x0 = nlp.meta.x0
    yrand = rand(m)
    I, J = NLPModels.hess_structure(nlp)
    V = NLPModels.hess_coord(nlp, x0, yrand)
    hess_sparsity = sparse(Symmetric(sparse(I, J, ones(Bool, length(I)), n, n), :L))
    hess = sparse(Symmetric(sparse(I, J, V, n, n), :L))
    return hess_sparsity, hess
end

## JuMP

#=
Here we use OptimizationProblems.PureJuMP because JuMP is the ground truth, but we translate with NLPModelsJuMP to easily query the stuff we need. 

https://jso.dev/OptimizationProblems.jl/stable/tutorial/#Problems-in-JuMP-syntax:-PureJuMP
https://jso.dev/NLPModelsJuMP.jl/stable/tutorial/#MathOptNLPModel
=#

function compute_jac_and_hess_sparsity_and_value_jump(name::Symbol)
    nlp_jump = OptimizationProblems.PureJuMP.eval(name)()
    nlp = NLPModelsJuMP.MathOptNLPModel(nlp_jump)
    jac_sparsity, jac = compute_jac_sparsity_and_value(nlp)
    hess_sparsity, hess = compute_hess_sparsity_and_value(nlp)
    return ((jac_sparsity, jac), (hess_sparsity, hess))
end

using Pkg
Pkg.develop(;
    path = joinpath(@__DIR__, "..", "benchmark", "SparseConnectivityTracerBenchmarks")
)

using SparseConnectivityTracer
using Documenter: Documenter, DocMeta
using Test, LinearAlgebra

DocMeta.setdocmeta!(
    SparseConnectivityTracer,
    :DocTestSetup,
    :(using SparseConnectivityTracer);
    recursive = true,
)

GROUP = get(ENV, "JULIA_SCT_TEST_GROUP", "Core")

@testset verbose = true "SparseConnectivityTracer.jl" begin
    if GROUP in ("Core", "All")
        @testset verbose = true "Linting" begin
            @info "Testing linting..."
            include("linting.jl")
        end
    end
    if GROUP in ("Core", "All")
        @testset "Doctests" begin
            Documenter.doctest(SparseConnectivityTracer)
        end
    end

    if GROUP in ("Core", "All")
        @info "Testing operator classification..."
        @testset "Operator classification" begin
            include("classification.jl")
        end
    end

    if GROUP in ("Core", "All")
        @info "Testing simple examples..."
        @testset verbose = true "Simple examples" begin
            @testset "Tracer Construction" begin
                include("test_constructors.jl")
            end
            @testset "GradientTracer" begin
                include("test_gradient.jl")
            end
            @testset "HessianTracer" begin
                include("test_hessian.jl")
            end
            @testset "Buffer allocation" begin
                include("test_buffers.jl")
            end
            @testset "Array overloads" begin
                include("test_arrays.jl")
            end
            @testset "ComponentArrays" begin
                include("componentarrays.jl")
            end
        end
    end
    if GROUP in ("Core", "All")
        @info "Testing package extensions..."
        @testset verbose = true "Package extensions" begin
            for ext in (:LogExpFunctions, :NaNMath, :NNlib, :SpecialFunctions, :ChainRulesCore)
                @testset "$ext" begin
                    @info "...$ext"
                    include("ext/test_$ext.jl")
                end
            end
        end
    end

    if GROUP in ("Core", "All")
        @info "Testing real-world examples..."
        @testset verbose = true "Real-world examples" begin
            @testset "Brusselator" begin
                include("brusselator.jl")
            end
            if pkgversion(NNlib) >= v"0.9.18" # contains NNlib PR #592
                @testset "Flux.jl" begin
                    include("flux.jl")
                end
            end
        end
    end

    if GROUP in ("Core", "All")
        @info "Testing ADTypes integration..."
        @testset "ADTypes integration" begin
            include("adtypes.jl")
        end
    end

    if GROUP in ("Benchmarks", "All")
        @info "Testing benchmarks correctness..."
        @testset "Benchmarks correctness" begin
            include("benchmarks_correctness.jl")
        end
    end

    if GROUP in ("NLPModels", "All")
        @info "Testing NLPModels..."
        @testset "NLPModels" begin
            include("nlpmodels.jl")
        end
    end
end

using SparseConnectivityTracer
using NaNMath
using Test

# Load definitions of GRADIENT_TRACERS and HESSIAN_TRACERS
include("../tracers_definitions.jl")

nan_1_to_1 = (
    NaNMath.sqrt,
    NaNMath.sin,
    NaNMath.cos,
    NaNMath.tan,
    NaNMath.asin,
    NaNMath.acos,
    NaNMath.acosh,
    NaNMath.atanh,
    NaNMath.log,
    NaNMath.log2,
    NaNMath.log10,
    NaNMath.log1p,
    NaNMath.lgamma,
)

@testset "Jacobian Global" begin
    detector = TracerSparsityDetector()
    J(f, x) = jacobian_sparsity(f, x, detector)

    @testset "1-to-1 functions" begin
        @testset "$f" for f in nan_1_to_1
            @test J(x -> f(x[1]), rand(2)) == [1 0]
        end
    end
    @testset "2-to-1 functions" begin
        @test J(x -> NaNMath.pow(x[1], x[2]), rand(3)) == [1 1 0]
        @test J(x -> NaNMath.pow(x[1], 2), rand(3)) == [1 0 0]  # Issue #291
        @test J(x -> NaNMath.max(x[1], x[2]), rand(3)) == [1 1 0]
        @test J(x -> NaNMath.min(x[1], x[2]), rand(3)) == [1 1 0]
    end
end

@testset "Jacobian Local" begin
    detector = TracerLocalSparsityDetector()
    J(f, x) = jacobian_sparsity(f, x, detector)

    @testset "2-to-1 functions" begin
        @test J(x -> NaNMath.max(x[1], x[2]), [1.0, 2.0, 0.0]) == [0 1 0]
        @test J(x -> NaNMath.max(x[1], x[2]), [2.0, 1.0, 0.0]) == [1 0 0]
        @test J(x -> NaNMath.min(x[1], x[2]), [1.0, 2.0, 0.0]) == [1 0 0]
        @test J(x -> NaNMath.min(x[1], x[2]), [2.0, 1.0, 0.0]) == [0 1 0]
    end
end

@testset "Hessian Global" begin
    detector = TracerSparsityDetector()
    H(f, x) = hessian_sparsity(f, x, detector)

    @testset "1-to-1 functions" begin
        @testset "$f" for f in nan_1_to_1
            @test H(x -> f(x[1]), rand(2)) == [1 0; 0 0]
        end
    end
    @testset "2-to-1 functions" begin
        @test H(x -> NaNMath.pow(x[1], x[2]), rand(3)) == [1 1 0; 1 1 0; 0 0 0]
        @test H(x -> NaNMath.pow(x[1], 2), rand(3)) == [1 0 0; 0 0 0; 0 0 0]  # Issue #291
        @test H(x -> NaNMath.max(x[1], x[2]), rand(3)) == zeros(Bool, 3, 3)
        @test H(x -> NaNMath.min(x[1], x[2]), rand(3)) == zeros(Bool, 3, 3)
    end
end

@testset "Hessian Local" begin
    detector = TracerLocalSparsityDetector()
    H(f, x) = hessian_sparsity(f, x, detector)

    @testset "2-to-1 functions" begin
        @test H(x -> NaNMath.max(x[1], x[2]), [1.0, 2.0, 0.0]) == zeros(Bool, 3, 3)
        @test H(x -> NaNMath.max(x[1], x[2]), [2.0, 1.0, 0.0]) == zeros(Bool, 3, 3)
        @test H(x -> NaNMath.min(x[1], x[2]), [1.0, 2.0, 0.0]) == zeros(Bool, 3, 3)
        @test H(x -> NaNMath.min(x[1], x[2]), [2.0, 1.0, 0.0]) == zeros(Bool, 3, 3)
    end
end

using ADTypes: jacobian_sparsity, hessian_sparsity
using SparseConnectivityTracer
using SparseConnectivityTracer: GradientTracer, HessianTracer, Shared, NotShared
using SparseConnectivityTracer: DEFAULT_GRADIENT_TRACER, DEFAULT_HESSIAN_TRACER, DEFAULT_SHARED_TYPE
using SparseArrays
using Test

@testset "Global" begin
    sd = TracerSparsityDetector()

    x = rand(10)
    y = zeros(9)
    J1 = jacobian_sparsity(diff, x, sd)
    J2 = jacobian_sparsity((y, x) -> y .= diff(x), y, x, sd)
    @test J1 == J2
    @test J1 isa SparseMatrixCSC{Bool, Int}
    @test J2 isa SparseMatrixCSC{Bool, Int}
    @test nnz(J1) == nnz(J2) == 18

    H1 = hessian_sparsity(x -> sum(diff(x)), x, sd)
    @test H1 ≈ zeros(10, 10)

    x = rand(5)
    f(x) = x[1] + x[2] * x[3] + 1 / x[4] + 1 * x[5]
    H2 = hessian_sparsity(f, x, sd)
    @test H2 isa SparseMatrixCSC{Bool, Int}
    @test H2 ≈ [
        0 0 0 0 0
        0 0 1 0 0
        0 1 0 0 0
        0 0 0 1 0
        0 0 0 0 0
    ]
end

@testset "Local" begin
    lsd = TracerLocalSparsityDetector()
    fl1(x) = x[1] + x[2] * x[3] + 1 / x[4] + x[2] * max(x[1], x[5])
    HL1 = hessian_sparsity(fl1, [1.0 3.0 5.0 1.0 2.0], lsd)
    @test HL1 ≈ [
        0  0  0  0  0
        0  0  1  0  1
        0  1  0  0  0
        0  0  0  1  0
        0  1  0  0  0
    ]
    HL2 = hessian_sparsity(fl1, [4.0 3.0 5.0 1.0 2.0], lsd)
    @test HL2 ≈ [
        0  1  0  0  0
        1  0  1  0  0
        0  1  0  0  0
        0  0  0  1  0
        0  0  0  0  0
    ]
end

@testset "Constructor" begin
    TG = DEFAULT_GRADIENT_TRACER
    TH = DEFAULT_HESSIAN_TRACER

    @test TracerSparsityDetector() isa TracerSparsityDetector{TG, TH}
    @test TracerLocalSparsityDetector() isa TracerLocalSparsityDetector{TG, TH}

    ## Gradient
    G = Set{Int16}
    @test TracerSparsityDetector(; gradient_pattern_type = G) isa TracerSparsityDetector{GradientTracer{Int16, Set{Int16}}, TH}
    @test TracerLocalSparsityDetector(; gradient_pattern_type = G) isa TracerLocalSparsityDetector{GradientTracer{Int16, Set{Int16}}, TH}
    @test_throws TypeError TracerSparsityDetector(; gradient_pattern_type = Set{Float32})
    @test_throws TypeError TracerLocalSparsityDetector(; gradient_pattern_type = Set{Float32})
    @test_throws MethodError TracerSparsityDetector(; gradient_pattern_type = Dict{Int, Set{Int}})
    @test_throws MethodError TracerLocalSparsityDetector(; gradient_pattern_type = Dict{Int, Set{Int}})

    ## Hessian
    # Dict
    H = Dict{UInt8, Set{UInt8}}
    @test TracerSparsityDetector(; hessian_pattern_type = H) isa TracerSparsityDetector{TG, HessianTracer{UInt8, Set{UInt8}, Dict{UInt8, Set{UInt8}}, NotShared}}
    @test TracerLocalSparsityDetector(; hessian_pattern_type = H) isa TracerLocalSparsityDetector{TG, HessianTracer{UInt8, Set{UInt8}, Dict{UInt8, Set{UInt8}}, NotShared}}
    @test_throws TypeError TracerSparsityDetector(; hessian_pattern_type = Dict{Int, Set{Float32}})
    @test_throws TypeError TracerLocalSparsityDetector(; hessian_pattern_type = Dict{Int, Set{Float32}})
    @test_throws MethodError TracerSparsityDetector(; hessian_pattern_type = BitSet)
    @test_throws MethodError TracerLocalSparsityDetector(; hessian_pattern_type = BitSet)

    # Set of Tuples
    H = Set{Tuple{UInt32, UInt32}}
    @test TracerSparsityDetector(; hessian_pattern_type = H) isa TracerSparsityDetector{TG, HessianTracer{UInt32, Set{UInt32}, Set{Tuple{UInt32, UInt32}}, NotShared}}
    @test TracerLocalSparsityDetector(; hessian_pattern_type = H) isa TracerLocalSparsityDetector{TG, HessianTracer{UInt32, Set{UInt32}, Set{Tuple{UInt32, UInt32}}, NotShared}}
    @test_throws TypeError TracerSparsityDetector(; hessian_pattern_type = Set{Tuple{Float32, Float32}})
    @test_throws TypeError TracerLocalSparsityDetector(; hessian_pattern_type = Set{Tuple{Float32, Float32}})

    ## Shared
    @test TracerSparsityDetector(; shared_hessian_pattern = true) isa TracerSparsityDetector{TG, HessianTracer{Int64, BitSet, Dict{Int64, BitSet}, Shared}}
    @test TracerLocalSparsityDetector(; shared_hessian_pattern = true) isa TracerLocalSparsityDetector{TG, HessianTracer{Int64, BitSet, Dict{Int64, BitSet}, Shared}}
end

## Rounding
Base.round(t::T, ::RoundingMode; kwargs...) where {T <: AbstractTracer} = myempty(T)

function Base.round(
        d::D, mode::RoundingMode; kwargs...
    ) where {P, T <: AbstractTracer, D <: Dual{P, T}}
    return round(primal(d), mode; kwargs...) # only return primal
end

for RR in (Real, Integer, Bool)
    Base.round(::Type{R}, ::T) where {R <: RR, T <: AbstractTracer} = myempty(T)
    function Base.round(::Type{R}, d::D) where {R <: RR, P, T <: AbstractTracer, D <: Dual{P, T}}
        return round(R, primal(d)) # only return primal
    end
end

## Random numbers
Base.rand(::AbstractRNG, ::SamplerType{T}) where {T <: AbstractTracer} = myempty(T)
function Base.rand(
        rng::AbstractRNG, ::SamplerType{D}
    ) where {P, T <: AbstractTracer, D <: Dual{P, T}}
    p = rand(rng, P)
    # This unfortunately can't just return the primal value.
    # Random.jl will otherwise throw "TypeError: in typeassert, expected Dual{P,T}, got a value of type P".
    t = myempty(T)
    return Dual(p, t)
end

#= This file implements the ADTypes interface for `AbstractSparsityDetector`s =#
const DEFAULT_SET_TYPE = BitSet
const DEFAULT_DICT_TYPE = Dict{eltype(DEFAULT_SET_TYPE), DEFAULT_SET_TYPE}
const DEFAULT_SHARED_TYPE = NotShared

function gradient_tracer_type(
        ::Type{G} = DEFAULT_SET_TYPE
    ) where {G <: AbstractSet}
    I = eltype(G)
    return GradientTracer{I, G}
end

function hessian_tracer_type(
        ::Type{H} = DEFAULT_DICT_TYPE, ::Type{S} = DEFAULT_SHARED_TYPE
    ) where {H <: AbstractDict, S <: SharingBehavior}
    I = keytype(H)
    G = valtype(H)
    return HessianTracer{I, G, H, S}
end

function hessian_tracer_type(
        ::Type{H}, ::Type{S} = DEFAULT_SHARED_TYPE
    ) where {I, H <: Set{Tuple{I, I}}, S <: SharingBehavior}
    G = Set{I}
    return HessianTracer{I, G, H, S}
end

const DEFAULT_GRADIENT_TRACER = gradient_tracer_type()
const DEFAULT_HESSIAN_TRACER = hessian_tracer_type()


const DOC_KWARGS = """# Keyword arguments
- `gradient_pattern_type::Type`: 
  Data structure used for bookkeeping of gradient sparsity patterns, used in `jacobian_sparsity`.
  Supports concrete subtypes of `AbstactSet{<:Integer}`.
  Defaults to `$DEFAULT_SET_TYPE`.
- `hessian_pattern_type::Type`: 
  Data structure used for bookkeeping of Hessian sparsity patterns, used in `hessian_sparsity`.
  Supports concrete subtypes of `AbstractDict{I, AbstractSet{I}}` or `AbstractSet{Tuple{I, I}}`, where `I <: Integer`.
  Defaults to `$DEFAULT_DICT_TYPE`.
- `shared_hessian_pattern::Bool`: 
  Indicate whether second-order information in Hessian sparsity patterns **always** shares memory and whether operators are **allowed** to mutate `HessianTracers`.
  Defaults to `false`.

If support for further pattern representations is needed, please open a feature request:
https://github.com/adrhill/SparseConnectivityTracer.jl/issues
"""

"""
    TracerSparsityDetector()

Global sparsity detection over the entire input domain using SparseConnectivityTracer.jl. 
For use with [ADTypes.jl](https://github.com/SciML/ADTypes.jl)'s `AbstractSparsityDetector` interface.

For local sparsity patterns, use [`TracerLocalSparsityDetector`](@ref).

$DOC_KWARGS

# Example

```jldoctest
julia> using SparseConnectivityTracer

julia> detector = TracerSparsityDetector()
TracerSparsityDetector()

julia> jacobian_sparsity(diff, rand(4), detector)
3×4 SparseArrays.SparseMatrixCSC{Bool, Int64} with 6 stored entries:
 1  1  ⋅  ⋅
 ⋅  1  1  ⋅
 ⋅  ⋅  1  1

julia> f(x) = x[1] + x[2]*x[3] + 1/x[4];

julia> hessian_sparsity(f, rand(4), detector)
4×4 SparseArrays.SparseMatrixCSC{Bool, Int64} with 3 stored entries:
 ⋅  ⋅  ⋅  ⋅
 ⋅  ⋅  1  ⋅
 ⋅  1  ⋅  ⋅
 ⋅  ⋅  ⋅  1
```

## References

- A. Hill and G. Dalle (2025). [*"Sparser, Better, Faster, Stronger: Sparsity Detection for Efficient Automatic Differentiation"*](https://openreview.net/forum?id=GtXSN52nIW)
- A. Hill, G. Dalle, A. Montoison (2025). [*"An Illustrated Guide to Automatic Sparse Differentiation"*](https://iclr-blogposts.github.io/2025/blog/sparse-autodiff/)
"""
struct TracerSparsityDetector{TG <: GradientTracer, TH <: HessianTracer} <:
    ADTypes.AbstractSparsityDetector end

"""
    TracerLocalSparsityDetector()

Local sparsity detection using SparseConnectivityTracer.jl. 
For use with [ADTypes.jl](https://github.com/SciML/ADTypes.jl)'s `AbstractSparsityDetector` interface.

For global sparsity patterns, use [`TracerSparsityDetector`](@ref).

$DOC_KWARGS

# Example

Local sparsity patterns are less convervative than global patterns and need to be recomputed for each input `x`:

```jldoctest
julia> using SparseConnectivityTracer

julia> detector = TracerLocalSparsityDetector()
TracerLocalSparsityDetector()

julia> f(x) = x[1] * x[2]; # J_f = [x[2], x[1]]

julia> jacobian_sparsity(f, [1, 0], detector)
1×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 1 stored entry:
 ⋅  1

julia> jacobian_sparsity(f, [0, 1], detector)
1×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 1 stored entry:
 1  ⋅

julia> jacobian_sparsity(f, [0, 0], detector)
1×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 0 stored entries:
 ⋅  ⋅

julia> jacobian_sparsity(f, [1, 1], detector)
1×2 SparseArrays.SparseMatrixCSC{Bool, Int64} with 2 stored entries:
 1  1
```

## References

- A. Hill and G. Dalle (2025). [*"Sparser, Better, Faster, Stronger: Sparsity Detection for Efficient Automatic Differentiation"*](https://openreview.net/forum?id=GtXSN52nIW)
- A. Hill, G. Dalle, A. Montoison (2025). [*"An Illustrated Guide to Automatic Sparse Differentiation"*](https://iclr-blogposts.github.io/2025/blog/sparse-autodiff/)
"""
struct TracerLocalSparsityDetector{TG <: GradientTracer, TH <: HessianTracer} <:
    ADTypes.AbstractSparsityDetector end

#==========================#
# Convenience constructors #
#==========================#

for D in (:TracerSparsityDetector, :TracerLocalSparsityDetector)
    # Specity both tracer types as arguments (stable, but not public/documented)
    @eval ($D)(::Type{TG}, ::Type{TH}) where {TG <: GradientTracer, TH <: HessianTracer} = ($D){TG, TH}()

    # Only specify one tracer type, fall back to default for other (stable, but not public/documented)
    @eval ($D)(::Type{TG}) where {TG <: GradientTracer} = ($D){TG, DEFAULT_HESSIAN_TRACER}()
    @eval ($D)(::Type{TH}) where {TH <: HessianTracer} = ($D){DEFAULT_GRADIENT_TRACER, TH}()

    # Convenience constructor: Only provide pattern types (public/documented in `DOC_KWARGS`)
    @eval function ($D)(;
            gradient_pattern_type::Type{G} = DEFAULT_SET_TYPE,
            hessian_pattern_type::Type{H} = DEFAULT_DICT_TYPE,
            shared_hessian_pattern::Bool = false,
        ) where {G, H}
        S = shared_hessian_pattern ? Shared : NotShared
        TG = gradient_tracer_type(G)
        TH = hessian_tracer_type(H, S)
        return ($D)(TG, TH)
    end

    # Pretty printing
    @eval function Base.show(io::IO, d::$D{TG, TH}) where {TG, TH}
        if TG == DEFAULT_GRADIENT_TRACER && TH == DEFAULT_HESSIAN_TRACER
            print(io, $D, "()")
        else
            print(io, $D, "{", TG, ",", TH, "}()")
        end
        return nothing
    end
end

#===============#
# ADTypes calls #
#===============#

# Global
function ADTypes.jacobian_sparsity(f, x, ::TracerSparsityDetector{TG, TH}) where {TG, TH}
    return _jacobian_sparsity(f, x, TG)
end

function ADTypes.jacobian_sparsity(f!, y, x, ::TracerSparsityDetector{TG, TH}) where {TG, TH}
    return _jacobian_sparsity(f!, y, x, TG)
end

function ADTypes.hessian_sparsity(f, x, ::TracerSparsityDetector{TG, TH}) where {TG, TH}
    return _hessian_sparsity(f, x, TH)
end

# Local
function ADTypes.jacobian_sparsity(f, x, ::TracerLocalSparsityDetector{TG, TH}) where {TG, TH}
    return _local_jacobian_sparsity(f, x, TG)
end

function ADTypes.jacobian_sparsity(
        f!, y, x, ::TracerLocalSparsityDetector{TG, TH}
    ) where {TG, TH}
    return _local_jacobian_sparsity(f!, y, x, TG)
end

function ADTypes.hessian_sparsity(f, x, ::TracerLocalSparsityDetector{TG, TH}) where {TG, TH}
    return _local_hessian_sparsity(f, x, TH)
end


#============#
# Allocation #
#============#

# Stable API to allow packages like DI to allocate caches of tracers

"""
    jacobian_eltype(x, detector)

Act like `eltype(x)` but return the matching number type used inside Jacobian sparsity detection.
"""
jacobian_eltype(x, ::TracerSparsityDetector{TG}) where {TG} = TG
function jacobian_eltype(x, ::TracerLocalSparsityDetector{TG}) where {TG}
    return Dual{eltype(x), TG}
end

"""
    hessian_eltype(x, detector)

Act like `eltype(x)` but return the matching number type used inside Hessian sparsity detection.
"""
hessian_eltype(x, ::TracerSparsityDetector{TG, TH}) where {TG, TH} = TH
function hessian_eltype(x, ::TracerLocalSparsityDetector{TG, TH}) where {TG, TH}
    return Dual{eltype(x), TH}
end

"""
    jacobian_buffer(x, detector)

Allocate a buffer similiar to `x` with the required tracer type for Jacobian sparsity detection.
Thin wrapper around `similar` that doesn't expose internal types.
"""
function jacobian_buffer(
        x, detector::Union{TracerSparsityDetector, TracerLocalSparsityDetector}
    )
    return similar(x, jacobian_eltype(x, detector))
end

"""
    hessian_buffer(x, detector)

Allocate a buffer similiar to `x` with the required tracer type for Hessian sparsity detection.
Thin wrapper around `similar` that doesn't expose internal types.
"""
function hessian_buffer(
        x, detector::Union{TracerSparsityDetector, TracerLocalSparsityDetector}
    )
    return similar(x, hessian_eltype(x, detector))
end

using SparseConnectivityTracer
using SparseConnectivityTracer: GradientTracer, HessianTracer, Dual
using Test

# Load definitions of GRADIENT_TRACERS and HESSIAN_TRACERS
include("tracers_definitions.jl")

@testset "Jacobian" begin
    P = Float32
    x = rand(P, 3, 2)
    @testset "$T" for T in GRADIENT_TRACERS
        D = Dual{P, T}
        @testset "Global" begin
            detector = TracerSparsityDetector(T)
            buff = jacobian_buffer(x, detector)
            @test size(buff) == (3, 2)
            @test eltype(buff) == T
        end
        @testset "Local" begin
            detector = TracerLocalSparsityDetector(T)
            buff = jacobian_buffer(x, detector)
            @test size(buff) == (3, 2)
            @test eltype(buff) == D
        end
    end
end

@testset "Hessian" begin
    P = Float32
    x = rand(P, 3, 2)
    @testset "$T" for T in HESSIAN_TRACERS
        D = Dual{P, T}
        @testset "Global" begin
            detector = TracerSparsityDetector(T)
            buff = hessian_buffer(x, detector)
            @test size(buff) == (3, 2)
            @test eltype(buff) == T
        end
        @testset "Local" begin
            detector = TracerLocalSparsityDetector(T)
            buff = hessian_buffer(x, detector)
            @test size(buff) == (3, 2)
            @test eltype(buff) == D
        end
    end
end

module SparseConnectivityTracerLogExpFunctionsExt

import SparseConnectivityTracer as SCT
using LogExpFunctions:
    LogExpFunctions,
    cexpexp,
    cloglog,
    log1mexp,
    log1mlogistic,
    log1pexp,
    log1pmx,
    log1psq,
    log2mexp,
    logabssinh,
    logaddexp,
    logcosh,
    logexpm1,
    logistic,
    logit,
    logit1mexp,
    logitexp,
    loglogistic,
    logmxp1,
    logsubexp,
    xexpx,
    xexpy,
    xlog1py,
    xlogx,
    xlogy

## 1-to-1 functions

ops_1_to_1 = (
    xlogx,
    xexpx,
    logistic,
    logit,
    logcosh,
    logabssinh,
    log1psq,
    log1pexp,
    log1mexp,
    log2mexp,
    logexpm1,
    log1pmx,
    logmxp1,
    cloglog,
    cexpexp,
    loglogistic,
    logitexp,
    log1mlogistic,
    logit1mexp,
    # softplus, # alias for log1pexp
    # invsoftplus, # alias for logexpm1
)

for op in ops_1_to_1
    T = typeof(op)
    @eval SCT.is_der1_zero_global(::$T) = false
    @eval SCT.is_der2_zero_global(::$T) = false
end

## 2-to-1 functions

ops_2_to_1 = (xlogy, xlog1py, xexpy, logaddexp, logsubexp)

for op in ops_2_to_1
    T = typeof(op)
    @eval SCT.is_der1_arg1_zero_global(::$T) = false
    @eval SCT.is_der2_arg1_zero_global(::$T) = false
    @eval SCT.is_der1_arg2_zero_global(::$T) = false
    @eval SCT.is_der2_arg2_zero_global(::$T) = false
    @eval SCT.is_der_cross_zero_global(::$T) = false
end

## Generate overloads
eval(SCT.generate_code_1_to_1(:LogExpFunctions, ops_1_to_1))
eval(SCT.generate_code_2_to_1(:LogExpFunctions, ops_2_to_1))

## List operators for later testing
SCT.test_operators_1_to_1(::Val{:LogExpFunctions}) = ops_1_to_1
SCT.test_operators_2_to_1(::Val{:LogExpFunctions}) = ops_2_to_1
SCT.test_operators_1_to_2(::Val{:LogExpFunctions}) = ()

end # module

#===============#
# FillArrays.jl #
#===============#

# Since v1.17, FillArrays' reduction fast paths call `iszero`/`isone` on the fill value,
# which global tracers deliberately answer with a `MissingPrimalError`,
# so reductions of tracer `Fill`s get exact O(1) overloads.

function Base.sum(A::AbstractFill{T}; dims = :) where {T <: AbstractTracer}
    t = isempty(A) ? myempty(T) : getindex_value(A)
    dims isa Colon && return t
    return Fill(t, Base.reduced_indices(axes(A), dims))
end

# `second_order_or` degrades to a plain union on `GradientTracer`s,
# so a single method is exact for both tracer types.
function Base.prod(A::AbstractFill{T}; dims = :) where {T <: AbstractTracer}
    t = getindex_value(A)
    if dims isa Colon
        isempty(A) && return myempty(T)
        length(A) == 1 && return t
        return second_order_or(t, t)
    end
    ri = Base.reduced_indices(axes(A), dims)
    isempty(A) && return Fill(myempty(T), ri)
    length(A) == prod(length, ri) && return Fill(t, ri) # one element per output slice
    return Fill(second_order_or(t, t), ri)
end

#= Parse tracers from function evaluation in `src/trace_functions.jl` into an output matrix. =#

_tracer_or_number(x::Real) = x
_tracer_or_number(d::Dual) = tracer(d)

#==========#
# Jacobian #
#==========#

function jacobian_tracers_to_matrix(
        xt::AbstractArray{T}, yt::AbstractArray
    ) where {T <: GradientTracer}
    n, m = length(xt), length(yt)
    I = Int[] # row indices
    J = Int[] # column indices
    V = Bool[]   # values
    for (i, y) in enumerate(yt)
        if y isa T && !isemptytracer(y)
            for j in gradient(y)
                push!(I, i)
                push!(J, j)
                push!(V, true)
            end
        end
    end
    return sparse(I, J, V, m, n)
end

function jacobian_tracers_to_matrix(
        xt::AbstractArray{D}, yt::AbstractArray
    ) where {P, T <: GradientTracer, D <: Dual{P, T}}
    return jacobian_tracers_to_matrix(tracer.(xt), _tracer_or_number.(yt))
end

#=========#
# Hessian #
#=========#

function hessian_tracers_to_matrix(xt::AbstractArray{T}, yt::T) where {T <: HessianTracer}
    n = length(xt)
    I = Int[] # row indices
    J = Int[] # column indices
    V = Bool[]   # values

    if !isemptytracer(yt)
        for (i, j) in tuple_set(hessian(yt))
            push!(I, i)
            push!(J, j)
            push!(V, true)
            # Write twice instead of returning `Symmetric`
            push!(I, j)
            push!(J, i)
            push!(V, true)
        end
    end
    h = sparse(I, J, V, n, n)
    return h
end

function hessian_tracers_to_matrix(
        xt::AbstractArray{D1}, yt::D2
    ) where {P1, P2, T <: HessianTracer, D1 <: Dual{P1, T}, D2 <: Dual{P2, T}}
    return hessian_tracers_to_matrix(tracer.(xt), tracer(yt))
end

function hessian_tracers_to_matrix(
        xt::AbstractArray{T}, yt::Number
    ) where {T <: HessianTracer}
    return hessian_tracers_to_matrix(xt, myempty(T))
end

function hessian_tracers_to_matrix(
        xt::AbstractArray{D1}, yt::Number
    ) where {P1, T <: HessianTracer, D1 <: Dual{P1, T}}
    return hessian_tracers_to_matrix(tracer.(xt), myempty(T))
end

module SparseConnectivityTracerSpecialFunctionsExt

import SparseConnectivityTracer as SCT
using SpecialFunctions:
    SpecialFunctions,
    airyai,
    airyaiprime,
    airyaiprimex,
    airyaix,
    airybi,
    airybiprime,
    airybiprimex,
    airybix,
    besseli,
    besselix,
    besselj,
    besselj0,
    besselj1,
    besseljx,
    besselk,
    besselkx,
    bessely,
    bessely0,
    bessely1,
    besselyx,
    beta,
    cosint,
    digamma,
    ellipe,
    ellipk,
    erf,
    erfc,
    erfcinv,
    erfcx,
    erfinv,
    expint,
    expinti,
    expintx,
    gamma,
    invdigamma,
    jinc,
    logbeta,
    logerfc,
    loggamma,
    sinint,
    sphericalbesselj,
    sphericalbessely,
    trigamma

#=
Complex functions are ignored.
Functions with more than 2 arguments are ignored.

TODO: add functions with integer arguments.
=#

## 1-to-1

# ops_1_to_1_s:
# x -> f  != 0
# ∂f/∂x   != 0
# ∂²f/∂x² != 0
ops_1_to_1_s = (
    # Gamma Function
    gamma,
    loggamma,
    digamma,
    invdigamma,
    trigamma,
    # Exponential and Trigonometric Integrals
    expinti,
    sinint,
    cosint,
    # Error functions, Dawson's and Fresnel Integrals
    erf,
    erfc,
    erfcinv,
    erfcx,
    logerfc,
    erfinv,
    # Airy and Related Functions
    airyai,
    airyaiprime,
    airybi,
    airybiprime,
    airyaix,
    airyaiprimex,
    airybix,
    airybiprimex,
    # Bessel Functions
    besselj0,
    besselj1,
    bessely0,
    bessely1,
    jinc,
    # Elliptic Integrals
    ellipk,
    ellipe,
)

for op in ops_1_to_1_s
    T = typeof(op)
    @eval SCT.is_der1_zero_global(::$T) = false
    @eval SCT.is_der2_zero_global(::$T) = false
end

ops_1_to_1 = ops_1_to_1_s

## 2-to-1

# ops_2_to_1_ssc:
# ∂f/∂x    != 0
# ∂²f/∂x²  != 0
# ∂f/∂y    != 0
# ∂²f/∂y²  != 0
# ∂²f/∂x∂y != 0
ops_2_to_1_ssc = (
    # Gamma Function
    gamma,
    loggamma,
    beta,
    logbeta,
    # Exponential and Trigonometric Integrals
    expint,
    expintx,
    # Error functions, Dawson's and Fresnel Integrals
    erf,
    # Bessel Functions
    besselj,
    besseljx,
    sphericalbesselj,
    bessely,
    besselyx,
    sphericalbessely,
    besseli,
    besselix,
    besselk,
    besselkx,
)

for op in ops_2_to_1_ssc
    T = typeof(op)
    @eval SCT.is_der1_arg1_zero_global(::$T) = false
    @eval SCT.is_der2_arg1_zero_global(::$T) = false
    @eval SCT.is_der1_arg2_zero_global(::$T) = false
    @eval SCT.is_der2_arg2_zero_global(::$T) = false
    @eval SCT.is_der_cross_zero_global(::$T) = false
end

ops_2_to_1 = ops_2_to_1_ssc

## Overloads
eval(SCT.generate_code_1_to_1(:SpecialFunctions, ops_1_to_1))
eval(SCT.generate_code_2_to_1(:SpecialFunctions, ops_2_to_1))

## List operators for later testing
SCT.test_operators_1_to_1(::Val{:SpecialFunctions}) = ops_1_to_1
SCT.test_operators_2_to_1(::Val{:SpecialFunctions}) = ops_2_to_1
SCT.test_operators_1_to_2(::Val{:SpecialFunctions}) = ()

end

struct MissingPrimalError <: Exception
    fn::Function
    tracer::AbstractTracer
end

function Base.showerror(io::IO, e::MissingPrimalError)
    println(io, "Function ", e.fn, " requires primal value(s).")
    print(
        io,
        "A dual-number tracer for local sparsity detection can be used via `TracerLocalSparsityDetector`.",
    )
    return nothing
end

using BenchmarkTools
using SparseConnectivityTracer

using Random: MersenneTwister

#=
Test cases taken from the article:
> "On efficient Hessian computation using the edge pushing algorithm in Julia"
> https://www.tandfonline.com/doi/full/10.1080/10556788.2018.1480625
=#

function hessbench(detector)
    suite = BenchmarkGroup()
    suite["ArrowHead"] = hessbench_arrowhead(detector)
    suite["RandomSparsity"] = hessbench_randomsparsity(detector)
    return suite
end

## 4.1 Arrow-head structure

struct ArrowHead
    K::Int
end

function (ah::ArrowHead)(x::AbstractVector)
    K = ah.K
    N = length(x)
    return sum(1:N) do i
        s1 = sum(x[i + j] for j in 1:K if (i + j) in eachindex(x); init = zero(eltype(x)))
        s2 = sum((x[i] + x[j])^2 for j in 1:K)
        cos(s1) + s2
    end
end

function hessbench_arrowhead(detector)
    suite = BenchmarkGroup()
    # Commented-out cases (N, K) are included in the JuMP paper linked above,
    # but excluded from to accelerate the benchmark suite.
    for (N, K) in [
            ## Table 1
            (200, 16),
            # (400, 16),
            # (800, 16),
            ## Table 2
            (3200, 2),
            # (3200, 4),
            # (3200, 8),
        ]
        x = rand(N)
        f = ArrowHead(K)
        suite["N=$N, K=$K"] = @benchmarkable hessian_sparsity($f, $x, $detector)
    end
    return suite
end

# 4.2 Random sparsity structure

struct RandomSparsity
    rand_sets::Vector{Vector{Int}}
end

function RandomSparsity(N::Integer, K::Integer)
    rand_sets = [rand(MersenneTwister(123 + i), 1:N, K) for i in 1:N]
    return RandomSparsity(rand_sets)
end

function (rs::RandomSparsity)(x::AbstractVector)
    return sum(eachindex(x, rs.rand_sets)) do i
        (x[i] - 1)^2 + prod(x[rs.rand_sets[i]])
    end
end

function hessbench_randomsparsity(detector)
    suite = BenchmarkGroup()
    # Commented-out cases (N, K) are included in the JuMP paper linked above,
    # but excluded from to accelerate the benchmark suite.
    for (N, K) in [
            ## Table 3
            (400, 2),
            # (400, 4),
            # (400, 8),
            ## Table 4
            (100, 32),
            # (200, 32),
            # (400, 32),
        ]
        x = rand(N)
        f = RandomSparsity(N, K)
        suite["N=$N, K=$K"] = @benchmarkable hessian_sparsity($f, $x, $detector)
    end
    return suite
end

# 4.3 Logistic regression

# TODO: Add this test case

## Special overloads to avoid ambiguity errors
eval(generate_code_2_to_1_typed(:Base, ^, Integer))
eval(generate_code_2_to_1_typed(:Base, ^, Rational))
eval(generate_code_2_to_1_typed(:Base, ^, Irrational{:ℯ}))
eval(generate_code_2_to_1_typed(:Base, isless, AbstractFloat))

## Operator definitions

# We use a system of letters to categorize operators:
#   z: first- and second-order derivatives (FOD, SOD) are zero
#   f: FOD ∂f/∂x is non-zero, SOD ∂²f/∂x² is zero
#   s: FOD ∂f/∂x is non-zero, SOD ∂²f/∂x² is non-zero
#   c: Cross-derivative ∂²f/∂x∂y is non-zero

#! format: off

##=================================#
# Operators for functions f: ℝ → ℝ #
#==================================#
function is_der1_zero_global end
function is_der2_zero_global end

# Fallbacks for local derivatives:
is_der1_zero_local(f::F, x) where {F} = is_der1_zero_global(f)
is_der2_zero_local(f::F, x) where {F} = is_der2_zero_global(f)

# ops_1_to_1_s: 
# x -> f  != 0
# ∂f/∂x   != 0
# ∂²f/∂x² != 0
ops_1_to_1_s = (
    # trigonometric functions
    cos, cosd, cosh, cospi, cosc, 
    sin, sind, sinh, sinpi, sinc, 
    tan, tand, tanh,
    # reciprocal trigonometric functions
    csc, cscd, csch, 
    sec, secd, sech, 
    cot, cotd, coth,
    # inverse trigonometric functions
    acos, acosd, acosh, 
    asin, asind, asinh, 
    atan, atand, atanh, 
    asec, asech, 
    acsc, acsch, 
    acot, acoth,
    # exponentials
    exp, exp2, exp10, expm1, 
    log, log2, log10, log1p, 
    # roots
    sqrt, cbrt,
    # absolute values
    abs2,
    # other
    inv,
)
for op in ops_1_to_1_s
    T = typeof(op)
    @eval is_der1_zero_global(::$T) = false
    @eval is_der2_zero_global(::$T) = false
end

# ops_1_to_1_f:
# x -> f  != 0
# ∂f/∂x   != 0
# ∂²f/∂x² == 0
ops_1_to_1_f = (
    +, -,
    abs, hypot,
    # angles
    deg2rad, rad2deg, mod2pi,
    # floats
    float, prevfloat, nextfloat,
    big, widen,
    # linalg
    transpose, adjoint,
    # complex
    conj, real,
)
for op in ops_1_to_1_f
    T = typeof(op)
    @eval is_der1_zero_global(::$T) = false
    @eval is_der2_zero_global(::$T) = true
end

# ops_1_to_1_z:
# x -> f  != 0
# ∂f/∂x   == 0
# ∂²f/∂x² == 0
ops_1_to_1_z = (
    round, floor, ceil, trunc,
    sign, !
)
for op in ops_1_to_1_z
    T = typeof(op)
    @eval is_der1_zero_global(::$T) = true
    @eval is_der2_zero_global(::$T) = true
end

ops_1_to_1 = union(
    ops_1_to_1_s, 
    ops_1_to_1_f, 
    ops_1_to_1_z,
)

##==================================#
# Operators for functions f: ℝ² → ℝ #
#===================================#

function is_der1_arg1_zero_global end
function is_der2_arg1_zero_global end
function is_der1_arg2_zero_global end
function is_der2_arg2_zero_global end
function is_der_cross_zero_global end

# Fallbacks for local derivatives:
is_der1_arg1_zero_local(f::F, x, y) where {F} = is_der1_arg1_zero_global(f)
is_der2_arg1_zero_local(f::F, x, y) where {F} = is_der2_arg1_zero_global(f)
is_der1_arg2_zero_local(f::F, x, y) where {F} = is_der1_arg2_zero_global(f)
is_der2_arg2_zero_local(f::F, x, y) where {F} = is_der2_arg2_zero_global(f)
is_der_cross_zero_local(f::F, x, y) where {F} = is_der_cross_zero_global(f)

# ops_2_to_1_ssc:
# ∂f/∂x    != 0
# ∂²f/∂x²  != 0
# ∂f/∂y    != 0
# ∂²f/∂y²  != 0
# ∂²f/∂x∂y != 0
ops_2_to_1_ssc = (
    ^, hypot, atan, log
)
for op in ops_2_to_1_ssc
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der2_arg1_zero_global(::$T) = false
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = false
    @eval is_der_cross_zero_global(::$T) = false
end

# ops_2_to_1_ssz: 
# ∂f/∂x    != 0
# ∂²f/∂x²  != 0
# ∂f/∂y    != 0
# ∂²f/∂y²  != 0
# ∂²f/∂x∂y == 0
ops_2_to_1_ssz = ()
#=
for op in ops_2_to_1_ssz
    T = typeof(op)
    @eval is_der2_arg1_zero_global(::$T) = false
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = false
    @eval is_der_cross_zero_global(::$T)      = true
end
=#

# ops_2_to_1_sfc: 
# ∂f/∂x    != 0
# ∂²f/∂x²  != 0
# ∂f/∂y    != 0
# ∂²f/∂y²  == 0
# ∂²f/∂x∂y != 0
ops_2_to_1_sfc = ()
#=
for op in ops_2_to_1_sfc
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der2_arg1_zero_global(::$T) = false
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = true
    @eval is_der_cross_zero_global(::$T) = false
end
=#

# ops_2_to_1_sfz: 
# ∂f/∂x    != 0
# ∂²f/∂x²  != 0
# ∂f/∂y    != 0
# ∂²f/∂y²  == 0
# ∂²f/∂x∂y == 0
ops_2_to_1_sfz = ()
#=
for op in ops_2_to_1_sfz
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der2_arg1_zero_global(::$T) = false
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = true
    @eval is_der_cross_zero_global(::$T) = true
end
=#

# ops_2_to_1_fsc: 
# ∂f/∂x    != 0
# ∂²f/∂x²  == 0
# ∂f/∂y    != 0
# ∂²f/∂y²  != 0
# ∂²f/∂x∂y != 0
ops_2_to_1_fsc = (
    /, 
    # ldexp,  # TODO: removed for now
)
for op in ops_2_to_1_fsc
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der2_arg1_zero_global(::$T) = true
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = false
    @eval is_der_cross_zero_global(::$T)  = false
end

# gradient of x/y: [1/y -x/y²]
is_der1_arg2_zero_local(::typeof(/), x, y) = iszero(x)

# ops_2_to_1_fsz: 
# ∂f/∂x    != 0
# ∂²f/∂x²  == 0
# ∂f/∂y    != 0
# ∂²f/∂y²  != 0
# ∂²f/∂x∂y == 0
ops_2_to_1_fsz = ()
#=
for op in ops_2_to_1_fsz
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der2_arg1_zero_global(::$T) = true
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = false
    @eval is_der_cross_zero_global(::$T) = true
end
=#

# ops_2_to_1_ffc: 
# ∂f/∂x    != 0
# ∂²f/∂x²  == 0
# ∂f/∂y    != 0
# ∂²f/∂y²  == 0
# ∂²f/∂x∂y != 0
ops_2_to_1_ffc = (
    *, 
)
for op in ops_2_to_1_ffc
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der2_arg1_zero_global(::$T) = true
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = true
    @eval is_der_cross_zero_global(::$T) = false
end

# gradient of x*y: [y x]
is_der1_arg1_zero_local(::typeof(*), x, y) = iszero(y)
is_der1_arg2_zero_local(::typeof(*), x, y) = iszero(x)

# ops_2_to_1_ffz: 
# ∂f/∂x    != 0
# ∂²f/∂x²  == 0
# ∂f/∂y    != 0
# ∂²f/∂y²  == 0
# ∂²f/∂x∂y == 0
ops_2_to_1_ffz = (
    +, -,
    mod, rem,
    min, max,
)
for op in ops_2_to_1_ffz
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der2_arg1_zero_global(::$T) = true
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = true
    @eval is_der_cross_zero_global(::$T) = true
end

is_der1_arg2_zero_local(::typeof(mod), x, y) = ifelse(y > zero(y), y > x, x > y)

is_der1_arg1_zero_local(::typeof(max), x, y) = x < y
is_der1_arg2_zero_local(::typeof(max), x, y) = y < x

is_der1_arg1_zero_local(::typeof(min), x, y) = x > y
is_der1_arg2_zero_local(::typeof(min), x, y) = y > x

# ops_2_to_1_szz: 
# ∂f/∂x    != 0
# ∂²f/∂x²  != 0
# ∂f/∂y    == 0
# ∂²f/∂y²  == 0
# ∂²f/∂x∂y == 0
ops_2_to_1_szz = ()
#=
for op in ops_2_to_1_szz
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der2_arg1_zero_global(::$T) = false
    @eval is_der1_arg2_zero_global(::$T) = true
    @eval is_der2_arg2_zero_global(::$T) = true
    @eval is_der_cross_zero_global(::$T) = true
end
=#

# ops_2_to_1_zsz: 
# ∂f/∂x    == 0
# ∂²f/∂x²  == 0
# ∂f/∂y    != 0
# ∂²f/∂y²  != 0
# ∂²f/∂x∂y == 0
ops_2_to_1_zsz = ()
#=
for op in ops_2_to_1_zsz
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = true
    @eval is_der2_arg1_zero_global(::$T) = true
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = false
    @eval is_der_cross_zero_global(::$T) = true
end
=#

# ops_2_to_1_fzz: 
# ∂f/∂x    != 0
# ∂²f/∂x²  == 0
# ∂f/∂y    == 0
# ∂²f/∂y²  == 0
# ∂²f/∂x∂y == 0
ops_2_to_1_fzz = (
    copysign, flipsign,
)
for op in ops_2_to_1_fzz
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = false
    @eval is_der2_arg1_zero_global(::$T) = true
    @eval is_der1_arg2_zero_global(::$T) = true
    @eval is_der2_arg2_zero_global(::$T) = true
    @eval is_der_cross_zero_global(::$T) = true
end

# ops_2_to_1_zfz: 
# ∂f/∂x    == 0
# ∂²f/∂x²  == 0
# ∂f/∂y    != 0
# ∂²f/∂y²  == 0
# ∂²f/∂x∂y == 0
ops_2_to_1_zfz = ()
#=
for op in ops_2_to_1_zfz
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = true
    @eval is_der2_arg1_zero_global(::$T) = true
    @eval is_der1_arg2_zero_global(::$T) = false
    @eval is_der2_arg2_zero_global(::$T) = true
    @eval is_der_cross_zero_global(::$T) = true
end
=#

# ops_2_to_1_zfz: 
# ∂f/∂x    == 0
# ∂²f/∂x²  == 0
# ∂f/∂y    == 0
# ∂²f/∂y²  == 0
# ∂²f/∂x∂y == 0
ops_2_to_1_zzz = (
    # division
    div, fld, fld1, cld, 
    # comparisons
    isequal, isapprox, isless, ==, <, <=,
)
for op in ops_2_to_1_zzz
    T = typeof(op)
    @eval is_der1_arg1_zero_global(::$T) = true
    @eval is_der2_arg1_zero_global(::$T) = true
    @eval is_der1_arg2_zero_global(::$T) = true
    @eval is_der2_arg2_zero_global(::$T) = true
    @eval is_der_cross_zero_global(::$T) = true
end

ops_2_to_1 = union(
    # Including second-order only
    ops_2_to_1_ssc,
    ops_2_to_1_ssz,

    # Including second- and first-order
    ops_2_to_1_sfc,
    ops_2_to_1_sfz,
    ops_2_to_1_fsc,
    ops_2_to_1_fsz,

    # Including first-order only
    ops_2_to_1_ffc,
    ops_2_to_1_ffz,

    # Including zero-order
    ops_2_to_1_szz,
    ops_2_to_1_zsz,
    ops_2_to_1_fzz,
    ops_2_to_1_zfz,
    ops_2_to_1_zzz,
)

##==================================#
# Operators for functions f: ℝ → ℝ² #
#===================================#

function is_der1_out1_zero_global end
function is_der2_out1_zero_global end
function is_der1_out2_zero_global end
function is_der2_out2_zero_global end

# Fallbacks for local derivatives:
is_der1_out1_zero_local(f::F, x) where {F} = is_der1_out1_zero_global(f)
is_der2_out1_zero_local(f::F, x) where {F} = is_der2_out1_zero_global(f)
is_der1_out2_zero_local(f::F, x) where {F} = is_der1_out2_zero_global(f)
is_der2_out2_zero_local(f::F, x) where {F} = is_der2_out2_zero_global(f)

# ops_1_to_2_ss: 
# ∂f₁/∂x   != 0
# ∂²f₁/∂x² != 0
# ∂f₂/∂x   != 0
# ∂²f₂/∂x² != 0
ops_1_to_2_ss = (
    sincos,
    sincosd,
    sincospi,
)
for op in ops_1_to_2_ss
    T = typeof(op)
    @eval is_der1_out1_zero_global(::$T) = false
    @eval is_der2_out1_zero_global(::$T) = false
    @eval is_der1_out2_zero_global(::$T) = false
    @eval is_der2_out2_zero_global(::$T) = false
end

# ops_1_to_2_sf: 
# ∂f₁/∂x   != 0
# ∂²f₁/∂x² != 0
# ∂f₂/∂x   != 0
# ∂²f₂/∂x² == 0
ops_1_to_2_sf = ()
#=
for op in ops_1_to_2_sf
    T = typeof(op)
    @eval is_der1_out1_zero_global(::$T) = false
    @eval is_der2_out1_zero_global(::$T) = false
    @eval is_der1_out2_zero_global(::$T) = false
    @eval is_der2_out2_zero_global(::$T) = true
end
=#

# ops_1_to_2_sz: 
# ∂f₁/∂x   != 0
# ∂²f₁/∂x² != 0
# ∂f₂/∂x   == 0
# ∂²f₂/∂x² == 0
ops_1_to_2_sz = ()
#=
for op in ops_1_to_2_sz
    T = typeof(op)
    @eval is_der1_out1_zero_global(::$T) = false
    @eval is_der2_out1_zero_global(::$T) = false
    @eval is_der1_out2_zero_global(::$T) = true
    @eval is_der2_out2_zero_global(::$T) = true
end
=#

# ops_1_to_2_fs: 
# ∂f₁/∂x   != 0
# ∂²f₁/∂x² == 0
# ∂f₂/∂x   != 0
# ∂²f₂/∂x² != 0
ops_1_to_2_fs = ()
#=
for op in ops_1_to_2_fs
    T = typeof(op)
    @eval is_der1_out1_zero_global(::$T) = false
    @eval is_der2_out1_zero_global(::$T) = true
    @eval is_der1_out2_zero_global(::$T) = false
    @eval is_der2_out2_zero_global(::$T) = false
end
=#

# ops_1_to_2_ff: 
# ∂f₁/∂x   != 0
# ∂²f₁/∂x² == 0
# ∂f₂/∂x   != 0
# ∂²f₂/∂x² == 0
ops_1_to_2_ff = ()
#=
for op in ops_1_to_2_ff
    T = typeof(op)
    @eval is_der1_out1_zero_global(::$T) = false
    @eval is_der2_out1_zero_global(::$T) = true
    @eval is_der1_out2_zero_global(::$T) = false
    @eval is_der2_out2_zero_global(::$T) = true
end
=#

# ops_1_to_2_fz: 
# ∂f₁/∂x   != 0
# ∂²f₁/∂x² == 0
# ∂f₂/∂x   == 0
# ∂²f₂/∂x² == 0
ops_1_to_2_fz = (
    # frexp,  # TODO: removed for now
)
#=
for op in ops_1_to_2_fz
    T = typeof(op)
    @eval is_der1_out1_zero_global(::$T) = false
    @eval is_der2_out1_zero_global(::$T) = true
    @eval is_der1_out2_zero_global(::$T) = true
    @eval is_der2_out2_zero_global(::$T) = true
end
=#

# ops_1_to_2_zs: 
# ∂f₁/∂x   == 0
# ∂²f₁/∂x² == 0
# ∂f₂/∂x   != 0
# ∂²f₂/∂x² != 0
ops_1_to_2_zs = ()
#=
for op in ops_1_to_2_zs
    T = typeof(op)
    @eval is_der1_out1_zero_global(::$T) = true
    @eval is_der2_out1_zero_global(::$T) = true
    @eval is_der1_out2_zero_global(::$T) = false
    @eval is_der2_out2_zero_global(::$T) = false
end
=#

# ops_1_to_2_zf: 
# ∂f₁/∂x   == 0
# ∂²f₁/∂x² == 0
# ∂f₂/∂x   != 0
# ∂²f₂/∂x² == 0
ops_1_to_2_zf = ()
#=
for op in ops_1_to_2_zf
    T = typeof(op)
    @eval is_der1_out1_zero_global(::$T) = true
    @eval is_der2_out1_zero_global(::$T) = true
    @eval is_der1_out2_zero_global(::$T) = false
    @eval is_der2_out2_zero_global(::$T) = true
end
=#

# ops_1_to_2_zz: 
# ∂f₁/∂x   == 0
# ∂²f₁/∂x² == 0
# ∂f₂/∂x   == 0
# ∂²f₂/∂x² == 0
ops_1_to_2_zz = ()
#=
for op in ops_1_to_2_zz
    T = typeof(op)
    @eval is_der1_out1_zero_global(::$T) = true
    @eval is_der2_out1_zero_global(::$T) = true
    @eval is_der1_out2_zero_global(::$T) = true
    @eval is_der2_out2_zero_global(::$T) = true
end
=#

ops_1_to_2 = union(
    ops_1_to_2_ss,
    ops_1_to_2_sf,
    ops_1_to_2_fs,
    ops_1_to_2_ff,
    ops_1_to_2_sz,
    ops_1_to_2_zs,
    ops_1_to_2_fz,
    ops_1_to_2_zf,
    ops_1_to_2_zz,   
)
#! format: on

SCT = SparseConnectivityTracer

## 1-to-1

# 𝟙[∇γ]  = 𝟙[∂φ]⋅𝟙[∇α]
# 𝟙[∇²γ] = 𝟙[∂φ]⋅𝟙[∇²α] ∨ 𝟙[∂²φ]⋅(𝟙[∇α] ∨ 𝟙[∇α]ᵀ)

function hessian_tracer_1_to_1(t::T, is_der1_zero::Bool, is_der2_zero::Bool) where {T <: HessianTracer}
    if isemptytracer(t) # TODO: add test
        return t
    else
        return hessian_tracer_1_to_1_inner(t, is_der1_zero, is_der2_zero, shared(T))
    end
end

function hessian_tracer_1_to_1_inner(
        t::T, is_der1_zero::Bool, is_der2_zero::Bool, ::NotShared
    ) where {T <: HessianTracer}
    g = gradient(t)
    h = hessian(t)

    g_out = gradient_tracer_1_to_1_inner(g, is_der1_zero) # 𝟙[∇γ] = 𝟙[∂φ]⋅𝟙[∇α]
    h_out = if is_der1_zero && is_der2_zero # 𝟙[∇²γ] = 0
        myempty(h)
    elseif !is_der1_zero && is_der2_zero # 𝟙[∇²γ] = 𝟙[∂φ]⋅𝟙[∇²α]
        h
    elseif is_der1_zero && !is_der2_zero # 𝟙[∇²γ] = 𝟙[∇α] ∨ 𝟙[∇α]ᵀ
        # TODO: this branch of the code currently isn't tested.
        # Covering it would require a scalar 1-to-1 function with local overloads,
        # such that ∂f/∂x == 0 and ∂²f/∂x² != 0.
        union_product!(myempty(h), g, g)
    else # !is_der1_zero && !is_der2_zero,  𝟙[∇²γ] = 𝟙[∇²α] ∨ (𝟙[∇α] ∨ 𝟙[∇α]ᵀ)
        union_product!(copy(h), g, g)
    end
    return T(g_out, h_out) # return pattern
end

# NOTE: mutates argument p and should arguably be called `hessian_tracer_1_to_1_inner!`
function hessian_tracer_1_to_1_inner(
        t::T, is_der1_zero::Bool, is_der2_zero::Bool, ::Shared
    ) where {T <: HessianTracer}
    g = gradient(t)
    g_out = gradient_tracer_1_to_1_inner(g, is_der1_zero)

    # shared Hessian patterns can't remove second-order information, only add to it.
    h = hessian(t)
    h_out = if is_der2_zero  # 𝟙[∇²γ] = 𝟙[∂φ]⋅𝟙[∇²α]
        h
    else # 𝟙[∇²γ] = 𝟙[∇²α] ∨ (𝟙[∇α] ∨ 𝟙[∇α]ᵀ)
        union_product!(h, g, g)
    end
    return T(g_out, h_out) # return pattern
end

function generate_code_hessian_1_to_1(M::Symbol, f::Function)
    fname = nameof(f)
    is_der1_zero_g = is_der1_zero_global(f)
    is_der2_zero_g = is_der2_zero_global(f)

    expr_hessiantracer = quote
        ## HessianTracer
        function $M.$fname(t::$SCT.HessianTracer)
            return @noinline $SCT.hessian_tracer_1_to_1(t, $is_der1_zero_g, $is_der2_zero_g)
        end
    end

    expr_dual = if is_der1_zero_g && is_der2_zero_g
        quote
            function $M.$fname(d::D) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(d)
                return $M.$fname(x)
            end
        end
    else
        quote
            function $M.$fname(d::D) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(d)
                p_out = $M.$fname(x)

                t = $SCT.tracer(d)
                is_der1_zero = $SCT.is_der1_zero_local($M.$fname, x)
                is_der2_zero = $SCT.is_der2_zero_local($M.$fname, x)
                t_out = @noinline $SCT.hessian_tracer_1_to_1(t, is_der1_zero, is_der2_zero)
                return $SCT.Dual(p_out, t_out)
            end
        end
    end

    return Expr(:block, expr_hessiantracer, expr_dual)
end

## 2-to-1

function hessian_tracer_2_to_1(
        tx::T,
        ty::T,
        is_der1_arg1_zero::Bool,
        is_der2_arg1_zero::Bool,
        is_der1_arg2_zero::Bool,
        is_der2_arg2_zero::Bool,
        is_der_cross_zero::Bool,
    ) where {T <: HessianTracer}
    # TODO: add tests for isempty
    if tx.isempty && ty.isempty
        return tx # empty tracer
    elseif ty.isempty
        return hessian_tracer_1_to_1(tx, is_der1_arg1_zero, is_der2_arg1_zero)
    elseif tx.isempty
        return hessian_tracer_1_to_1(ty, is_der1_arg2_zero, is_der2_arg2_zero)
    else
        return hessian_tracer_2_to_1_inner(
            tx,
            ty,
            is_der1_arg1_zero,
            is_der2_arg1_zero,
            is_der1_arg2_zero,
            is_der2_arg2_zero,
            is_der_cross_zero,
            shared(T),
        )
    end
end

function hessian_tracer_2_to_1_inner(
        tx::T,
        ty::T,
        is_der1_arg1_zero::Bool,
        is_der2_arg1_zero::Bool,
        is_der1_arg2_zero::Bool,
        is_der2_arg2_zero::Bool,
        is_der_cross_zero::Bool,
        ::NotShared,
    ) where {T <: HessianTracer}
    gx, hx = gradient(tx), hessian(tx)
    gy, hy = gradient(ty), hessian(ty)
    g_out = gradient_tracer_2_to_1_inner(gx, gy, is_der1_arg1_zero, is_der1_arg2_zero)
    h_out = myempty(hx)
    !is_der1_arg1_zero && myunion!(h_out, hx)  # hessian alpha
    !is_der1_arg2_zero && myunion!(h_out, hy)  # hessian beta
    !is_der2_arg1_zero && union_product!(h_out, gx, gx)  # product alpha
    !is_der2_arg2_zero && union_product!(h_out, gy, gy)  # product beta
    !is_der_cross_zero && union_product!(h_out, gx, gy)  # cross product 1
    !is_der_cross_zero && union_product!(h_out, gy, gx)  # cross product 2
    return T(g_out, h_out) # return pattern
end

# NOTE: mutates arguments tx and ty and should arguably be called `hessian_tracer_1_to_1_inner!`
function hessian_tracer_2_to_1_inner(
        tx::T,
        ty::T,
        is_der1_arg1_zero::Bool,
        is_der2_arg1_zero::Bool,
        is_der1_arg2_zero::Bool,
        is_der2_arg2_zero::Bool,
        is_der_cross_zero::Bool,
        ::Shared,
    ) where {T <: HessianTracer}
    gx, hx = gradient(tx), hessian(tx)
    gy, hy = gradient(ty), hessian(ty)

    hx !== hy && error("Expected shared Hessians, got $hx, $hy.")
    h_out = hx # union of hx and hy can be skipped since they are the same object
    g_out = gradient_tracer_2_to_1_inner(gx, gy, is_der1_arg1_zero, is_der1_arg2_zero)

    !is_der2_arg1_zero && union_product!(h_out, gx, gx)  # product alpha
    !is_der2_arg2_zero && union_product!(h_out, gy, gy)  # product beta
    !is_der_cross_zero && union_product!(h_out, gx, gy)  # cross product 1
    !is_der_cross_zero && union_product!(h_out, gy, gx)  # cross product 2
    return T(g_out, h_out) # return pattern
end

function generate_code_hessian_2_to_1(
        M::Symbol,    # Symbol indicating Module of f, usually `:Base`
        f::Function,  # function to overload
        Z::Type = Real, # external non-tracer-type to overload on
    )
    fname = nameof(f)
    is_der1_arg1_zero_g = is_der1_arg1_zero_global(f)
    is_der2_arg1_zero_g = is_der2_arg1_zero_global(f)
    is_der1_arg2_zero_g = is_der1_arg2_zero_global(f)
    is_der2_arg2_zero_g = is_der2_arg2_zero_global(f)
    is_der_cross_zero_g = is_der_cross_zero_global(f)

    expr_tracer_tracer = quote
        function $M.$fname(tx::T, ty::T) where {T <: $SCT.HessianTracer}
            return @noinline $SCT.hessian_tracer_2_to_1(
                tx,
                ty,
                $is_der1_arg1_zero_g,
                $is_der2_arg1_zero_g,
                $is_der1_arg2_zero_g,
                $is_der2_arg2_zero_g,
                $is_der_cross_zero_g,
            )
        end
    end

    expr_dual_dual =
    if is_der1_arg1_zero_g &&
            is_der2_arg1_zero_g &&
            is_der1_arg2_zero_g &&
            is_der2_arg2_zero_g &&
            is_der_cross_zero_g
        quote
            function $M.$fname(
                    dx::D, dy::D
                ) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(dx)
                y = $SCT.primal(dy)
                return $M.$fname(x, y)
            end
        end
    else
        quote
            function $M.$fname(
                    dx::D, dy::D
                ) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(dx)
                y = $SCT.primal(dy)
                p_out = $M.$fname(x, y)

                tx = $SCT.tracer(dx)
                ty = $SCT.tracer(dy)
                is_der1_arg1_zero = $SCT.is_der1_arg1_zero_local($M.$fname, x, y)
                is_der2_arg1_zero = $SCT.is_der2_arg1_zero_local($M.$fname, x, y)
                is_der1_arg2_zero = $SCT.is_der1_arg2_zero_local($M.$fname, x, y)
                is_der2_arg2_zero = $SCT.is_der2_arg2_zero_local($M.$fname, x, y)
                is_der_cross_zero = $SCT.is_der_cross_zero_local($M.$fname, x, y)
                t_out = @noinline $SCT.hessian_tracer_2_to_1(
                    tx,
                    ty,
                    is_der1_arg1_zero,
                    is_der2_arg1_zero,
                    is_der1_arg2_zero,
                    is_der2_arg2_zero,
                    is_der_cross_zero,
                )
                return $SCT.Dual(p_out, t_out)
            end
        end
    end

    exprs_typed = generate_code_hessian_2_to_1_typed(M, f, Real)
    return Expr(:block, expr_tracer_tracer, expr_dual_dual, exprs_typed)
end

function generate_code_hessian_2_to_1_typed(
        M::Symbol,   # Symbol indicating Module of f, usually `:Base`
        f::Function, # function to overload
        Z::Type,     # external non-tracer-type to overload on
    )
    fname = nameof(f)
    is_der1_arg1_zero_g = is_der1_arg1_zero_global(f)
    is_der2_arg1_zero_g = is_der2_arg1_zero_global(f)
    is_der1_arg2_zero_g = is_der1_arg2_zero_global(f)
    is_der2_arg2_zero_g = is_der2_arg2_zero_global(f)

    expr_tracer_type = quote
        function $M.$fname(tx::$SCT.HessianTracer, y::$Z)
            return @noinline $SCT.hessian_tracer_1_to_1(
                tx, $is_der1_arg1_zero_g, $is_der2_arg1_zero_g
            )
        end
    end
    expr_type_tracer = quote
        function $M.$fname(x::$Z, ty::$SCT.HessianTracer)
            return @noinline $SCT.hessian_tracer_1_to_1(
                ty, $is_der1_arg2_zero_g, $is_der2_arg2_zero_g
            )
        end
    end


    expr_dual_type = if is_der1_arg1_zero_g && is_der2_arg1_zero_g
        quote
            function $M.$fname(dx::D, y::$Z) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(dx)
                return $M.$fname(x, y)
            end
        end
    else
        quote
            function $M.$fname(dx::D, y::$Z) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(dx)
                p_out = $M.$fname(x, y)

                tx = $SCT.tracer(dx)
                is_der1_arg1_zero = $SCT.is_der1_arg1_zero_local($M.$fname, x, y)
                is_der2_arg1_zero = $SCT.is_der2_arg1_zero_local($M.$fname, x, y)
                t_out = @noinline $SCT.hessian_tracer_1_to_1(
                    tx, is_der1_arg1_zero, is_der2_arg1_zero
                )
                return $SCT.Dual(p_out, t_out)
            end
        end
    end
    expr_type_dual = if is_der1_arg2_zero_g && is_der2_arg2_zero_g
        quote
            function $M.$fname(x::$Z, dy::D) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                y = $SCT.primal(dy)
                return $M.$fname(x, y)
            end
        end
    else
        quote
            function $M.$fname(x::$Z, dy::D) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                y = $SCT.primal(dy)
                p_out = $M.$fname(x, y)

                ty = $SCT.tracer(dy)
                is_der1_arg2_zero = $SCT.is_der1_arg2_zero_local($M.$fname, x, y)
                is_der2_arg2_zero = $SCT.is_der2_arg2_zero_local($M.$fname, x, y)
                t_out = @noinline $SCT.hessian_tracer_1_to_1(
                    ty, is_der1_arg2_zero, is_der2_arg2_zero
                )
                return $SCT.Dual(p_out, t_out)
            end
        end
    end
    return Expr(:block, expr_tracer_type, expr_type_tracer, expr_dual_type, expr_type_dual)
end

## 1-to-2

function hessian_tracer_1_to_2(
        t::T,
        is_der1_out1_zero::Bool,
        is_der2_out1_zero::Bool,
        is_der1_out2_zero::Bool,
        is_der2_out2_zero::Bool,
    ) where {T <: HessianTracer}
    if isemptytracer(t) # TODO: add test
        return (t, t)
    else
        t_out1 = hessian_tracer_1_to_1(t, is_der1_out1_zero, is_der2_out1_zero)
        t_out2 = hessian_tracer_1_to_1(t, is_der1_out2_zero, is_der2_out2_zero)
        return (t_out1, t_out2)
    end
end

function generate_code_hessian_1_to_2(M::Symbol, f::Function)
    fname = nameof(f)
    is_der1_out1_zero_g = is_der1_out1_zero_global(f)
    is_der2_out1_zero_g = is_der2_out1_zero_global(f)
    is_der1_out2_zero_g = is_der1_out2_zero_global(f)
    is_der2_out2_zero_g = is_der2_out2_zero_global(f)

    expr_hessiantracer = quote
        function $M.$fname(t::$SCT.HessianTracer)
            return @noinline $SCT.hessian_tracer_1_to_2(
                t,
                $is_der1_out1_zero_g,
                $is_der2_out1_zero_g,
                $is_der1_out2_zero_g,
                $is_der2_out2_zero_g,
            )
        end
    end

    expr_dual =
    if is_der1_out1_zero_g &&
            is_der2_out1_zero_g &&
            is_der1_out2_zero_g &&
            is_der2_out2_zero_g
        quote
            function $M.$fname(d::D) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(d)
                return $M.$fname(x)
            end
        end
    else
        quote
            function $M.$fname(d::D) where {P, T <: $SCT.HessianTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(d)
                p_out1, p_out2 = $M.$fname(x)

                t = $SCT.tracer(d)
                is_der1_out1_zero = $SCT.is_der1_out1_zero_local($M.$fname, x)
                is_der2_out1_zero = $SCT.is_der2_out1_zero_local($M.$fname, x)
                is_der1_out2_zero = $SCT.is_der1_out2_zero_local($M.$fname, x)
                is_der2_out2_zero = $SCT.is_der2_out2_zero_local($M.$fname, x)
                t_out1, t_out2 = @noinline $SCT.hessian_tracer_1_to_2(
                    t,
                    is_der1_out1_zero,
                    is_der2_out1_zero,
                    is_der1_out2_zero,
                    is_der2_out2_zero,
                )
                return ($SCT.Dual(p_out1, t_out1), $SCT.Dual(p_out2, t_out2))
            end
        end
    end

    return Expr(:block, expr_hessiantracer, expr_dual)
end

# Brusselator example taken from Gowda et al.
# "Sparsity Programming: Automated Sparsity-Aware Optimizations in Differentiable Programming"
# https://openreview.net/pdf?id=rJlPdcY38B

#! format: off
brusselator_f(x, y, t) = ifelse((((x-0.3)^2 + (y-0.6)^2) <= 0.1^2) && (t >= 1.1), 5., 0.)
limit(a, N) = a == N+1 ? 1 : a == 0 ? N : a
function brusselator_2d_loop!(du, u, p, t)
    A, B, alpha, xyd, dx, N = p; alpha = alpha/dx^2
    @inbounds for I in CartesianIndices((N, N))
        i, j = Tuple(I)
        x, y = xyd[I[1]], xyd[I[2]]
        ip1, im1, jp1, jm1 = limit(i+1, N), limit(i-1, N), limit(j+1, N), limit(j-1, N)
        du[i,j,1] = alpha*(u[im1,j,1] + u[ip1,j,1] + u[i,jp1,1] + u[i,jm1,1] - 4u[i,j,1]) +
        B + u[i,j,1]^2*u[i,j,2] - (A + 1)*u[i,j,1] + brusselator_f(x, y, t)
        du[i,j,2] = alpha*(u[im1,j,2] + u[ip1,j,2] + u[i,jp1,2] + u[i,jm1,2] - 4u[i,j,2]) +
        A*u[i,j,1] - u[i,j,1]^2*u[i,j,2]
    end
end
#! format: on

struct Brusselator!{P}
    N::Int
    params::P
end

Base.show(b!::Brusselator!) = "Brusselator(N=$(b!.N))"

function Brusselator!(N::Integer)
    dims = (N, N, 2)
    A = 1.0
    B = 1.0
    alpha = 1.0
    xyd = fill(1.0, N)
    dx = 1.0
    params = (; A, B, alpha, xyd, dx, N)
    return Brusselator!(N, params)
end

(b!::Brusselator!)(y, x) = brusselator_2d_loop!(y, x, b!.params, nothing)

#= Create empty sets and compute unions of sets and cross-products of sets =#

myempty(::S) where {S <: AbstractSet} = S()
myempty(::Type{S}) where {S <: AbstractSet} = S()
myempty(::D) where {D <: AbstractDict} = D()
myempty(::Type{D}) where {D <: AbstractDict} = D()
seed(::Type{S}, i::Integer) where {S <: AbstractSet} = S(i)

myunion!(a::S, b::S) where {S <: AbstractSet} = union!(a, b)
function myunion!(a::D, b::D) where {I <: Integer, S <: AbstractSet{I}, D <: AbstractDict{I, S}}
    for k in keys(b)
        if haskey(a, k)
            union!(a[k], b[k])
        else
            push!(a, k => b[k])
        end
    end
    return a
end

# convert to set of index tuples
tuple_set(s::AbstractSet{Tuple{I, I}}) where {I <: Integer} = s
function tuple_set(d::AbstractDict{I, S}) where {I <: Integer, S <: AbstractSet{I}}
    return Set((k, v) for k in keys(d) for v in d[k])
end

""""
    product(a::S{T}, b::S{T})::S{Tuple{T,T}}

Inner product of set-like inputs `a` and `b`.
"""
function product(a::AbstractSet{I}, b::AbstractSet{I}) where {I <: Integer}
    # Since the Hessian is symmetric, we only have to keep track of index-tuples (i,j) with i≤j.
    return Set((i, j) for i in a, j in b if i <= j)
end

function union_product!(
        hessian::H, gradient_x::G, gradient_y::G
    ) where {I <: Integer, G <: AbstractSet{I}, H <: AbstractSet{Tuple{I, I}}}
    for i in gradient_x
        for j in gradient_y
            if i <= j # symmetric Hessian
                push!(hessian, (i, j))
            end
        end
    end
    return hessian
end

function union_product!(
        hessian::AbstractDict{I, S}, gradient_x::S, gradient_y::S
    ) where {I <: Integer, S <: AbstractSet{I}}
    for i in gradient_x
        if !haskey(hessian, i)
            push!(hessian, i => S())
        end
        for j in gradient_y
            if i <= j # symmetric Hessian
                push!(hessian[i], j)
            end
        end
    end
    return hessian
end

# NNlib activation functions on tracers.
# Parametric activation functions with two or more arguments are ignored.
module SparseConnectivityTracerNNlibExt

import SparseConnectivityTracer as SCT
using NNlib:
    NNlib,
    celu,
    elu,
    gelu,
    hardswish,
    hardtanh,
    hardσ,
    leakyrelu,
    lisht,
    logcosh,
    logσ,
    mish,
    relu,
    relu6,
    selu,
    sigmoid_fast,
    softplus,
    softshrink,
    softsign,
    swish,
    tanh_fast,
    tanhshrink,
    trelu,
    σ

## 1-to-1

# ops_1_to_1_s:
# x -> f  != 0
# ∂f/∂x   != 0
# ∂²f/∂x² != 0
ops_1_to_1_s = (
    # ReLU-like activation functions
    celu,
    elu,
    gelu,
    selu,
    # Other activation functions
    σ, # sigmoid
    hardswish,
    lisht,
    logσ,
    logcosh,
    mish,
    sigmoid_fast,
    softplus,
    softsign,
    swish,
    tanh_fast,
    tanhshrink,
)

for op in ops_1_to_1_s
    T = typeof(op)
    @eval SCT.is_der1_zero_global(::$T) = false
    @eval SCT.is_der2_zero_global(::$T) = false
end

SCT.is_der2_zero_local(::typeof(celu), x) = x > 0
SCT.is_der2_zero_local(::typeof(elu), x) = x > 0
SCT.is_der2_zero_local(::typeof(selu), x) = x > 0

SCT.is_der1_zero_local(::typeof(hardswish), x) = x < -3
SCT.is_der2_zero_local(::typeof(hardswish), x) = x < -3 || x > 3

# ops_1_to_1_f:
# x -> f  != 0
# ∂f/∂x   != 0
# ∂²f/∂x² == 0
ops_1_to_1_f = (
    # ReLU-like activation functions
    leakyrelu,
    relu,
    relu6,
    trelu,
    # Other activation functions
    hardσ,
    hardtanh,
    softshrink,
)

for op in ops_1_to_1_f
    T = typeof(op)
    @eval SCT.is_der1_zero_global(::$T) = false
    @eval SCT.is_der2_zero_global(::$T) = true
end

SCT.is_der1_zero_local(::typeof(relu), x) = x < 0
SCT.is_der1_zero_local(::typeof(relu6), x) = x < 0 || x > 6
SCT.is_der1_zero_local(::typeof(trelu), x) = x < 1

SCT.is_der1_zero_local(::typeof(hardσ), x) = x < -3 || x > 3
SCT.is_der1_zero_local(::typeof(hardtanh), x) = x < -1 || x > 1
SCT.is_der1_zero_local(::typeof(softshrink), x) = x > -0.5 && x < 0.5

ops_1_to_1 = union(ops_1_to_1_s, ops_1_to_1_f)

## Overload
eval(SCT.generate_code_1_to_1(:NNlib, ops_1_to_1))

## List operators for later testing
SCT.test_operators_1_to_1(::Val{:NNlib}) = ops_1_to_1
SCT.test_operators_2_to_1(::Val{:NNlib}) = ()
SCT.test_operators_1_to_2(::Val{:NNlib}) = ()

end

"""
    AbstractTracer

Abstract supertype of tracers.

## Type hierarchy
```
AbstractTracer
├── GradientTracer
└── HessianTracer
```

Note that [`Dual`](@ref) is not an `AbstractTracer`.
"""
abstract type AbstractTracer <: Real end

"""
    gradient(pattern::AbstractTracer)
    
Return a representation of non-zero values ``∇f(x)_{i} ≠ 0`` in the gradient.
"""
gradient

"""
    hessian(pattern::HessianTracer)
    
Return a representation of non-zero values ``∇²f(x)_{ij} ≠ 0`` in the Hessian.
"""
hessian

"""
    myempty(T)
    myempty(tracer::AbstractTracer)
    
Constructor for an empty tracer or pattern of type `T` representing a new number (usually an empty pattern).
"""
myempty

#================#
# GradientTracer #
#================#

"""
$(TYPEDEF)

`Real` number type keeping track of non-zero gradient entries.

## Fields
$(TYPEDFIELDS)
"""
struct GradientTracer{I <: Integer, G <: AbstractSet{I}} <: AbstractTracer
    "Set of indices ``i`` of non-zero values ``∇f(x)_i ≠ 0`` in the gradient."
    gradient::G
    "Indicator whether gradient in tracer contains only zeros."
    isempty::Bool

    function GradientTracer{I, G}(gradient::G, isempty::Bool = false) where {I, G}
        return new{I, G}(gradient, isempty)
    end
end

GradientTracer{I, G}(::Real) where {I, G} = myempty(GradientTracer{I, G})
GradientTracer{I, G}(t::GradientTracer{I, G}) where {I, G} = t

isemptytracer(t::GradientTracer) = t.isempty
gradient(t::GradientTracer) = t.gradient

myempty(::Type{GradientTracer{I, G}}) where {I, G} = GradientTracer{I, G}(myempty(G), true)

function create_tracers(::Type{T}, xs, is) where {I, G, T <: GradientTracer{I, G}}
    gradients = map(Base.Fix1(seed, G), is)
    return T.(gradients)
end

#===============#
# HessianTracer #
#===============#

abstract type SharingBehavior end

"""
Indicates that patterns **always** share memory and that operators are **allowed** to mutate their `HessianTracer` arguments.
In practice, memory sharing is limited to second-order information in `HessianTracer`.
"""
struct Shared <: SharingBehavior end

"""
Indicates that patterns **can** share memory and operators are **prohibited** from mutating `HessianTracer` arguments.
In practice, memory sharing is limited to second-order information in `HessianTracer`.
"""
struct NotShared <: SharingBehavior end

"""
$(TYPEDEF)

`Real` number type keeping track of non-zero gradient and Hessian entries.

## Fields
$(TYPEDFIELDS)
"""
struct HessianTracer{
        I <: Integer, G <: AbstractSet{I}, H <: Union{AbstractDict{I, G}, AbstractSet{Tuple{I, I}}}, S <: SharingBehavior,
    } <: AbstractTracer
    "Set of indices ``i`` of non-zero values ``∇f(x)_i ≠ 0`` in the gradient."
    gradient::G
    "Set of index-tuples ``(i, j)`` of non-zero values ``∇²f(x)_{ij} ≠ 0`` in the Hessian."
    hessian::H
    "Indicator whether gradient and Hessian in tracer both contain only zeros."
    isempty::Bool

    function HessianTracer{I, G, H, S}(gradient::G, hessian::H, isempty::Bool = false) where {I, G, H, S}
        return new{I, G, H, S}(gradient, hessian, isempty)
    end
end

HessianTracer{I, G, H, S}(::Real) where {I, G, H, S} = myempty(HessianTracer{I, G, H, S})
HessianTracer{I, G, H, S}(t::HessianTracer{I, G, H, S}) where {I, G, H, S} = t

isemptytracer(t::HessianTracer) = t.isempty
gradient(t::HessianTracer) = t.gradient
hessian(t::HessianTracer) = t.hessian

myempty(::Type{HessianTracer{I, G, H, S}}) where {I, G, H, S} = HessianTracer{I, G, H, S}(myempty(G), myempty(H), true)

function create_tracers(
        ::Type{T}, xs, is
    ) where {I, G, H, S, T <: HessianTracer{I, G, H, S}}
    gradients = map(Base.Fix1(seed, G), is)
    hessian = myempty(H)
    # Even if `NotShared`, sharing a single reference to `hessian` is allowed upon initialization,
    # since mutation is prohibited when `isshared` is false.
    return T.(gradients, Ref(hessian))
end

"""
    shared(pattern)

Indicates whether patterns **always** share memory and whether operators are **allowed** to mutate their `HessianTracer` arguments.
Returns either the `Shared()` or `NotShared()` trait.

If `NotShared()`, patterns **can** share memory and operators are **prohibited** from mutating `HessianTracer` arguments.

## Note
In practice, memory sharing is limited to second-order information in `HessianTracer`.
"""
shared(::T) where {T <: HessianTracer} = shared(T)
shared(::Type{HessianTracer{I, G, H, S}}) where {I, G, H, S} = S()

isshared(::Shared) = true
isshared(::NotShared) = false
isshared(t) = isshared(shared(t))

#================================#
# Dual numbers for local tracing #
#================================#

"""
$(TYPEDEF)

Dual `Real` number type keeping track of the results of a primal computation as well as a tracer.

## Fields
$(TYPEDFIELDS)
"""
struct Dual{P <: Real, T <: AbstractTracer} <: Real
    primal::P
    tracer::T

    function Dual{P, T}(primal::P, tracer::T) where {P <: Number, T <: AbstractTracer}
        if P <: AbstractTracer || P <: Dual
            error("Primal value of Dual tracer can't be an AbstractTracer.")
        end
        return new{P, T}(primal, tracer)
    end
end

primal(d::Dual) = d.primal
tracer(d::Dual) = d.tracer

gradient(d::Dual{P, T}) where {P, T <: GradientTracer} = gradient(tracer(d))
gradient(d::Dual{P, T}) where {P, T <: HessianTracer} = gradient(tracer(d))
hessian(d::Dual{P, T}) where {P, T <: HessianTracer} = hessian(tracer(d))
isemptytracer(d::Dual) = isemptytracer(tracer(d))

Dual{P, T}(d::Dual{P, T}) where {P <: Real, T <: AbstractTracer} = d
Dual(primal::P, tracer::T) where {P, T} = Dual{P, T}(primal, tracer)

function Dual{P, T}(x::Real) where {P <: Real, T <: AbstractTracer}
    return Dual(convert(P, x), myempty(T))
end

#===========#
# Utilities #
#===========#


"""
    create_tracers(T, xs, indices)

Convenience constructor for [`GradientTracer`](@ref), [`HessianTracer`](@ref) and [`Dual`](@ref) 
from multiple inputs `xs` and their indices `is`.
"""


function create_tracers(
        ::Type{D}, xs::AbstractArray{<:Real, N}, indices::AbstractArray{<:Integer, N}
    ) where {P, T, D <: Dual{P, T}, N}
    tracers = create_tracers(T, xs, indices)
    return D.(xs, tracers)
end

using Pkg
Pkg.develop(; path = joinpath(@__DIR__, "SparseConnectivityTracerBenchmarks"))

using BenchmarkTools
using SparseConnectivityTracer
using SparseConnectivityTracer: HessianTracer, Shared

include("jacobian.jl")
include("hessian.jl")
include("nlpmodels.jl")

suite = BenchmarkGroup()
suite["OptimizationProblems"] = optbench([:britgas])

suite["Jacobian"]["Global"] = jacbench(TracerSparsityDetector())
suite["Jacobian"]["Local"] = jacbench(TracerLocalSparsityDetector())
suite["Hessian"]["Global"] = hessbench(TracerSparsityDetector())
suite["Hessian"]["Local"] = hessbench(TracerLocalSparsityDetector())

# Shared tracers
TH = HessianTracer{Int, BitSet, Dict{Int, BitSet}, Shared}
suite["Hessian"]["Global shared"] = hessbench(
    TracerSparsityDetector(TH)
)
suite["Hessian"]["Local shared"] = hessbench(
    TracerLocalSparsityDetector(TH)
)

using SparseConnectivityTracer: DEFAULT_GRADIENT_TRACER, DEFAULT_HESSIAN_TRACER
using SparseConnectivityTracer: AbstractTracer, GradientTracer, HessianTracer, Dual
using SparseConnectivityTracer: Shared, NotShared

GRADIENT_TRACERS = (
    GradientTracer{Int, BitSet},
    GradientTracer{Int, Set{Int}},
)

HESSIAN_TRACERS_SHARED = (
    HessianTracer{Int, BitSet, Set{Tuple{Int, Int}}, Shared},
    HessianTracer{Int, BitSet, Dict{Int, BitSet}, Shared},
)
HESSIAN_TRACERS_NOTSHARED = (
    HessianTracer{Int, BitSet, Set{Tuple{Int, Int}}, NotShared},
    HessianTracer{Int, BitSet, Dict{Int, BitSet}, NotShared},
    HessianTracer{Int, Set{Int}, Dict{Int, Set{Int}}, NotShared},
)
HESSIAN_TRACERS = union(HESSIAN_TRACERS_SHARED, HESSIAN_TRACERS_NOTSHARED)

# To run benchmarks locally, BenchmarkCI should be added to root project. Then call:
# ```bash
# julia benchmark/run_benchmarks.jl
# ```

using BenchmarkCI
on_CI = haskey(ENV, "GITHUB_ACTIONS")

BenchmarkCI.judge(; baseline = "origin/main")
on_CI ? BenchmarkCI.postjudge() : BenchmarkCI.displayjudgement()

module SparseConnectivityTracerChainRulesCoreExt

import ChainRulesCore: ignore_derivatives
using SparseConnectivityTracer: AbstractTracer, Dual, primal, myempty

## Scalar
ignore_derivatives(::T) where {T <: AbstractTracer} = myempty(T)
ignore_derivatives(d::Dual) = primal(d)

## Array
ignore_derivatives(A::AbstractArray{T}) where {T <: AbstractTracer} = ignore_derivatives.(A)
ignore_derivatives(A::AbstractArray{<:Dual}) = primal.(A)

end # module

#===========#
# Utilities #
#===========#

function split_dual_array(A::AbstractArray{D}) where {D <: Dual}
    primals = getproperty.(A, :primal)
    tracers = getproperty.(A, :tracer)
    return primals, tracers
end

sct_owns_type(::Type) = false
sct_owns_type(::Type{T}) where {T <: AbstractTracer} = true
sct_owns_type(::Type{A}) where {A <: AbstractArray{<:AbstractTracer}} = true
sct_owns_type(::Type{A}) where {T, A <: AbstractArray{T}} = sct_owns_type(T)

nopiracy(types) = any(sct_owns_type, types)

#==================#
# LinearAlgebra.jl #
#==================#

# TODO: replace `second_order_or` by less conservative sparsity patterns when possible

## Determinant
LinearAlgebra.det(A::AbstractMatrix{T}) where {T <: AbstractTracer} = second_order_or(A)
LinearAlgebra.logdet(A::AbstractMatrix{T}) where {T <: AbstractTracer} = second_order_or(A)
function LinearAlgebra.logabsdet(A::AbstractMatrix{T}) where {T <: AbstractTracer}
    t1 = second_order_or(A)
    t2 = sign(t1) # corresponds to sign of det(A): set first- and second-order derivatives to zero
    return (t1, t2)
end

## Norm
function LinearAlgebra.norm(A::AbstractArray{T}, p::Real = 2) where {T <: AbstractTracer}
    if isone(p) || isinf(p)
        return first_order_or(A)
    else
        return second_order_or(A)
    end
end
function LinearAlgebra.opnorm(A::AbstractMatrix{T}, p::Real = 2) where {T <: AbstractTracer}
    if isone(p) || isinf(p)
        return first_order_or(A)
    else
        return second_order_or(A)
    end
end

## Eigenvalues

function LinearAlgebra.eigmax(
        A::Union{T, AbstractMatrix{T}}; permute::Bool = true, scale::Bool = true
    ) where {T <: AbstractTracer}
    return second_order_or(A)
end
function LinearAlgebra.eigmin(
        A::Union{T, AbstractMatrix{T}}; permute::Bool = true, scale::Bool = true
    ) where {T <: AbstractTracer}
    return second_order_or(A)
end
function LinearAlgebra.eigen(
        A::AbstractMatrix{T};
        permute::Bool = true,
        scale::Bool = true,
        sortby::Union{Function, Nothing} = nothing,
    ) where {T <: AbstractTracer}
    LinearAlgebra.checksquare(A)
    n = size(A, 1)
    t = second_order_or(A)
    values = Fill(t, n)
    vectors = Fill(t, n, n)
    return LinearAlgebra.Eigen(values, vectors)
end

## Cholesky
# A generic `cholesky` compares matrix entries (pivoting / positive-definiteness), which on tracers
# return a tracer rather than a `Bool`. Like `eigen`, return a conservative all-depends factor.
function LinearAlgebra.cholesky(
        A::AbstractMatrix{T},
        ::LinearAlgebra.NoPivot = LinearAlgebra.NoPivot();
        check::Bool = true,
    ) where {T <: AbstractTracer}
    LinearAlgebra.checksquare(A)
    n = size(A, 1)
    t = second_order_or(A)
    return LinearAlgebra.Cholesky(Fill(t, n, n), 'U', 0)
end
function LinearAlgebra.cholesky(
        A::AbstractMatrix{T},
        ::LinearAlgebra.RowMaximum;
        tol::Real = 0.0,
        check::Bool = true,
    ) where {T <: AbstractTracer}
    LinearAlgebra.checksquare(A)
    n = size(A, 1)
    t = second_order_or(A)
    return LinearAlgebra.CholeskyPivoted(Fill(t, n, n), 'U', 1:n, n, tol, 0)
end

## Inverse
function Base.inv(A::StridedMatrix{T}) where {T <: AbstractTracer}
    LinearAlgebra.checksquare(A)
    t = second_order_or(A)
    return Fill(t, size(A)...)
end
function Base.inv(D::Diagonal{T}) where {T <: AbstractTracer}
    ts_in = D.diag
    ts_out = similar(ts_in)
    for i in 1:length(ts_out)
        ts_out[i] = inv(ts_in[i])
    end
    return Diagonal(ts_out)
end

function LinearAlgebra.pinv(
        A::AbstractMatrix{T}; atol::Real = 0.0, rtol::Real = 0.0
    ) where {T <: AbstractTracer}
    n, m = size(A)
    t = second_order_or(A)
    return Fill(t, m, n)
end
LinearAlgebra.pinv(D::Diagonal{T}) where {T <: AbstractTracer} = inv(D)

## Dot product – adapted from https://github.com/JuliaLang/LinearAlgebra.jl/blob/924dda4d5d26d745fc8993b7ffdfaa80ee0e0c0e/src/generic.jl#L895-L1029
LinearAlgebra.dot(x::T, y::T) where {T <: AbstractTracer} = x * y # no conjugate required on tracers.

# In the future, we will likely have to add more methods.
for (Tx, TA, Ty) in Iterators.filter(
        nopiracy, # only keep tuples of types we own
        Iterators.product(
            # Types for x
            (Vector, Vector{<:AbstractTracer}, SubArray, SubArray{<:AbstractTracer, 1}),
            # Types for A
            (Matrix, Matrix{<:AbstractTracer}),
            # Types for y
            (Vector, Vector{<:AbstractTracer}, SubArray, SubArray{<:AbstractTracer, 1}),
        ),
    )
    @eval LinearAlgebra.dot(x::$Tx, A::$TA, y::$Ty) = LinearAlgebra.dot(x, A * y)
end

## Multiplication
function Base.:*(A::Matrix{T}, B::Matrix{T}) where {T <: GradientTracer}
    if size(A, 2) != size(B, 1)
        throw(DimensionMismatch("arguments must have compatible dimensions"))
    end
    tA = map(first_order_or, eachrow(A))
    tB = map(first_order_or, eachcol(B))
    C = second_order_or.(tA, transpose(tB))
    return C
end
function Base.:*(A::Matrix{T}, B::Vector{T}) where {T <: GradientTracer}
    if size(A, 2) != length(B)
        throw(DimensionMismatch("arguments must have compatible dimensions"))
    end
    tA = map(first_order_or, eachrow(A))
    tB = first_order_or(B)
    t = second_order_or.(tA, Ref(tB))
    return t
end

## Division
function LinearAlgebra.:\(A::AbstractMatrix{T}, B::AbstractMatrix) where {T <: AbstractTracer}
    if size(A, 1) != size(B, 1)
        throw(DimensionMismatch("arguments must have the same number of rows"))
    end
    t = second_order_or(A)
    return Fill(t, size(A, 2), size(B, 2))
end
function LinearAlgebra.:\(A::AbstractMatrix{T}, B::AbstractVector) where {T <: AbstractTracer}
    if size(A, 1) != size(B, 1)
        throw(DimensionMismatch("arguments must have the same number of rows"))
    end
    t = second_order_or(A)
    return Fill(t, size(A, 2))
end

function LinearAlgebra.:\(A::AbstractMatrix, B::AbstractMatrix{T}) where {T <: AbstractTracer}
    if size(A, 1) != size(B, 1)
        throw(DimensionMismatch("arguments must have the same number of rows"))
    end
    t = second_order_or(B)
    return Fill(t, size(A, 2), size(B, 2))
end
function LinearAlgebra.:\(A::AbstractMatrix, B::AbstractVector{T}) where {T <: AbstractTracer}
    if size(A, 1) != size(B, 1)
        throw(DimensionMismatch("arguments must have the same number of rows"))
    end
    t = second_order_or(B)
    return Fill(t, size(A, 2))
end

function LinearAlgebra.:\(
        A::AbstractMatrix{T}, B::AbstractMatrix{T}
    ) where {T <: AbstractTracer}
    if size(A, 1) != size(B, 1)
        throw(DimensionMismatch("arguments must have the same number of rows"))
    end
    tA = second_order_or(A)
    tB = second_order_or(B)
    t = second_order_or(tA, tB)
    return Fill(t, size(A, 2), size(B, 2))
end
function LinearAlgebra.:\(
        A::AbstractMatrix{T}, B::AbstractVector{T}
    ) where {T <: AbstractTracer}
    if size(A, 1) != size(B, 1)
        throw(DimensionMismatch("arguments must have the same number of rows"))
    end
    tA = second_order_or(A)
    tB = second_order_or(B)
    t = second_order_or(tA, tB)
    return Fill(t, size(A, 2))
end

## Exponential
function Base.exp(A::AbstractMatrix{T}) where {T <: AbstractTracer}
    LinearAlgebra.checksquare(A)
    n = size(A, 1)
    t = second_order_or(A)
    return Fill(t, n, n)
end

## Matrix power
function LinearAlgebra.:^(A::AbstractMatrix{T}, p::Integer) where {T <: AbstractTracer}
    LinearAlgebra.checksquare(A)
    n = size(A, 1)
    if iszero(p)
        return Fill(myempty(T), n, n)
    else
        t = second_order_or(A)
        return Fill(t, n, n)
    end
end

function Base.literal_pow(::typeof(^), D::Diagonal{T}, ::Val{0}) where {T <: AbstractTracer}
    ts = similar(D.diag)
    ts .= myempty(T)
    return Diagonal(ts)
end

## clamp!
Base.clamp!(A::AbstractArray{T}, lo, hi) where {T <: AbstractTracer} = A
function Base.clamp!(A::AbstractArray{T}, lo::T, hi) where {T <: AbstractTracer}
    return first_order_or.(A, lo)
end
function Base.clamp!(A::AbstractArray{T}, lo, hi::T) where {T <: AbstractTracer}
    return first_order_or.(A, hi)
end
function Base.clamp!(A::AbstractArray{T}, lo::T, hi::T) where {T <: AbstractTracer}
    return first_order_or.(A, first_order_or(lo, hi))
end

#==========================#
# LinearAlgebra.jl on Dual #
#==========================#

# `Duals` should use LinearAlgebra's generic fallback implementations
# to compute the "least conservative" sparsity patterns possible on a scalar level.

# The following three methods are a temporary fix for issue #108.
# TODO: instead overload `lu` on AbstractMatrix of Duals.
function LinearAlgebra.det(A::AbstractMatrix{<:Dual})
    primals, tracers = split_dual_array(A)
    p = LinearAlgebra.det(primals)
    t = LinearAlgebra.det(tracers)
    return Dual(p, t)
end
function LinearAlgebra.logdet(A::AbstractMatrix{<:Dual})
    primals, tracers = split_dual_array(A)
    p = LinearAlgebra.logdet(primals)
    t = LinearAlgebra.logdet(tracers)
    return Dual(p, t)
end
function LinearAlgebra.logabsdet(A::AbstractMatrix{<:Dual})
    primals, tracers = split_dual_array(A)
    p1, p2 = LinearAlgebra.logabsdet(primals)
    t1, t2 = LinearAlgebra.logabsdet(tracers)
    return (Dual(p1, t1), Dual(p2, t2))
end
function LinearAlgebra.:\(A::AbstractMatrix{<:Dual}, B::AbstractVector)
    primals, tracers = split_dual_array(A)
    p = primals \ B
    t = tracers \ B
    return Dual.(p, t)
end
function LinearAlgebra.:\(A::AbstractMatrix, B::AbstractVector{D}) where {D <: Dual}
    primals, tracers = split_dual_array(B)
    p = A \ primals
    t = A \ tracers
    return Dual.(p, t)
end
function LinearAlgebra.:\(
        A::AbstractMatrix{D1}, B::AbstractVector{D2}
    ) where {D1 <: Dual, D2 <: Dual}
    A_primals, A_tracers = split_dual_array(A)
    B_primals, B_tracers = split_dual_array(B)
    p = A_primals \ B_primals
    t = A_tracers \ B_tracers
    return Dual.(p, t)
end

#==============#
# SparseArrays #
#==============#

# Helper function needed in SparseArrays's sparsematrix, sparsevector and higherorderfns.
# On Tracers, `iszero` and `!iszero` don't return a boolean,
# but we need a function that does to handle the structure of the array.

SparseArrays._iszero(t::AbstractTracer) = isemptytracer(t)
SparseArrays._iszero(d::Dual) = isemptytracer(tracer(d)) && iszero(primal(d))

SparseArrays._isnotzero(t::AbstractTracer) = !isemptytracer(t)
SparseArrays._isnotzero(d::Dual) = !isemptytracer(tracer(d)) || !iszero(primal(d))

using SparseConnectivityTracer
using Test

using Aqua: Aqua
using JET: JET
using ExplicitImports: ExplicitImports

# Load package extensions so they get tested by ExplicitImports.jl
using ChainRulesCore: ChainRulesCore
using NaNMath: NaNMath
using NNlib: NNlib
using SpecialFunctions: SpecialFunctions

@testset "Aqua tests" begin
    @info "...with Aqua.jl"
    Aqua.test_all(
        SparseConnectivityTracer;
        ambiguities = false,
        undocumented_names = true,
    )
end

if VERSION > v"1.11" # JET v0.10 requires Julia v1.12
    @testset "JET tests" begin
        @info "...with JET.jl"
        JET.test_package(SparseConnectivityTracer; target_defined_modules = true)
    end
end

@testset "ExplicitImports tests" begin
    @info "...with ExplicitImports.jl"
    @testset "Improper implicit imports" begin
        @test ExplicitImports.check_no_implicit_imports(SparseConnectivityTracer) ===
            nothing
    end
    @testset "Improper explicit imports" begin
        @test ExplicitImports.check_no_stale_explicit_imports(
            SparseConnectivityTracer
        ) === nothing
        @test ExplicitImports.check_all_explicit_imports_via_owners(
            SparseConnectivityTracer
        ) === nothing
        # TODO: test in the future when `public` is more common
        # @test ExplicitImports.check_all_explicit_imports_are_public(
        #     SparseConnectivityTracer
        # ) === nothing
    end
    @testset "Improper qualified accesses" begin
        @test ExplicitImports.check_all_qualified_accesses_via_owners(
            SparseConnectivityTracer
        ) === nothing
        @test ExplicitImports.check_no_self_qualified_accesses(SparseConnectivityTracer) ===
            nothing
        # TODO: test in the future when `public` is more common
        # @test ExplicitImports.check_all_qualified_accesses_are_public(
        #     SparseConnectivityTracer
        # ) === nothing
    end
end

function Base.ifelse(::AbstractTracer, x, y)
    size(x) != size(y) && throw(
        DimensionMismatch(
            "Output sizes of x and y in `ifelse(condition, x, y)` don't match in size."
        ),
    )
    return output_union(x, y)
end

## output union on scalar outputs
function output_union(tx::T, ty::T) where {T <: GradientTracer}
    return T(union(gradient(tx), gradient(ty))) # return tracer
end

output_union(tx::T, ty::T) where {T <: HessianTracer} = output_union(tx, ty, shared(T))
function output_union(tx::T, ty::T, ::Shared) where {T <: HessianTracer}
    g_out = union(gradient(tx), gradient(ty))
    hx, hy = hessian(tx), hessian(ty)
    hx !== hy && error("Expected shared Hessians, got $hx, $hy.")
    return T(g_out, hx) # return pattern
end

function output_union(tx::T, ty::T, ::NotShared) where {I <: Integer, G <: AbstractSet{I}, H <: AbstractSet{Tuple{I, I}}, T <: HessianTracer{I, G, H}}
    g_out = union(gradient(tx), gradient(ty))
    h_out = union(hessian(tx), hessian(ty))
    return T(g_out, h_out) # return pattern
end
function output_union(tx::T, ty::T, ::NotShared) where {I <: Integer, G <: AbstractSet{I}, H <: AbstractDict{I, G}, T <: HessianTracer{I, G, H}}
    g_out = union(gradient(tx), gradient(ty))
    h_out = myunion!(deepcopy(hessian(tx)), hessian(ty))
    return T(g_out, h_out) # return pattern
end

output_union(tx::AbstractTracer, y) = tx
output_union(x, ty::AbstractTracer) = ty

## output union on AbstractArray outputs
# TODO: add test
function output_union(tx::AbstractArray{T}, ty::AbstractArray{T}) where {T <: AbstractTracer}
    return output_union.(tx, ty)
end
function output_union(tx::AbstractArray{T}, y::AbstractArray) where {T <: AbstractTracer}
    return tx
end
function output_union(x::AbstractArray, ty::AbstractArray{T}) where {T <: AbstractTracer}
    return ty
end

using SparseConnectivityTracer: # 1-to-1
    is_der1_zero_global,
    is_der2_zero_global,
    is_der1_zero_local,
    is_der2_zero_local
using SparseConnectivityTracer: # 2-to-1
    is_der1_arg1_zero_global,
    is_der2_arg1_zero_global,
    is_der1_arg2_zero_global,
    is_der2_arg2_zero_global,
    is_der_cross_zero_global,
    is_der1_arg1_zero_local,
    is_der2_arg1_zero_local,
    is_der1_arg2_zero_local,
    is_der2_arg2_zero_local,
    is_der_cross_zero_local
using SparseConnectivityTracer: # 1-to-2
    is_der1_out1_zero_global,
    is_der2_out1_zero_global,
    is_der1_out2_zero_global,
    is_der2_out2_zero_global,
    is_der2_out1_zero_local,
    is_der1_out1_zero_local,
    is_der1_out2_zero_local,
    is_der2_out2_zero_local
using SparseConnectivityTracer: # testing
    test_operators_2_to_1,
    test_operators_1_to_1,
    test_operators_1_to_2
using SpecialFunctions: SpecialFunctions
using NNlib: NNlib
using LogExpFunctions: LogExpFunctions
using NaNMath: NaNMath
using Test
using ForwardDiff: ForwardDiff

second_derivative(f, x) = ForwardDiff.derivative(_x -> ForwardDiff.derivative(f, _x), x)

DEFAULT_ATOL = 1.0e-8
DEFAULT_TRIALS = 20

## Random inputs

random_input(op) = rand()
random_input(::Union{typeof(acosh), typeof(acoth), typeof(acsc), typeof(asec)}) = 1 + rand()
random_input(::typeof(sincosd)) = 180 * rand()

# LogExpFunctions.jl
random_input(::typeof(LogExpFunctions.log1mexp)) = -rand()  # log1mexp(x) is defined for x < 0
random_input(::typeof(LogExpFunctions.log2mexp)) = -rand()  # log2mexp(x) is defined for x < 0
random_input(::typeof(LogExpFunctions.logitexp)) = -rand()  # logitexp(x) is defined for x < 0
random_input(::typeof(LogExpFunctions.logit1mexp)) = -rand() # logit1mexp(x) is defined for x < 0

# NaNMath.jl
random_input(::typeof(NaNMath.acosh)) = 1 + rand()  # Range: [1, ∞)

random_first_input(op) = random_input(op)
random_second_input(op) = random_input(op)

## Skip tests on functions that don't support ForwardDiff's Dual numbers

correct_classification_1_to_1(op::typeof(!), x; atol) = true

## Derivatives and special cases

both_derivatives_1_to_1(op, x) = ForwardDiff.derivative(op, x), second_derivative(op, x)

function both_derivatives_1_to_1(::Union{typeof(big), typeof(widen)}, x)
    return both_derivatives_1_to_1(identity, x)
end
function both_derivatives_1_to_1(
        ::Union{typeof(floatmin), typeof(floatmax), typeof(maxintfloat)}, x
    )
    return both_derivatives_1_to_1(zero, x)
end

function both_derivatives_2_to_1(op, x, y)
    return ForwardDiff.gradient(Base.splat(op), [x, y]), ForwardDiff.hessian(Base.splat(op), [x, y])
end

function both_derivatives_1_to_2(op, x)
    function op_vec(x)
        y = op(x)
        return [y[1], y[2]]
    end
    return ForwardDiff.derivative(op_vec, x), second_derivative(op_vec, x)
end

## 1-to-1

function correct_classification_1_to_1(op, x; atol)
    dfdx, d²fdx² = both_derivatives_1_to_1(op, x)
    if (is_der1_zero_global(op) | is_der1_zero_local(op, x)) && !isapprox(dfdx, 0; atol)
        return false
    elseif (is_der2_zero_global(op) | is_der2_zero_local(op, x)) &&
            !isapprox(d²fdx², 0; atol)
        return false
    else
        return true
    end
end

@testset verbose = true "1-to-1" begin
    @testset "$m" for m in (Base, SpecialFunctions, NNlib, LogExpFunctions, NaNMath)
        @testset "$op" for op in test_operators_1_to_1(Val(Symbol(m)))
            @test all(
                correct_classification_1_to_1(op, random_input(op); atol = DEFAULT_ATOL) for
                    _ in 1:DEFAULT_TRIALS
            )
            yield()
        end
    end
end;

## 2-to-1

function correct_classification_2_to_1(op, x, y; atol)
    g, H = both_derivatives_2_to_1(op, x, y)

    ∂f∂x = g[1]
    ∂f∂y = g[2]
    ∂²f∂x² = H[1, 1]
    ∂²f∂y² = H[2, 2]
    ∂²f∂x∂y = H[1, 2]

    if (is_der1_arg1_zero_global(op) | is_der1_arg1_zero_local(op, x, y)) &&
            !isapprox(∂f∂x, 0; atol)
        return false
    elseif (is_der2_arg1_zero_global(op) | is_der2_arg1_zero_local(op, x, y)) &&
            !isapprox(∂²f∂x², 0; atol)
        return false
    elseif (is_der1_arg2_zero_global(op) | is_der1_arg2_zero_local(op, x, y)) &&
            !isapprox(∂f∂y, 0; atol)
        return false
    elseif (is_der2_arg2_zero_global(op) | is_der2_arg2_zero_local(op, x, y)) &&
            !isapprox(∂²f∂y², 0; atol)
        return false
    elseif (is_der_cross_zero_global(op) | is_der_cross_zero_local(op, x, y)) &&
            !isapprox(∂²f∂x∂y, 0; atol)
        return false
    else
        return true
    end
end

@testset verbose = true "2-to-1" begin
    @testset "$m" for m in (Base, SpecialFunctions, NNlib, LogExpFunctions, NaNMath)
        @testset "$op" for op in test_operators_2_to_1(Val(Symbol(m)))
            @test all(
                correct_classification_2_to_1(
                        op, random_first_input(op), random_second_input(op); atol = DEFAULT_ATOL
                    ) for _ in 1:DEFAULT_TRIALS
            )
            yield()
        end
    end
end;

## 1-to-2

function correct_classification_1_to_2(op, x; atol)
    d1, d2 = both_derivatives_1_to_2(op, x)

    ∂f₁∂x = d1[1]
    ∂f₂∂x = d1[2]
    ∂²f₁∂x² = d2[1]
    ∂²f₂∂x² = d2[2]

    if (is_der1_out1_zero_global(op) | is_der1_out1_zero_local(op, x)) &&
            !isapprox(∂f₁∂x, 0; atol)
        return false
    elseif (is_der2_out1_zero_global(op) | is_der2_out1_zero_local(op, x)) &&
            !isapprox(∂²f₁∂x², 0; atol)
        return false
    elseif (is_der1_out2_zero_global(op) | is_der1_out2_zero_local(op, x)) &&
            !isapprox(∂f₂∂x, 0; atol)
        return false
    elseif (is_der2_out2_zero_global(op) | is_der2_out2_zero_local(op, x)) &&
            !isapprox(∂²f₂∂x², 0; atol)
        return false
    else
        return true
    end
end

@testset verbose = true "1-to-2" begin
    @testset "$m" for m in (Base, SpecialFunctions, NNlib, LogExpFunctions, NaNMath)
        @testset "$op" for op in test_operators_1_to_2(Val(Symbol(m)))
            @test all(
                correct_classification_1_to_2(op, random_input(op); atol = DEFAULT_ATOL) for
                    _ in 1:DEFAULT_TRIALS
            )
            yield()
        end
    end
end;

module SparseConnectivityTracerBenchmarks

module ODE
    include("brusselator.jl")
    export Brusselator!, brusselator_2d_loop!
end

module Optimization
    using ADTypes: ADTypes
    using SparseConnectivityTracer
    import SparseConnectivityTracer as SCT

    using ADNLPModels: ADNLPModels
    using NLPModels: NLPModels, AbstractNLPModel
    using NLPModelsJuMP: NLPModelsJuMP
    using OptimizationProblems: OptimizationProblems

    using LinearAlgebra
    using SparseArrays

    include("nlpmodels.jl")
    export OPTIMIZATION_PROBLEM_NAMES
    export compute_jac_sparsity_sct, compute_hess_sparsity_sct
    export compute_jac_and_hess_sparsity_sct, compute_jac_and_hess_sparsity_and_value_jump
end

end # module SparseConnectivityTracerBenchmarks

using SparseConnectivityTracer
using NNlib: NNlib
using Test

NNLIB_ACTIVATIONS_S = (
    NNlib.σ,
    NNlib.celu,
    NNlib.elu,
    NNlib.gelu,
    NNlib.hardswish,
    NNlib.lisht,
    NNlib.logσ,
    NNlib.logcosh,
    NNlib.mish,
    NNlib.selu,
    NNlib.softplus,
    NNlib.softsign,
    NNlib.swish,
    NNlib.sigmoid_fast,
    NNlib.tanhshrink,
    NNlib.tanh_fast,
)
NNLIB_ACTIVATIONS_F = (
    NNlib.hardσ,
    NNlib.hardtanh,
    NNlib.leakyrelu,
    NNlib.relu,
    NNlib.relu6,
    NNlib.softshrink,
    NNlib.trelu,
)
NNLIB_ACTIVATIONS = union(NNLIB_ACTIVATIONS_S, NNLIB_ACTIVATIONS_F)

@testset "Jacobian Global" begin
    detector = TracerSparsityDetector()
    J(f, x) = jacobian_sparsity(f, x, detector)

    @testset "$f" for f in NNLIB_ACTIVATIONS
        @test J(f, 1) ≈ [1;;]
    end
end

@testset "Jacobian Local" begin
    detector = TracerLocalSparsityDetector()
    J(f, x) = jacobian_sparsity(f, x, detector)

    @test J(NNlib.relu, -1) ≈ [0;;]
    @test J(NNlib.relu, 1) ≈ [1;;]
    @test J(NNlib.elu, -1) ≈ [1;;]
    @test J(NNlib.elu, 1) ≈ [1;;]
    @test J(NNlib.celu, -1) ≈ [1;;]
    @test J(NNlib.celu, 1) ≈ [1;;]
    @test J(NNlib.selu, -1) ≈ [1;;]
    @test J(NNlib.selu, 1) ≈ [1;;]

    @test J(NNlib.relu6, -1) ≈ [0;;]
    @test J(NNlib.relu6, 1) ≈ [1;;]
    @test J(NNlib.relu6, 7) ≈ [0;;]

    @test J(NNlib.trelu, 0.9) ≈ [0;;]
    @test J(NNlib.trelu, 1.1) ≈ [1;;]

    @test J(NNlib.swish, -5) ≈ [1;;]
    @test J(NNlib.swish, 0) ≈ [1;;]
    @test J(NNlib.swish, 5) ≈ [1;;]

    @test J(NNlib.hardswish, -5) ≈ [0;;]
    @test J(NNlib.hardswish, 0) ≈ [1;;]
    @test J(NNlib.hardswish, 5) ≈ [1;;]

    @test J(NNlib.hardσ, -4) ≈ [0;;]
    @test J(NNlib.hardσ, 0) ≈ [1;;]
    @test J(NNlib.hardσ, 4) ≈ [0;;]

    @test J(NNlib.hardtanh, -2) ≈ [0;;]
    @test J(NNlib.hardtanh, 0) ≈ [1;;]
    @test J(NNlib.hardtanh, 2) ≈ [0;;]

    @test J(NNlib.softshrink, -1) ≈ [1;;]
    @test J(NNlib.softshrink, 0) ≈ [0;;]
    @test J(NNlib.softshrink, 1) ≈ [1;;]
end

@testset "Global Hessian" begin
    detector = TracerSparsityDetector()
    H(f, x) = hessian_sparsity(f, x, detector)

    @testset "First-order differentiable" begin
        @testset "$f" for f in NNLIB_ACTIVATIONS_F
            @test H(f, 1) ≈ [0;;]
        end
    end
    @testset "Second-order differentiable" begin
        @testset "$f" for f in NNLIB_ACTIVATIONS_S
            @test H(f, 1) ≈ [1;;]
        end
    end
end

@testset "Local Hessian" begin
    detector = TracerLocalSparsityDetector()
    H(f, x) = hessian_sparsity(f, x, detector)

    @test H(NNlib.relu, -1) ≈ [0;;]
    @test H(NNlib.relu, 1) ≈ [0;;]
    @test H(NNlib.elu, -1) ≈ [1;;]
    @test H(NNlib.elu, 1) ≈ [0;;]
    @test H(NNlib.celu, -1) ≈ [1;;]
    @test H(NNlib.celu, 1) ≈ [0;;]
    @test H(NNlib.selu, -1) ≈ [1;;]
    @test H(NNlib.selu, 1) ≈ [0;;]

    @test H(NNlib.relu6, -1) ≈ [0;;]
    @test H(NNlib.relu6, 1) ≈ [0;;]
    @test H(NNlib.relu6, 7) ≈ [0;;]

    @test H(NNlib.trelu, 0.9) ≈ [0;;]
    @test H(NNlib.trelu, 1.1) ≈ [0;;]

    @test H(NNlib.swish, -5) ≈ [1;;]
    @test H(NNlib.swish, 0) ≈ [1;;]
    @test H(NNlib.swish, 5) ≈ [1;;]

    @test H(NNlib.hardswish, -5) ≈ [0;;]
    @test H(NNlib.hardswish, 0) ≈ [1;;]
    @test H(NNlib.hardswish, 5) ≈ [0;;]

    @test H(NNlib.hardσ, -4) ≈ [0;;]
    @test H(NNlib.hardσ, 0) ≈ [0;;]
    @test H(NNlib.hardσ, 4) ≈ [0;;]

    @test H(NNlib.hardtanh, -2) ≈ [0;;]
    @test H(NNlib.hardtanh, 0) ≈ [0;;]
    @test H(NNlib.hardtanh, 2) ≈ [0;;]

    @test H(NNlib.softshrink, -1) ≈ [0;;]
    @test H(NNlib.softshrink, 0) ≈ [0;;]
    @test H(NNlib.softshrink, 1) ≈ [0;;]
end

using SparseConnectivityTracer
using SpecialFunctions: erf, beta
using Test

# Load definitions of GRADIENT_TRACERS and HESSIAN_TRACERS
include("../tracers_definitions.jl")

@testset "Jacobian Global" begin
    detector = TracerSparsityDetector()
    J(f, x) = jacobian_sparsity(f, x, detector)

    @test J(x -> erf(x[1]), rand(2)) == [1 0]
    @test J(x -> beta(x[1], x[2]), rand(3)) == [1 1 0]
end

# TODO: add tests
# @testset "Jacobian Local" begin
#     detector = TracerLocalSparsityDetector()
#     J(f, x) = jacobian_sparsity(f, x, detector)
# end

@testset "Global Hessian" begin
    detector = TracerSparsityDetector()
    H(f, x) = hessian_sparsity(f, x, detector)

    @test H(x -> erf(x[1]), rand(2)) == [
        1 0
        0 0
    ]
    @test H(x -> beta(x[1], x[2]), rand(3)) == [
        1 1 0
        1 1 0
        0 0 0
    ]
end

# TODO: add tests
# @testset "Local Hessian" begin
#     detector = TracerLocalSparsityDetector()
#     H(f, x) = hessian_sparsity(f, x, detector)
# end

#= This file handles the actual tracing of functions:
1) creating tracers from inputs
2) evaluating the function with the created tracers

The resulting output is parsed in `src/parse_outputs_to_matrix.jl`.
=#

#==================#
# Enumerate inputs #
#==================#

"""
    trace_input(T, x)
    trace_input(T, xs)

Enumerates input indices and constructs the specified type `T` of tracer.
Supports [`GradientTracer`](@ref), [`HessianTracer`](@ref) and [`Dual`](@ref).
"""
trace_input(::Type{T}, xs) where {T <: Union{AbstractTracer, Dual}} = trace_input(T, xs, 1)

# If possible, this should call `similar` and have the function signature `A{T} -> A{Int}`.
# For some array types, this function signature isn't possible,
# e.g. on `Symmetric`, where symmetry doesn't hold for the index matrix.
allocate_index_matrix(A::AbstractArray) = similar(A, Int)
allocate_index_matrix(A::Symmetric) = Matrix{Int}(undef, size(A)...)

function trace_input(::Type{T}, xs::AbstractArray, i) where {T <: Union{AbstractTracer, Dual}}
    is = allocate_index_matrix(xs)
    is .= reshape(1:length(xs), size(xs)) .+ (i - 1)
    return create_tracers(T, xs, is)
end

function trace_input(::Type{T}, xs::Diagonal, i) where {T <: Union{AbstractTracer, Dual}}
    ts = create_tracers(T, diag(xs), diagind(xs))
    return Diagonal(ts)
end

function trace_input(::Type{T}, x::Real, i::Integer) where {T <: Union{AbstractTracer, Dual}}
    return only(create_tracers(T, [x], [i]))
end

#=========================#
# Trace through functions #
#=========================#

function trace_function(::Type{T}, f, x) where {T <: Union{AbstractTracer, Dual}}
    xt = trace_input(T, x)
    yt = f(xt)
    return xt, yt
end

function trace_function(::Type{T}, f!, y, x) where {T <: AbstractTracer}
    xt = trace_input(T, x)
    yt = similar(y, T)
    fill!(yt, myempty(T))
    f!(yt, xt)
    return xt, yt
end

function trace_function(::Type{D}, f!, y, x) where {P, T <: AbstractTracer, D <: Dual{P, T}}
    t = myempty(T)
    xt = trace_input(D, x)
    yt = Dual.(y, t)
    f!(yt, xt)
    return xt, yt
end

to_array(x::Real) = [x]
to_array(x::AbstractArray) = x

#==========#
# Jacobian #
#==========#

# Compute the sparsity pattern of the Jacobian of `y = f(x)`.
function _jacobian_sparsity(
        f, x, ::Type{T} = DEFAULT_GRADIENT_TRACER
    ) where {T <: GradientTracer}
    xt, yt = trace_function(T, f, x)
    return jacobian_tracers_to_matrix(to_array(xt), to_array(yt))
end

# Compute the sparsity pattern of the Jacobian of `f!(y, x)`.
function _jacobian_sparsity(
        f!, y, x, ::Type{T} = DEFAULT_GRADIENT_TRACER
    ) where {T <: GradientTracer}
    xt, yt = trace_function(T, f!, y, x)
    return jacobian_tracers_to_matrix(to_array(xt), to_array(yt))
end

# Compute the local sparsity pattern of the Jacobian of `y = f(x)` at `x`.
function _local_jacobian_sparsity(
        f, x, ::Type{T} = DEFAULT_GRADIENT_TRACER
    ) where {T <: GradientTracer}
    D = Dual{eltype(x), T}
    xt, yt = trace_function(D, f, x)
    return jacobian_tracers_to_matrix(to_array(xt), to_array(yt))
end

# Compute the local sparsity pattern of the Jacobian of `f!(y, x)` at `x`.
function _local_jacobian_sparsity(
        f!, y, x, ::Type{T} = DEFAULT_GRADIENT_TRACER
    ) where {T <: GradientTracer}
    D = Dual{eltype(x), T}
    xt, yt = trace_function(D, f!, y, x)
    return jacobian_tracers_to_matrix(to_array(xt), to_array(yt))
end

#=========#
# Hessian #
#=========#

# Compute the sparsity pattern of the Hessian of a scalar function `y = f(x)`.
function _hessian_sparsity(f, x, ::Type{T} = DEFAULT_HESSIAN_TRACER) where {T <: HessianTracer}
    xt, yt = trace_function(T, f, x)
    return hessian_tracers_to_matrix(to_array(xt), yt)
end

# Compute the local sparsity pattern of the Hessian of a scalar function `y = f(x)` at `x`.
function _local_hessian_sparsity(
        f, x, ::Type{T} = DEFAULT_HESSIAN_TRACER
    ) where {T <: HessianTracer}
    D = Dual{eltype(x), T}
    xt, yt = trace_function(D, f, x)
    return hessian_tracers_to_matrix(to_array(xt), yt)
end

# GradientTracer & HessianTracer
for fn in (
        :iseven,
        :isfinite,
        :isinf,
        :isreal,
        :isinteger,
        :isnan,
        :isodd,
        :isone,
        :iszero,
    )
    @eval Base.$fn(t::AbstractTracer) = throw(MissingPrimalError($fn, t))
end

# Dual
for fn in (
        :iseven,
        :isfinite,
        :isinf,
        :isinteger,
        :isnan,
        :isodd,
        :isone,
        :iszero,
    )
    @eval Base.$fn(d::Dual) = $fn(primal(d))
end

SCT = SparseConnectivityTracer

## 1-to-1

function gradient_tracer_1_to_1(t::T, is_der1_zero::Bool) where {T <: GradientTracer}
    if is_der1_zero && !isemptytracer(t)
        return myempty(T)
    else
        return t
    end
end

# This is only required because it is called by HessianTracer
function gradient_tracer_1_to_1_inner(
        s::S, is_der1_zero::Bool
    ) where {S <: AbstractSet{<:Integer}}
    if is_der1_zero
        return myempty(S)
    else
        return s # return set
    end
end

function generate_code_gradient_1_to_1(M::Symbol, f::Function)
    fname = nameof(f)
    is_der1_zero_g = is_der1_zero_global(f)

    expr_gradienttracer = quote
        function $M.$fname(t::$SCT.GradientTracer)
            return @noinline $SCT.gradient_tracer_1_to_1(t, $is_der1_zero_g)
        end
    end

    expr_dual = if is_der1_zero_g
        quote
            function $M.$fname(d::D) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(d)
                return $M.$fname(x)
            end
        end
    else
        quote
            function $M.$fname(d::D) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(d)
                p_out = $M.$fname(x)

                t = $SCT.tracer(d)
                is_der1_zero = $SCT.is_der1_zero_local($M.$fname, x)
                t_out = @noinline $SCT.gradient_tracer_1_to_1(t, is_der1_zero)
                return $SCT.Dual(p_out, t_out)
            end
        end
    end
    return Expr(:block, expr_gradienttracer, expr_dual)
end

## 2-to-1

function gradient_tracer_2_to_1(
        tx::T, ty::T, is_der1_arg1_zero::Bool, is_der1_arg2_zero::Bool
    ) where {T <: GradientTracer}
    # TODO: add tests for isempty
    if tx.isempty && ty.isempty
        return tx # empty tracer
    elseif ty.isempty
        return gradient_tracer_1_to_1(tx, is_der1_arg1_zero)
    elseif tx.isempty
        return gradient_tracer_1_to_1(ty, is_der1_arg2_zero)
    else
        g_out = gradient_tracer_2_to_1_inner(
            gradient(tx), gradient(ty), is_der1_arg1_zero, is_der1_arg2_zero
        )
        return T(g_out) # return tracer
    end
end

# This is only required because it is called by HessianTracer overloads.
# Otherwise, we would just have the method above.
function gradient_tracer_2_to_1_inner(
        sx::S, sy::S, is_der1_arg1_zero::Bool, is_der1_arg2_zero::Bool
    ) where {S <: AbstractSet{<:Integer}}
    if is_der1_arg1_zero && is_der1_arg2_zero
        return myempty(S)
    elseif !is_der1_arg1_zero && is_der1_arg2_zero
        return sx
    elseif is_der1_arg1_zero && !is_der1_arg2_zero
        return sy
    else
        return union(sx, sy) # return set
    end
end

function generate_code_gradient_2_to_1(M::Symbol, f::Function)
    fname = nameof(f)
    is_der1_arg1_zero_g = is_der1_arg1_zero_global(f)
    is_der1_arg2_zero_g = is_der1_arg2_zero_global(f)

    expr_tracer_tracer = quote
        function $M.$fname(tx::T, ty::T) where {T <: $SCT.GradientTracer}
            return @noinline $SCT.gradient_tracer_2_to_1(
                tx, ty, $is_der1_arg1_zero_g, $is_der1_arg2_zero_g
            )
        end
    end

    expr_dual_dual = if is_der1_arg1_zero_g && is_der1_arg2_zero_g
        quote
            function $M.$fname(dx::D, dy::D) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(dx)
                y = $SCT.primal(dy)
                return $M.$fname(x, y)
            end
        end
    else
        quote
            function $M.$fname(dx::D, dy::D) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(dx)
                y = $SCT.primal(dy)
                p_out = $M.$fname(x, y)

                tx = $SCT.tracer(dx)
                ty = $SCT.tracer(dy)
                is_der1_arg1_zero = $SCT.is_der1_arg1_zero_local($M.$fname, x, y)
                is_der1_arg2_zero = $SCT.is_der1_arg2_zero_local($M.$fname, x, y)
                t_out = @noinline $SCT.gradient_tracer_2_to_1(
                    tx, ty, is_der1_arg1_zero, is_der1_arg2_zero
                )
                return $SCT.Dual(p_out, t_out)
            end
        end
    end

    exprs_typed = generate_code_gradient_2_to_1_typed(M, f, Real)
    return Expr(:block, expr_tracer_tracer, expr_dual_dual, exprs_typed)
end

function generate_code_gradient_2_to_1_typed(
        M::Symbol,   # Symbol indicating Module of f, usually `:Base`
        f::Function, # function to overload
        Z::Type,     # external non-tracer-type to overload on
    )
    fname = nameof(f)
    is_der1_arg1_zero_g = is_der1_arg1_zero_global(f)
    is_der1_arg2_zero_g = is_der1_arg2_zero_global(f)

    expr_tracer_type = quote
        function $M.$fname(tx::$SCT.GradientTracer, y::$Z)
            return @noinline $SCT.gradient_tracer_1_to_1(tx, $is_der1_arg1_zero_g)
        end
    end
    expr_type_tracer = quote
        function $M.$fname(x::$Z, ty::$SCT.GradientTracer)
            return @noinline $SCT.gradient_tracer_1_to_1(ty, $is_der1_arg2_zero_g)
        end
    end

    expr_dual_type = if is_der1_arg1_zero_g
        quote
            function $M.$fname(dx::D, y::$Z) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(dx)
                return $M.$fname(x, y)
            end
        end
    else
        quote
            function $M.$fname(dx::D, y::$Z) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(dx)
                p_out = $M.$fname(x, y)

                tx = $SCT.tracer(dx)
                is_der1_arg1_zero = $SCT.is_der1_arg1_zero_local($M.$fname, x, y)
                t_out = @noinline $SCT.gradient_tracer_1_to_1(tx, is_der1_arg1_zero)
                return $SCT.Dual(p_out, t_out)
            end
        end
    end
    expr_type_dual = if is_der1_arg2_zero_g
        quote
            function $M.$fname(x::$Z, dy::D) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                y = $SCT.primal(dy)
                return $M.$fname(x, y)
            end
        end
    else
        quote
            function $M.$fname(x::$Z, dy::D) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                y = $SCT.primal(dy)
                p_out = $M.$fname(x, y)

                ty = $SCT.tracer(dy)
                is_der1_arg2_zero = $SCT.is_der1_arg2_zero_local($M.$fname, x, y)
                t_out = @noinline $SCT.gradient_tracer_1_to_1(ty, is_der1_arg2_zero)
                return $SCT.Dual(p_out, t_out)
            end
        end
    end
    return Expr(:block, expr_tracer_type, expr_type_tracer, expr_dual_type, expr_type_dual)
end

## 1-to-2

function gradient_tracer_1_to_2(
        t::T, is_der1_out1_zero::Bool, is_der1_out2_zero::Bool
    ) where {T <: GradientTracer}
    if isemptytracer(t) # TODO: add test
        return (t, t)
    else
        t_out1 = gradient_tracer_1_to_1(t, is_der1_out1_zero)
        t_out2 = gradient_tracer_1_to_1(t, is_der1_out2_zero)
        return (t_out1, t_out2)
    end
end

function generate_code_gradient_1_to_2(M::Symbol, f::Function)
    fname = nameof(f)
    is_der1_out1_zero_g = is_der1_out1_zero_global(f)
    is_der1_out2_zero_g = is_der1_out2_zero_global(f)

    expr_gradienttracer = quote
        function $M.$fname(t::$SCT.GradientTracer)
            return @noinline $SCT.gradient_tracer_1_to_2(
                t, $is_der1_out1_zero_g, $is_der1_out2_zero_g
            )
        end
    end

    expr_dual = if is_der1_out1_zero_g && is_der1_out2_zero_g
        quote
            function $M.$fname(d::D) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(d)
                return $M.$fname(x)
            end
        end
    else
        quote
            function $M.$fname(d::D) where {P, T <: $SCT.GradientTracer, D <: $SCT.Dual{P, T}}
                x = $SCT.primal(d)
                p_out1, p_out2 = $M.$fname(x)

                t = $SCT.tracer(d)
                is_der1_out2_zero = $SCT.is_der1_out2_zero_local($M.$fname, x)
                is_der1_out1_zero = $SCT.is_der1_out1_zero_local($M.$fname, x)
                t_out1, t_out2 = @noinline $SCT.gradient_tracer_1_to_2(
                    t, is_der1_out1_zero, is_der1_out2_zero
                )
                return ($SCT.Dual(p_out1, t_out1), $SCT.Dual(p_out2, t_out2))  # TODO: this was wrong, add test
            end
        end
    end

    return Expr(:block, expr_gradienttracer, expr_dual)
end

using ComponentArrays
using SparseConnectivityTracer
using Test

f(x::AbstractVector) = abs2.(x)
f_comp(x::ComponentVector) = ComponentVector(; a = abs2.(x.a), b = abs2.(x.b))

function f!(y::AbstractVector, x::AbstractVector)
    y .= abs2.(x)
    return y
end

function f_comp!(y::ComponentVector, x::ComponentVector)
    y.a .= abs2.(x.a)
    y.b .= abs2.(x.b)
    return y
end

x_comp = ComponentVector(; a = rand(2), b = rand(3))
y_comp = ComponentVector(; a = rand(2), b = rand(3))
x = Vector(x_comp)
y = Vector(y_comp)

@testset "$detector" for detector in
    (TracerSparsityDetector(), TracerLocalSparsityDetector())
    @test jacobian_sparsity(f_comp, x_comp, detector) == jacobian_sparsity(f, x, detector)
    @test jacobian_sparsity(f_comp!, similar(y_comp), x_comp, detector) ==
        jacobian_sparsity(f!, similar(y), x, detector)
    @test hessian_sparsity(sum ∘ f_comp, x_comp, detector) ==
        hessian_sparsity(sum ∘ f, x, detector)
end

module SparseConnectivityTracerNaNMathExt

import SparseConnectivityTracer as SCT
using NaNMath: NaNMath

## 1-to-1

# ops_1_to_1_s:
# x -> f  != 0
# ∂f/∂x   != 0
# ∂²f/∂x² != 0
ops_1_to_1_s = (
    NaNMath.sqrt,
    NaNMath.sin,
    NaNMath.cos,
    NaNMath.tan,
    NaNMath.asin,
    NaNMath.acos,
    NaNMath.acosh,
    NaNMath.atanh,
    NaNMath.log,
    NaNMath.log2,
    NaNMath.log10,
    NaNMath.log1p,
    NaNMath.lgamma,
)

for op in ops_1_to_1_s
    T = typeof(op)
    @eval SCT.is_der1_zero_global(::$T) = false
    @eval SCT.is_der2_zero_global(::$T) = false
end

ops_1_to_1 = ops_1_to_1_s

## 2-to-1

# ops_2_to_1_ssc:
# ∂f/∂x    != 0
# ∂²f/∂x²  != 0
# ∂f/∂y    != 0
# ∂²f/∂y²  != 0
# ∂²f/∂x∂y != 0
ops_2_to_1_ssc = (NaNMath.pow,)

for op in ops_2_to_1_ssc
    T = typeof(op)
    @eval SCT.is_der1_arg1_zero_global(::$T) = false
    @eval SCT.is_der2_arg1_zero_global(::$T) = false
    @eval SCT.is_der1_arg2_zero_global(::$T) = false
    @eval SCT.is_der2_arg2_zero_global(::$T) = false
    @eval SCT.is_der_cross_zero_global(::$T) = false
end

# ops_2_to_1_ffz:
# ∂f/∂x    != 0
# ∂²f/∂x²  == 0
# ∂f/∂y    != 0
# ∂²f/∂y²  == 0
# ∂²f/∂x∂y == 0
ops_2_to_1_ffz = (NaNMath.max, NaNMath.min)

for op in ops_2_to_1_ffz
    T = typeof(op)
    @eval SCT.is_der1_arg1_zero_global(::$T) = false
    @eval SCT.is_der2_arg1_zero_global(::$T) = true
    @eval SCT.is_der1_arg2_zero_global(::$T) = false
    @eval SCT.is_der2_arg2_zero_global(::$T) = true
    @eval SCT.is_der_cross_zero_global(::$T) = true
end

SCT.is_der1_arg1_zero_local(::typeof(NaNMath.max), x, y) = x < y
SCT.is_der1_arg2_zero_local(::typeof(NaNMath.max), x, y) = y < x

SCT.is_der1_arg1_zero_local(::typeof(NaNMath.min), x, y) = x > y
SCT.is_der1_arg2_zero_local(::typeof(NaNMath.min), x, y) = y > x

ops_2_to_1 = union(ops_2_to_1_ssc, ops_2_to_1_ffz)

## Overloads
eval(SCT.generate_code_1_to_1(:NaNMath, ops_1_to_1))
eval(SCT.generate_code_2_to_1(:NaNMath, ops_2_to_1))

## Special overloads to avoid ambiguity errors
eval(SCT.generate_code_2_to_1_typed(:NaNMath, NaNMath.pow, Integer))

## List operators for later testing
SCT.test_operators_1_to_1(::Val{:NaNMath}) = ops_1_to_1
SCT.test_operators_2_to_1(::Val{:NaNMath}) = ops_2_to_1
SCT.test_operators_1_to_2(::Val{:NaNMath}) = ()

end # module

# [How SparseConnectivityTracer works](@id how-sct-works)

!!! tip "Read the paper"
    Please read our TMLR paper describing SparseConnectivityTracer:
    [*Sparser, Better, Faster, Stronger: Efficient Automatic Differentiation for Sparse Jacobians and Hessians*](https://openreview.net/forum?id=GtXSN52nIW).

!!! danger "Internals may change"
    The developer documentation might refer to internals which can change without warning in a future release of SparseConnectivityTracer.
    Only functionality that is exported or part of the [user documentation](@ref api) adheres to semantic versioning.

## Tracers are scalars

SparseConnectivityTracer (SCT) works by pushing `Real` number types called tracers through generic functions using operator overloading.
Currently, two tracer types are provided:

* [`GradientTracer`](@ref SparseConnectivityTracer.GradientTracer): used for Jacobian sparsity patterns
* [`HessianTracer`](@ref SparseConnectivityTracer.HessianTracer): used for Hessian sparsity patterns

When used alone, these tracers compute [**global** sparsity patterns](@ref TracerSparsityDetector).
Alternatively, these can be used inside of a dual number type [`Dual`](@ref SparseConnectivityTracer.Dual), 
which keeps track of the primal computation and allows tracing through comparisons and control flow.
This is how [**local** sparsity patterns](@ref TracerLocalSparsityDetector) are computed.

!!! tip "Tip: View SparseConnectivityTracer as binary ForwardDiff"
     SparseConnectivityTracer's `Dual{T, GradientTracer}` can be thought of as a binary version of [ForwardDiff](https://github.com/JuliaDiff/ForwardDiff.jl)'s own `Dual` number type.
     This is a good mental model for SparseConnectivityTracer if you are familiar with ForwardDiff and its limitations.

## Index sets

Let's take a look at a scalar function $f: \mathbb{R}^n \rightarrow \mathbb{R}$.
For a given input $\mathbf{x} \in \mathbb{R}^n$, 
the gradient of $f$ is defined as $\left(\nabla f(\mathbf{x})\right)_{i} = \frac{\partial f}{\partial x_i}$ 
and the Hessian as $\left(\nabla^2 f(\mathbf{x})\right)_{i,j} = \frac{\partial^2 f}{\partial x_i \partial x_j}$. 

Sparsity patterns correspond to the mask of non-zero values in the gradient and Hessian.
Instead of saving the values of individual partial derivatives, they can efficiently be represented by the set of indices corresponding to non-zero values:

* Gradient patterns are represented by sets of indices $\left\{i \;\big|\; \frac{\partial f}{\partial x_i} \neq 0\right\}$
* Hessian patterns are represented by sets of index tuples $\left\{(i, j) \;\Big|\; \frac{\partial^2 f}{\partial x_i \partial x_j} \neq 0\right\}$

!!! warning "Global vs. Local"
    As shown in the page [*"Global vs. Local"*](@ref global-vs-local),
    global sparsity patterns are the index sets over all $\mathbf{x}\in\mathbb{R}^n$,
    whereas local patterns are the index sets for a given point $\mathbf{x}$.
    For a given function $f$, global sparsity patterns are therefore always supersets of local sparsity patterns 
    and more "conservative" in the sense that they are less sparse. 

## Motivating example

Let's take a look at the computational graph of the equation $f(\mathbf{x}) = x_1 + x_2x_3 + \text{sgn}(x_4)$,
where $\text{sgn}$ is the [sign function](https://en.wikipedia.org/wiki/Sign_function):

```mermaid
flowchart LR
    subgraph Inputs
    X1["$$x_1$$"]
    X2["$$x_2$$"]
    X3["$$x_3$$"]
    X4["$$x_4$$"]
    end

    PLUS((+))
    TIMES((*))
    SIGN((sgn))
    PLUS2((+))

    X1 --> |"{1}"| PLUS
    X2 --> |"{2}"| TIMES
    X3 --> |"{3}"| TIMES
    X4 --> |"{4}"| SIGN
    TIMES  --> |"{2,3}"| PLUS
    PLUS --> |"{1,2,3}"| PLUS2
    SIGN --> |"{}"| PLUS2

    PLUS2 --> |"{1,2,3}"| RES["$$y=f(x)$$"]
```
To obtain a sparsity pattern, each scalar input $x_i$ gets seeded with a corresponding singleton index set $\{i\}$ [^1]. 
Since addition and multiplication have non-zero derivatives with respect to both of their inputs, 
their outputs accumulate and propagate the index sets of their inputs (annotated on the edges of the graph above).
The sign function has zero derivatives for any input value. It therefore doesn't propagate the index set ${4}$ corresponding to the input $x_4$. Instead, it returns an empty set.

[^1]: $\frac{\partial x_i}{\partial x_j} \neq 0$ only holds for $i=j$

The resulting **global** gradient sparsity pattern $\left(\nabla f(\mathbf{x})\right)_{i} \neq 0$ for $i$ in $\{1, 2, 3\}$ matches the analytical gradient

```math 
\nabla f(\mathbf{x}) = \begin{bmatrix}
    \frac{\partial f}{\partial x_1} \\
    \frac{\partial f}{\partial x_2} \\
    \frac{\partial f}{\partial x_3} \\
    \frac{\partial f}{\partial x_4}
\end{bmatrix}
=
\begin{bmatrix}
    1 \\
    x_3 \\
    x_2 \\
    0
\end{bmatrix} \quad .
```

!!! tip "From Global to Local"
    Note that the **local** sparsity pattern could be more sparse in case $x_2$ and/or $x_3$ are zero.
    Computing such local sparsity patterns requires [`Dual`](@ref SparseConnectivityTracer.Dual) numbers with information about the primal computation. 
    These are used to evaluate the **local** differentiability of operations like multiplication.

## Toy implementation

As mentioned above, SCT uses operator overloading to keep track of index sets.
Let's start by implementing our own `MyGradientTracer` type:

```@example toytracer
struct MyGradientTracer
    indexset::Set
end
```

We can now overload operators from Julia Base using our type:

```@example toytracer
import Base: +, *, sign

Base.:+(a::MyGradientTracer, b::MyGradientTracer) = MyGradientTracer(union(a.indexset, b.indexset))
Base.:*(a::MyGradientTracer, b::MyGradientTracer) = MyGradientTracer(union(a.indexset, b.indexset))
Base.sign(x::MyGradientTracer) = MyGradientTracer(Set()) # return empty index set
```

Let's create a vector of tracers to represent our input and evaluate our function with it:

```@example toytracer
f(x) = x[1] + x[2]*x[3] * sign(x[4])

xtracer = [
    MyGradientTracer(Set(1)),
    MyGradientTracer(Set(2)),
    MyGradientTracer(Set(3)),
    MyGradientTracer(Set(4)),
]

ytracer = f(xtracer)
```

Compared to this toy implementation, SCT adds some utilities to automatically create `xtracer` and parse the output `ytracer` into a sparse matrix, which we will omit here.

[`jacobian_sparsity(f, x, TracerSparsityDetector())`](@ref TracerSparsityDetector) calls these three steps of (1) tracer creation, (2) function evaluation and (3) output parsing in sequence:

```@example toytracer
using SparseConnectivityTracer

x = rand(4)
jacobian_sparsity(f, x, TracerSparsityDetector())
```

## Tracing Jacobians

Our toy implementation above doesn't just work on scalar functions, but also on vector valued functions:

```@example toytracer
g(x) = [x[1], x[2]*x[3], x[1]+x[4]]
g(xtracer)
```

By stacking individual `MyGradientTracer`s row-wise, we obtain the sparsity pattern of the Jacobian of $g$

```math
J_g(\mathbf{x})=
\begin{pmatrix}
1 & 0 & 0 & 0 \\
0 & x_3 & x_2 & 0 \\
1 & 0 & 0 & 1
\end{pmatrix} \quad .
```

We obtain the same result using SCT's `jacobian_sparsity`:
```@example toytracer
jacobian_sparsity(g, x, TracerSparsityDetector())
```

## Tracing Hessians

In the sections above, we outlined how to implement our own [`GradientTracer`](@ref SparseConnectivityTracer.GradientTracer) from scratch.
[`HessianTracer`](@ref SparseConnectivityTracer.HessianTracer) use the same operator overloading approach but are a bit more involved as they contain two index sets: 
one for the gradient pattern and one for the Hessian pattern. 
These sets are updated based on whether the first- and second-order derivatives of an operator are zero or not.

!!! tip "To be published"
    Look forward to our upcoming publication of SparseConnectivityTracer, 
    where we will go into more detail on the implementation of `HessianTracer`!

# [Limitations](@id limitations)

## Sparsity patterns are conservative approximations

Sparsity patterns returned by SparseConnectivityTracer (SCT) can in some cases be overly conservative, meaning that they might contain "too many ones".
If you observe an overly conservative pattern, [please open a feature request](https://github.com/adrhill/SparseConnectivityTracer.jl/issues) so we know where to add more method overloads to increase the sparsity.

!!! warning "SCT's no-false-negatives policy"
    If you ever observe a sparsity pattern that contains too many zeros, we urge you to [open a bug report](https://github.com/adrhill/SparseConnectivityTracer.jl/issues)!

## Function must be composed of generic Julia functions

SCT can't trace through non-Julia code.
However, if you know the sparsity pattern of an external, non-Julia function,
you might be able to work around it by adding methods on SCT's tracer types.

## Function types must be generic

When computing the sparsity pattern of a function,
it must be written generically enough to accept numbers of type `T<:Real` as (or `AbstractArray{<:Real}`) as inputs.

!!! details "Example: Overly restrictive type annotations"
    Let's see this mistake in action:

    ```@example notgeneric
    using SparseConnectivityTracer
    detector = TracerSparsityDetector()

    relu_bad(x::AbstractFloat) = max(zero(x), x)

    f_bad(xs) = sum(relu_bad, xs)
    nothing # hide
    ```

    Since tracers and dual numbers are `Real` numbers and not `AbstractFloat`s,
    `relu_bad` throws a `MethodError`:

    ```@repl notgeneric
    xs = [1.0, -2.0, 3.0];

    f_bad(xs)

    jacobian_sparsity(f_bad, xs, detector)
    ```

    This is easily fixed by loosening type restrictions or adding an additional methods on `Real`:

    ```@example notgeneric
    relu_good(x) = max(zero(x), x)

    f_good(xs) = sum(relu_good, xs)
    nothing # hide
    ```

    ```@repl notgeneric
    jacobian_sparsity(f_good, xs, detector)
    ```

## Limited control flow

Only [`TracerLocalSparsityDetector`](@ref) supports comparison operators (`<`, `==`, ...), indicator functions (`iszero`, `iseven`, ...) and control flow.

[`TracerSparsityDetector`](@ref) does not support any boolean functions and control flow (with the exception of `ifelse`).
This might seem unintuitive but follows from our policy stated above: SCT guarantees conservative sparsity patterns.
Using an approach based on operator-overloading, this means that global sparsity detection isn't allowed to hit any branching code.
`ifelse` is the only exception, since it allows us to evaluate both branches.


!!! warning "Common control flow errors"
    By design, SCT will throw errors instead of returning wrong sparsity patterns. Common error messages include:

    ```julia
    ERROR: TypeError: non-boolean [tracer type] used in boolean context
    ```
    
    ```julia
    ERROR: Function [function] requires primal value(s).
    A dual-number tracer for local sparsity detection can be used via `TracerLocalSparsityDetector`.
    ```

!!! details "Why does TracerSparsityDetector not support control flow and comparisons?"
    Let us motivate the design decision above by a simple example function:

    ```@example ctrlflow
    function f(x)
        if x[1] > x[2]
            return x[1]
        else 
            return x[2]
        end
    end
    nothing # hide
    ```

    The desired **global** Jacobian sparsity pattern over the entire input domain $x \in \mathbb{R}^2$ is `[1 1]`. 
    Two **local** sparsity patterns are possible: 
    `[1 0]` for $\{x | x_1 > x_2\}$,
    `[0 1]` for $\{x | x_1 \le x_2\}$.

    The local sparsity patterns of [`TracerLocalSparsityDetector`](@ref) are easy to compute using operator overloading by using [dual numbers](@ref SparseConnectivityTracer.Dual) 
    which contain primal values on which we can evaluate comparisons like `>`:

    ```@example ctrlflow
    using SparseConnectivityTracer

    jacobian_sparsity(f, [2, 1], TracerLocalSparsityDetector())

    jacobian_sparsity(f, [1, 2], TracerLocalSparsityDetector())
    ```

    The global sparsity pattern is **impossible** to compute when code branches with an if-else condition, 
    since we can only ever hit one branch during run-time. 
    If we made comparisons like `>` return `true` or `false`, we'd get the local patterns `[1 0]` and `[0 1]` respectively. 
    But SCT's policy is to guarantee conservative sparsity patterns, which means that "false positives" (ones) are acceptable, but "false negatives" (zeros) are not.
    In my our opinion, the right thing to do here is to throw an error:

    ```@repl ctrlflow
    jacobian_sparsity(f, [1, 2], TracerSparsityDetector())
    ```

    In some cases, we can work around this by using `ifelse`.
    Since `ifelse` is a method, it can evaluate "both branches" and take a conservative union of both resulting sparsity patterns:

    ```@example ctrlflow
    f(x) = ifelse(x[1] > x[2], x[1], x[2])

    jacobian_sparsity(f, [1, 2], TracerSparsityDetector())
    ```

## [No guarantee of conservative global sparsity patterns on stateful code](@id stateful-code)

SCT can't guarantee correct, conservative global sparsity patterns on stateful functions `f(x)` whose output isn't fully determined by the input `x`.
We provide some common examples:

!!! details "Example: Stateful branching code"

    As motivated in the section above, global sparsity detection isn't allowed to hit any branching code.
    While SCT's overloads try to avoid branches by throwing errors, they can in some cases be entered by stateful functions.
    Let's look at a function whose output doesn't only depend on the input `x`, but also on an internal state (in this case a random number):

    ```@repl stateful
    using SparseConnectivityTracer

    f(x) = randn() > 0.5 ? x[1] : x[2];

    jacobian_sparsity(f, [1, 2], TracerSparsityDetector())
    ```

    SCT cannot return the correct global sparsity pattern `[1 1]` for this code.
    This issue can be circumvented by [adding an overload](@ref adding-overloads) on `f` that returns a conservative pattern.

!!! details "Example: Stateful mutable caches"

    Problems can also arise when statefulness is introduced via mutable caches.
    In this example, we assume a stateful function `f` whose output not only depends on the input `x`, but also on a mutable array defined outside of the function call:

    ```@repl stateful2
    using SparseConnectivityTracer, SparseArrays

    A_cache = sparse([2 0; 0 3])

    f(x) = A_cache * x;

    pattern1 = jacobian_sparsity(f, [1, 2], TracerSparsityDetector())
    ```

    #### Invalidation of global sparsity patterns 

    While this sparsity pattern is correct at the time of detection,
    it can be invalidated by mutating the array `A_cache`:

    ```@repl stateful2
    A_cache[1, 2] = 4;

    A_cache

    pattern2 = jacobian_sparsity(f, [1, 2], TracerSparsityDetector())
    ```

    With the wisdom of hindsight, `pattern1` can therefore be seen as "non-conservative".

    #### Exception: Dense arrays

    For dense caches of type `Array` (including `Matrix` and `Vector`), SCT tries to circumvent this issue by returning a conservative sparsity pattern
    *(note that this behavior could be changed in a future breaking release)*:

    ```@repl stateful2
    A_cache = [2 0; 0 3]

    pattern1 = jacobian_sparsity(f, [1, 2], TracerSparsityDetector())
    ```

    However, such guarantees can't be made for arbitrary cache types (like the `SparseMatrixCSC` above).
    

# [Adding Overloads](@id adding-overloads)

!!! danger "Internals may change"
    The developer documentation might refer to internals which can change without warning in a future release of SparseConnectivityTracer.
    Only functionality that is exported or part of the [user documentation](@ref api) adheres to semantic versioning.

Having read our guide [*"How SparseConnectivityTracer works"*](@ref how-sct-works), you might want to add your own methods on 
[`GradientTracer`](@ref SparseConnectivityTracer.GradientTracer), 
[`HessianTracer`](@ref SparseConnectivityTracer.HessianTracer) and
[`Dual`](@ref SparseConnectivityTracer.Dual)
to improve the performance of your functions or to work around some of SCT's [limitations](@ref limitations).

!!! warning "Don't overload manually"
    If you want to overload a function that takes `Real` arguments, 
    we recommend using SCT's code generation mechanism instead of manually adding methods. This page shows you how.

## Generated overloads

!!! tip "Copy one of our package extensions"
    The easiest way to add overloads is to copy one of our package extensions, [e.g. our NNlib extension](https://github.com/adrhill/SparseConnectivityTracer.jl/blob/main/ext/SparseConnectivityTracerNNlibExt.jl), and to modify it.
    Please upstream your additions by opening a pull request! We will help you out to get your feature merged.

### Operator classification

SCT currently supports three types of functions:

1. **1-to-1**: operators with one input and one output
2. **2-to-1**: operators with two inputs and one output
3. **1-to-2**: operators with one input and two outputs

Depending on the type of function you're dealing with, you will have to specify the way in which your function is differentiable:

| In | Out | Examples                 | Methods you need to implement                                                                                                              | 
|:--:|:---:|:-------------------------|:-------------------------------------------------------------------------------------------------------------------------------------------|
| 1  | 1   | `sin`, `cos`, `abs`      | `is_der1_zero_global`, `is_der2_zero_global`                                                                                               |
| 2  | 1   | `+`, `*`, `>`, `isequal` | `is_der1_arg1_zero_global`, `is_der2_arg1_zero_global`, `is_der1_arg2_zero_global`, `is_der2_arg2_zero_global`, `is_der_cross_zero_global` |
| 1  | 2   | `sincos`                 | `is_der1_out1_zero_global`, `is_der2_out1_zero_global`, `is_der1_out2_zero_global`, `is_der2_out2_zero_global`                             |


!!! details "Methods you have to implement for 1-to-1 operators"

    | Function                                   | Meaning                                                 |
    |:-------------------------------------------|:--------------------------------------------------------|
    | `is_der1_zero_global(::typeof(f)) = false` | $\frac{\partial f}{\partial x} \neq 0$ for some $x$     | 
    | `is_der2_zero_global(::typeof(f)) = false` | $\frac{\partial^2 f}{\partial x^2} \neq 0$ for some $x$ | 

    Optionally, to increase the sparsity of [`TracerLocalSparsityDetector`](@ref), you can additionally implement

    | Function                                     | Meaning                                                  |
    |:---------------------------------------------|:---------------------------------------------------------|
    | `is_der1_zero_local(::typeof(f), x) = false` | $\frac{\partial f}{\partial x} \neq 0$ for given $x$     | 
    | `is_der2_zero_local(::typeof(f), x) = false` | $\frac{\partial^2 f}{\partial x^2} \neq 0$ for given $x$ | 

    These fall back to 

    ```julia
    is_der1_zero_local(f::F, x) where {F} = is_der1_zero_global(f)
    is_der2_zero_local(f::F, x) where {F} = is_der2_zero_global(f)
    ```

!!! details "Methods you have to implement for 2-to-1 operators"

    | Function                                        | Meaning                                                            |
    |:------------------------------------------------|:-------------------------------------------------------------------|
    | `is_der1_arg1_zero_global(::typeof(f)) = false` | $\frac{\partial f}{\partial x} \neq 0$ for some $x,y$              | 
    | `is_der2_arg1_zero_global(::typeof(f)) = false` | $\frac{\partial^2 f}{\partial x^2} \neq 0$ for some $x,y$          | 
    | `is_der1_arg2_zero_global(::typeof(f)) = false` | $\frac{\partial f}{\partial y} \neq 0$ for some $x,y$              | 
    | `is_der2_arg2_zero_global(::typeof(f)) = false` | $\frac{\partial^2 f}{\partial y^2} \neq 0$ for some $x,y$          | 
    | `is_der_cross_zero_global(::typeof(f)) = false` | $\frac{\partial^2 f}{\partial x \partial y} \neq 0$ for some $x,y$ | 

    Optionally, to increase the sparsity of [`TracerLocalSparsityDetector`](@ref), you can additionally implement

    | Function                                             | Meaning                                                             |
    |:-----------------------------------------------------|:--------------------------------------------------------------------|
    | `is_der1_arg1_zero_local(::typeof(f), x, y) = false` | $\frac{\partial f}{\partial x} \neq 0$ for given $x,y$              | 
    | `is_der2_arg1_zero_local(::typeof(f), x, y) = false` | $\frac{\partial^2 f}{\partial x^2} \neq 0$ for given $x,y$          | 
    | `is_der1_arg2_zero_local(::typeof(f), x, y) = false` | $\frac{\partial f}{\partial x} \neq 0$ for given $x,y$              | 
    | `is_der2_arg2_zero_local(::typeof(f), x, y) = false` | $\frac{\partial^2 f}{\partial x^2} \neq 0$ for given $x,y$          | 
    | `is_der_cross_zero_local(::typeof(f), x, y) = false` | $\frac{\partial^2 f}{\partial x \partial y} \neq 0$ for given $x,y$ | 


    These fall back to 

    ```julia
    is_der1_arg1_zero_local(f::F, x, y) where {F} = is_der1_arg1_zero_global(f)
    is_der2_arg1_zero_local(f::F, x, y) where {F} = is_der2_arg1_zero_global(f)
    is_der1_arg2_zero_local(f::F, x, y) where {F} = is_der1_arg2_zero_global(f)
    is_der2_arg2_zero_local(f::F, x, y) where {F} = is_der2_arg2_zero_global(f)
    is_der_cross_zero_local(f::F, x, y) where {F} = is_der_cross_zero_global(f)
    ```

!!! details "Methods you have to implement for 1-to-2 operators"

    | Function                                       | Meaning                                                   |
    |:-----------------------------------------------|:----------------------------------------------------------|
    | `is_der1_out1_zero_local(::typeof(f)) = false` | $\frac{\partial f_1}{\partial x} \neq 0$ for some $x$     | 
    | `is_der2_out1_zero_local(::typeof(f)) = false` | $\frac{\partial^2 f_1}{\partial x^2} \neq 0$ for some $x$ | 
    | `is_der1_out2_zero_local(::typeof(f)) = false` | $\frac{\partial f_2}{\partial x} \neq 0$ for some $x$     | 
    | `is_der2_out2_zero_local(::typeof(f)) = false` | $\frac{\partial^2 f_2}{\partial x^2} \neq 0$ for some $x$ | 

    Optionally, to increase the sparsity of [`TracerLocalSparsityDetector`](@ref), you can additionally implement

    | Function                                          | Meaning                                                    |
    |:--------------------------------------------------|:-----------------------------------------------------------|
    | `is_der1_out1_zero_local(::typeof(f), x) = false` | $\frac{\partial f_1}{\partial x} \neq 0$ for given $x$     | 
    | `is_der2_out1_zero_local(::typeof(f), x) = false` | $\frac{\partial^2 f_1}{\partial x^2} \neq 0$ for given $x$ | 
    | `is_der1_out2_zero_local(::typeof(f), x) = false` | $\frac{\partial f_2}{\partial x} \neq 0$ for given $x$     | 
    | `is_der2_out2_zero_local(::typeof(f), x) = false` | $\frac{\partial^2 f_2}{\partial x^2} \neq 0$ for given $x$ | 

    These fall back to 

    ```julia
    is_der1_out1_zero_local(f::F, x) where {F} = is_der1_out1_zero_global(f)
    is_der2_out1_zero_local(f::F, x) where {F} = is_der2_out1_zero_global(f)
    is_der1_out2_zero_local(f::F, x) where {F} = is_der1_out2_zero_global(f)
    is_der2_out2_zero_local(f::F, x) where {F} = is_der2_out2_zero_global(f)
    ```

### [Generating code](@id code-gen)

After implementing the required classification methods for a function, the function has not been overloaded on our tracer types yet.
SCT provides three functions that generate code via meta-programming:

* 1-to-1: `eval(SCT.generate_code_1_to_1(module_symbol, f))`
* 2-to-1: `eval(SCT.generate_code_1_to_2(module_symbol, f))`
* 1-to-2: `eval(SCT.generate_code_2_to_1(module_symbol, f))`

You are required to call the function that matches your type of operator.

!!! tip "Code generation"
    We will take a look at the code generation mechanism in the example below.

### Example

For some examples on how to overload methods, take a look at our [package extensions](https://github.com/adrhill/SparseConnectivityTracer.jl/tree/main/ext).
Let's look at the `relu` activation function from `ext/SparseConnectivityTracerNNlibExt.jl`, which is a 1-to-1 operator defined as $\text{relu}(x) = \text{max}(0, x)$.

#### Step 1: Classification

The `relu` function has a non-zero first-order derivative $\frac{\partial f}{\partial x}=1$ for inputs $x>0$. 
The second derivative is zero everywhere.
We therefore implement:

```@example overload
import SparseConnectivityTracer as SCT
using NNlib

SCT.is_der1_zero_global(::typeof(relu)) = false
SCT.is_der2_zero_global(::typeof(relu)) = true

SCT.is_der1_zero_local(::typeof(relu), x) = x < 0
```

!!! warning "import SparseConnectivityTracer"
    Note that we imported SCT to extend its operator classification methods on `typeof(relu)`.

#### Step 2: Generating code

The `relu` function has not been overloaded on our tracer types yet.
Let's call the code generation utilities from the [*"Generating code"*](@ref code-gen) section for this purpose:

```@example overload
eval(SCT.generate_code_1_to_1(:NNlib, relu))
```

The `relu` function is now ready to be called with SCT's tracer types.

!!! details "What is the eval call doing?"
    Let's call `generate_code_1_to_1` without wrapping it `eval`:

    ```@example overload
    SCT.generate_code_1_to_1(:NNlib, relu)
    ```

    As you can see, this returns a `quote`, a type of expression containing our generated Julia code.

    **We have to use quotes:** 
    The code generation mechanism lives in SCT, but the generated code has to be evaluated in the package extension, not SCT.
    As you can see in the generated quote, we handle the necessary name-spacing for you.

## Manual overloads

As mentioned above, for functions that take `Real` arguments, manual overloads should generally be avoided.
If such an overload is necessary (e.g. for array inputs), it should follow the following design priciples, ordered by importance:

**Local sparsity detection (`Dual`):**

- Overloads must return conservative sparsity patterns (no false negatives) at the given input.
- Local tracers are allowed to enter branches in user code. User code can be stateful.
- `MethodError`s due to missing overloads can be avoided by returning a very conservative sparsity pattern.

**Global sparsity detection (`GradientTracer` and `HessianTracer`):**

- Overloads must return conservative sparsity patterns (no false negatives) over the entire input domain.
- Tracers must error instead of entering branches in user code. 
  This requires that overloaded functions return tracers instead of `Bool` (or numbers), 
  as the former are designed to error in comparisons.
- Overloads must ignore scalar values of non-tracer inputs.
  *(While not set in stone, changing this rule in the future would require a breaking release.)*
- Sparsity should be prioritized over performance. We assume global sparsity detection can be amortized.
- `MethodError`s due to missing overloads can be avoided by returning a very conservative sparsity pattern.

# [Performance](@id performance)

## Data structures for sparsity pattern representations

The most efficient internal data structure for sparsity pattern representations
depends on the number of inputs and the computational graph / sparsity of a given function.

Let's use a convolutional layer from Flux.jl as an example.
By default, SCT uses `BitSet` for Jacobian sparsity detection, which is well suited for small to medium sized functions.

```@example Flux
using SparseConnectivityTracer, Flux, BenchmarkTools

x = rand(28, 28, 3, 1)
layer = Conv((3, 3), 3 => 2)

detector_bitset = TracerSparsityDetector()
jacobian_sparsity(layer, x, detector_bitset)
```

```@example Flux
@benchmark jacobian_sparsity(layer, x, detector_bitset);
```

Instead of `BitSet`, we can use any concrete subtype of `AbstractSet{<:Integer}`, for example `Set{UInt}`.
To set the sparsity pattern type for Jacobian sparsity detection, we use the keyword argument `gradient_pattern_type`:

```@example Flux
detector_set = TracerSparsityDetector(; gradient_pattern_type=Set{UInt})
@benchmark jacobian_sparsity(layer, x, detector_set);
```

While this is slower for the given input size, the performance is highly dependant on the problem.
For larger inputs (e.g. of size $224 \times 224 \times 3 \times 1$), `detector_set` will outperform `detector_bitset`.
Note that memory requirement will vary as well.

For Hessians sparsity detection, the internal sparsity pattern representation uses either concrete subtypes of
`AbstractDict{I, AbstractSet{I}}` or `AbstractSet{Tuple{I, I}}`, where `I <: Integer`.
By default, `Dict{Int, BitSet)` is used.
To set the sparsity pattern type, use the keyword argument `hessian_pattern_type`:

```@example Flux
detector = TracerSparsityDetector(; hessian_pattern_type=Dict{UInt, Set{UInt}})
```

Data structures can also be set analogously for `TracerLocalSparsityDetector`.
If both Jacobian and Hessian sparsity patterns are needed, 
`gradient_pattern_type` and `hessian_pattern_type` can be set separately.

```@meta
CurrentModule = Main
CollapsedDocStrings = true
```

# [API Reference](@id api)

SparseConnectivityTracer uses [ADTypes.jl](https://github.com/SciML/ADTypes.jl)'s [interface for sparsity detection](https://sciml.github.io/ADTypes.jl/stable/#Sparsity-detector).
In fact, the functions `jacobian_sparsity` and `hessian_sparsity` are re-exported from ADTypes.

```@docs
ADTypes.jacobian_sparsity
ADTypes.hessian_sparsity
```

To compute **global** sparsity patterns of `f(x)` over the entire input domain `x`, use
```@docs
TracerSparsityDetector
```

To compute **local** sparsity patterns of `f(x)` at a specific input `x`, use
```@docs
TracerLocalSparsityDetector
```

## Memory allocation

For developers requiring the allocation of output buffers that support our tracers, we additionally provide
```@docs
jacobian_eltype
hessian_eltype
jacobian_buffer
hessian_buffer
```

Please note that the `DiffCache` from
[PreallocationTools.jl](https://github.com/SciML/PreallocationTools.jl)
can be used to make caches compatible with both
[ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl) and
[SparseConnectivityTracer.jl](https://github.com/adrhill/SparseConnectivityTracer.jl/).

# [Internals Reference](@id internal-api)

!!! danger "Internals may change"
    This part of the developer documentation **exclusively** refers to internals that may change without warning in a future release of SparseConnectivityTracer.
    Anything written on this page should be treated as if it was undocumented.
    Only functionality that is exported or part of the [user documentation](@ref api) adheres to semantic versioning.


```@index
```

## Tracer Types

```@docs
SparseConnectivityTracer.AbstractTracer
SparseConnectivityTracer.GradientTracer
SparseConnectivityTracer.HessianTracer
SparseConnectivityTracer.Dual
```

### Traits

```@docs
SparseConnectivityTracer.NotShared
SparseConnectivityTracer.Shared
SparseConnectivityTracer.shared
```

### Utilities

```@docs
SparseConnectivityTracer.gradient
SparseConnectivityTracer.hessian
SparseConnectivityTracer.myempty
```

# [Global vs. Local Sparsity](@id global-vs-local)

Let's motivate the difference between local and global sparsity patterns by taking a look at the function $f(\mathbf{x}) = x_1x_2$. 
The corresponding Jacobian is:

```math
J_f = \begin{bmatrix}
    \frac{\partial f}{\partial x_1} &
    \frac{\partial f}{\partial x_2}
\end{bmatrix}
=
\begin{bmatrix}
    x_2 & x_1
\end{bmatrix}
```

Depending on the values of $\mathbf{x}$, the resulting **local** Jacobian sparsity pattern could be either:
*  $[1\; 1]$ for $x_1 \neq 0$, $x_2 \neq 0$
*  $[1\; 0]$ for $x_1 = 0$, $x_2 \neq 0$
*  $[0\; 1]$ for $x_1 \neq 0$, $x_2 = 0$
*  $[0\; 0]$ for $x_1 = 0$, $x_2 = 0$

These are computed by [`TracerLocalSparsityDetector`](@ref):

```@repl localvsglobal
using SparseConnectivityTracer
detector = TracerLocalSparsityDetector();

f(x) = x[1]*x[2];

jacobian_sparsity(f, [1, 1], detector)
jacobian_sparsity(f, [0, 1], detector)
jacobian_sparsity(f, [1, 0], detector)
jacobian_sparsity(f, [0, 0], detector)
```

In contrast to this, [`TracerSparsityDetector`](@ref) computes a conservative union over all sparsity patterns in $\mathbf{x} \in \mathbb{R}^2$.
The resulting **global** pattern therefore does not depend on the input.
All of the following function calls are equivalent:

```@repl localvsglobal
detector = TracerSparsityDetector()

jacobian_sparsity(f, [1, 1], detector)
jacobian_sparsity(f, [0, 1], detector)
jacobian_sparsity(f, [1, 0], detector)
jacobian_sparsity(f, [0, 0], detector)
jacobian_sparsity(f, rand(2), detector)
```

!!! tip "Global vs. Local"
    Global sparsity patterns are the union of all local sparsity patterns over the entire input domain.
    For a given function, they are therefore always supersets of local sparsity patterns 
    and more "conservative" in the sense that they are less sparse.
